/*
This file was auto-generated by mupdfwrap.py.
*/


#include "mupdf/classes.h"
#include "mupdf/exceptions.h"
#include "mupdf/internal.h"

#include "mupdf/fitz/geometry.h"

#include <sstream>
#include <string.h>


namespace mupdf
{

/* Implementation of methods for AaContext (wrapper for fz_aa_context). */

FZ_FUNCTION AaContext::AaContext(const fz_aa_context* internal)
{
	this->hscale = internal->hscale;
	this->vscale = internal->vscale;
	this->scale = internal->scale;
	this->bits = internal->bits;
	this->text_bits = internal->text_bits;
	this->min_line_width = internal->min_line_width;
}

FZ_FUNCTION AaContext::AaContext(const fz_aa_context internal)
{
	this->hscale = internal.hscale;
	this->vscale = internal.vscale;
	this->scale = internal.scale;
	this->bits = internal.bits;
	this->text_bits = internal.text_bits;
	this->min_line_width = internal.min_line_width;
}

/* Constructor using raw copy of pre-existing fz_aa_context. */
FZ_FUNCTION fz_aa_context* AaContext::internal()
{
	return (fz_aa_context*) &this->hscale;
}

/* Constructor using raw copy of pre-existing fz_aa_context. */
FZ_FUNCTION const fz_aa_context* AaContext::internal() const
{
	return (const fz_aa_context*) &this->hscale;
}

FZ_FUNCTION std::string AaContext::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const AaContext& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Aes (wrapper for fz_aes). */

/* Wrapper for fz_aes_crypt_cbc(). */
FZ_FUNCTION void Aes::aes_crypt_cbc(int mode, size_t length, unsigned char iv[16], const unsigned char *input, unsigned char *output)
{
	return mupdf::aes_crypt_cbc(this->m_internal, mode, length, iv, input, output);
}

/* Wrapper for fz_aes_setkey_dec(). */
FZ_FUNCTION int Aes::aes_setkey_dec(const unsigned char *key, int keysize)
{
	return mupdf::aes_setkey_dec(this->m_internal, key, keysize);
}

/* Wrapper for fz_aes_setkey_enc(). */
FZ_FUNCTION int Aes::aes_setkey_enc(const unsigned char *key, int keysize)
{
	return mupdf::aes_setkey_enc(this->m_internal, key, keysize);
}

FZ_FUNCTION Aes::Aes(fz_aes* internal)
: m_internal(internal)
{
}


/* Implementation of methods for AllocContext (wrapper for fz_alloc_context). */

/* Wrapper for fz_new_context_imp(). */
FZ_FUNCTION Context AllocContext::new_context_imp(const LocksContext& locks, size_t max_store, const char *version)
{
	fz_context* temp = mupdf::new_context_imp(this->m_internal, locks.m_internal, max_store, version);
	return Context(temp);
}

FZ_FUNCTION AllocContext::AllocContext(fz_alloc_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Arc4 (wrapper for fz_arc4). */

/* Wrapper for fz_arc4_encrypt(). */
FZ_FUNCTION void Arc4::arc4_encrypt(unsigned char *dest, const unsigned char *src, size_t len)
{
	return mupdf::arc4_encrypt(this->m_internal, dest, src, len);
}

/* Wrapper for fz_arc4_init(). */
FZ_FUNCTION void Arc4::arc4_init(const unsigned char *key, size_t len)
{
	return mupdf::arc4_init(this->m_internal, key, len);
}

FZ_FUNCTION Arc4::Arc4(fz_arc4* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Archive (wrapper for fz_archive). */

/* Constructor using fz_new_archive_of_size(). */
FZ_FUNCTION Archive::Archive(const Stream& file, int size)
{
	this->m_internal = mupdf::new_archive_of_size(file.m_internal, size);
}

/* Wrapper for fz_archive_format(). */
FZ_FUNCTION const char *Archive::archive_format()
{
	return mupdf::archive_format(this->m_internal);
}

/* Wrapper for fz_count_archive_entries(). */
FZ_FUNCTION int Archive::count_archive_entries()
{
	return mupdf::count_archive_entries(this->m_internal);
}

/* Wrapper for fz_has_archive_entry(). */
FZ_FUNCTION int Archive::has_archive_entry(const char *name)
{
	return mupdf::has_archive_entry(this->m_internal, name);
}

/* Wrapper for fz_list_archive_entry(). */
FZ_FUNCTION const char *Archive::list_archive_entry(int idx)
{
	return mupdf::list_archive_entry(this->m_internal, idx);
}

/* Wrapper for fz_open_archive_entry(). */
FZ_FUNCTION Stream Archive::open_archive_entry(const char *name)
{
	fz_stream* temp = mupdf::open_archive_entry(this->m_internal, name);
	return Stream(temp);
}

/* Wrapper for fz_read_archive_entry(). */
FZ_FUNCTION Buffer Archive::read_archive_entry(const char *name)
{
	fz_buffer* temp = mupdf::read_archive_entry(this->m_internal, name);
	return Buffer(temp);
}

FZ_FUNCTION Archive::Archive(fz_archive* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Archive::~Archive()
{
	mupdf::drop_archive(m_internal);
}


/* Implementation of methods for BandWriter (wrapper for fz_band_writer). */

/* Constructor using fz_new_band_writer_of_size(). */
FZ_FUNCTION BandWriter::BandWriter(size_t size, const Output& out)
{
	this->m_internal = mupdf::new_band_writer_of_size(size, out.m_internal);
}

/* Constructor using fz_new_color_pcl_band_writer(). */
/* Disabled because same args as fz_new_mono_pcl_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out, const PclOptions& options)
{
	this->m_internal = mupdf::new_color_pcl_band_writer(out.m_internal, options.m_internal);
}

*/
/* Constructor using fz_new_mono_pcl_band_writer(). */
FZ_FUNCTION BandWriter::BandWriter(const Output& out, const PclOptions& options)
{
	this->m_internal = mupdf::new_mono_pcl_band_writer(out.m_internal, options.m_internal);
}

/* Constructor using fz_new_mono_pwg_band_writer(). */
FZ_FUNCTION BandWriter::BandWriter(const Output& out, PwgOptions& pwg)
{
	this->m_internal = mupdf::new_mono_pwg_band_writer(out.m_internal, &pwg.m_internal);
}

/* Constructor using fz_new_pam_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_pam_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_pbm_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_pbm_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_pclm_band_writer(). */
FZ_FUNCTION BandWriter::BandWriter(const Output& out, const PclmOptions& options)
{
	this->m_internal = mupdf::new_pclm_band_writer(out.m_internal, options.m_internal);
}

/* Constructor using fz_new_pdfocr_band_writer(). */
FZ_FUNCTION BandWriter::BandWriter(const Output& out, const PdfocrOptions& options)
{
	this->m_internal = mupdf::new_pdfocr_band_writer(out.m_internal, options.m_internal);
}

/* Constructor using fz_new_pkm_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_pkm_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_png_band_writer(). */
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_png_band_writer(out.m_internal);
}

/* Constructor using fz_new_pnm_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_pnm_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_ps_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_ps_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_psd_band_writer(). */
/* Disabled because same args as fz_new_png_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out)
{
	this->m_internal = mupdf::new_psd_band_writer(out.m_internal);
}

*/
/* Constructor using fz_new_pwg_band_writer(). */
/* Disabled because same args as fz_new_mono_pwg_band_writer.
FZ_FUNCTION BandWriter::BandWriter(const Output& out, PwgOptions& pwg)
{
	this->m_internal = mupdf::new_pwg_band_writer(out.m_internal, &pwg.m_internal);
}

*/
/* Custom constructor. */
FZ_FUNCTION BandWriter::BandWriter(Output& out, Cm cm, const PclOptions& options)
{
	fz_output*              out2 = out.m_internal;
	const fz_pcl_options*   options2 = options.m_internal;
	if (0)  {}
	else if (cm == MONO)    m_internal = mupdf::new_mono_pcl_band_writer( out2, options2);
	else if (cm == COLOR)   m_internal = mupdf::new_color_pcl_band_writer( out2, options2);
	else throw std::runtime_error( "Unrecognised fz_band_writer_s Cm type");
}

/* Custom constructor. */
FZ_FUNCTION BandWriter::BandWriter(Output& out, P p)
{
	fz_output*              out2 = out.m_internal;
	if (0)  {}
	else if (p == PNG)  m_internal = mupdf::new_png_band_writer( out2);
	else if (p == PNM)  m_internal = mupdf::new_pnm_band_writer( out2);
	else if (p == PAM)  m_internal = mupdf::new_pam_band_writer( out2);
	else if (p == PBM)  m_internal = mupdf::new_pbm_band_writer( out2);
	else if (p == PKM)  m_internal = mupdf::new_pkm_band_writer( out2);
	else if (p == PS)   m_internal = mupdf::new_ps_band_writer( out2);
	else if (p == PSD)  m_internal = mupdf::new_psd_band_writer( out2);
	else throw std::runtime_error( "Unrecognised fz_band_writer_s P type");
}

/* Custom constructor. */
FZ_FUNCTION BandWriter::BandWriter(Output& out, Cm cm, const PwgOptions& options)
{
	fz_output*              out2 = out.m_internal;
	const fz_pwg_options*   options2 = &options.m_internal;
	if (0)  {}
	else if (cm == MONO)    m_internal = mupdf::new_mono_pwg_band_writer( out2, options2);
	else if (cm == COLOR)   m_internal = mupdf::new_pwg_band_writer( out2, options2);
	else throw std::runtime_error( "Unrecognised fz_band_writer_s Cm type");
}

/* Wrapper for fz_pdfocr_band_writer_set_progress(). */
FZ_FUNCTION void BandWriter::pdfocr_band_writer_set_progress(int (*progress)(fz_context *, void *, int ), void *progress_arg)
{
	return mupdf::pdfocr_band_writer_set_progress(this->m_internal, progress, progress_arg);
}

/* Wrapper for fz_write_band(). */
FZ_FUNCTION void BandWriter::write_band(int stride, int band_height, const unsigned char *samples)
{
	return mupdf::write_band(this->m_internal, stride, band_height, samples);
}

/* Wrapper for fz_write_header(). */
FZ_FUNCTION void BandWriter::write_header(int w, int h, int n, int alpha, int xres, int yres, int pagenum, const Colorspace& cs, const Separations& seps)
{
	return mupdf::write_header(this->m_internal, w, h, n, alpha, xres, yres, pagenum, cs.m_internal, seps.m_internal);
}

FZ_FUNCTION BandWriter::BandWriter(fz_band_writer* internal)
: m_internal(internal)
{
}

FZ_FUNCTION BandWriter::~BandWriter()
{
	mupdf::drop_band_writer(m_internal);
}


/* Implementation of methods for Bitmap (wrapper for fz_bitmap). */

/* Constructor using fz_new_bitmap(). */
FZ_FUNCTION Bitmap::Bitmap(int w, int h, int n, int xres, int yres)
{
	this->m_internal = mupdf::new_bitmap(w, h, n, xres, yres);
}

/* Constructor using fz_new_bitmap_from_pixmap(). */
FZ_FUNCTION Bitmap::Bitmap(const Pixmap& pix, const Halftone& ht)
{
	this->m_internal = mupdf::new_bitmap_from_pixmap(pix.m_internal, ht.m_internal);
}

/* Constructor using fz_new_bitmap_from_pixmap_band(). */
FZ_FUNCTION Bitmap::Bitmap(const Pixmap& pix, const Halftone& ht, int band_start)
{
	this->m_internal = mupdf::new_bitmap_from_pixmap_band(pix.m_internal, ht.m_internal, band_start);
}

/* Copy constructor using fz_keep_bitmap(). */
FZ_FUNCTION Bitmap::Bitmap(const Bitmap& rhs)
: m_internal(mupdf::keep_bitmap(rhs.m_internal))
{
}

/* operator= using fz_keep_bitmap() and fz_drop_bitmap(). */
FZ_FUNCTION Bitmap& Bitmap::operator=(const Bitmap& rhs)
{
	mupdf::drop_bitmap(this->m_internal);
	mupdf::keep_bitmap(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_bitmap_details(). */
FZ_FUNCTION void Bitmap::bitmap_details(int *w, int *h, int *n, int *stride)
{
	return mupdf::bitmap_details(this->m_internal, w, h, n, stride);
}

/* Wrapper for fz_clear_bitmap(). */
FZ_FUNCTION void Bitmap::clear_bitmap()
{
	return mupdf::clear_bitmap(this->m_internal);
}

/* Wrapper for fz_save_bitmap_as_pbm(). */
FZ_FUNCTION void Bitmap::save_bitmap_as_pbm(const char *filename)
{
	return mupdf::save_bitmap_as_pbm(this->m_internal, filename);
}

/* Wrapper for fz_save_bitmap_as_pcl(). */
FZ_FUNCTION void Bitmap::save_bitmap_as_pcl(char *filename, int append, const PclOptions& pcl)
{
	return mupdf::save_bitmap_as_pcl(this->m_internal, filename, append, pcl.m_internal);
}

/* Wrapper for fz_save_bitmap_as_pkm(). */
FZ_FUNCTION void Bitmap::save_bitmap_as_pkm(const char *filename)
{
	return mupdf::save_bitmap_as_pkm(this->m_internal, filename);
}

/* Wrapper for fz_save_bitmap_as_pwg(). */
FZ_FUNCTION void Bitmap::save_bitmap_as_pwg(char *filename, int append, PwgOptions& pwg)
{
	return mupdf::save_bitmap_as_pwg(this->m_internal, filename, append, &pwg.m_internal);
}

FZ_FUNCTION Bitmap::Bitmap(fz_bitmap* internal)
: m_internal(internal)
{
}

FZ_FUNCTION int Bitmap::refs()
{
	return m_internal->refs;
}

FZ_FUNCTION int Bitmap::w()
{
	return m_internal->w;
}

FZ_FUNCTION int Bitmap::h()
{
	return m_internal->h;
}

FZ_FUNCTION int Bitmap::stride()
{
	return m_internal->stride;
}

FZ_FUNCTION int Bitmap::n()
{
	return m_internal->n;
}

FZ_FUNCTION int Bitmap::xres()
{
	return m_internal->xres;
}

FZ_FUNCTION int Bitmap::yres()
{
	return m_internal->yres;
}

FZ_FUNCTION const unsigned char *Bitmap::samples()
{
	return m_internal->samples;
}

FZ_FUNCTION Bitmap::~Bitmap()
{
	mupdf::drop_bitmap(m_internal);
}


/* Implementation of methods for Buffer (wrapper for fz_buffer). */

/* Constructor using fz_new_buffer(). */
FZ_FUNCTION Buffer::Buffer(size_t capacity)
{
	this->m_internal = mupdf::new_buffer(capacity);
}

/* Constructor using fz_new_buffer_from_base64(). */
FZ_FUNCTION Buffer::Buffer(const char *data, size_t size)
{
	this->m_internal = mupdf::new_buffer_from_base64(data, size);
}

/* Constructor using fz_new_buffer_from_data(). */
FZ_FUNCTION Buffer::Buffer(unsigned char *data, size_t size)
{
	this->m_internal = mupdf::new_buffer_from_data(data, size);
}

/* Constructor using fz_new_buffer_from_display_list(). */
FZ_FUNCTION Buffer::Buffer(const DisplayList& list, StextOptions& options)
{
	this->m_internal = mupdf::new_buffer_from_display_list(list.m_internal, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_buffer_from_image_as_png(). */
FZ_FUNCTION Buffer::Buffer(const Image& image, ColorParams& color_params)
{
	this->m_internal = mupdf::new_buffer_from_image_as_png(image.m_internal, *(fz_color_params*) &color_params.ri);
}

/* Constructor using fz_new_buffer_from_page(). */
FZ_FUNCTION Buffer::Buffer(const Page& page, StextOptions& options)
{
	this->m_internal = mupdf::new_buffer_from_page(page.m_internal, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_buffer_from_page_number(). */
FZ_FUNCTION Buffer::Buffer(const Document& doc, int number, StextOptions& options)
{
	this->m_internal = mupdf::new_buffer_from_page_number(doc.m_internal, number, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_buffer_from_page_with_format(). */
FZ_FUNCTION Buffer::Buffer(const Page& page, const char *format, const char *options, Matrix& transform, Cookie& cookie)
{
	this->m_internal = mupdf::new_buffer_from_page_with_format(page.m_internal, format, options, *(fz_matrix*) &transform.a, &cookie.m_internal);
}

/* Constructor using fz_new_buffer_from_pixmap_as_png(). */
FZ_FUNCTION Buffer::Buffer(const Pixmap& pixmap, ColorParams& color_params)
{
	this->m_internal = mupdf::new_buffer_from_pixmap_as_png(pixmap.m_internal, *(fz_color_params*) &color_params.ri);
}

/* Constructor using fz_new_buffer_from_shared_data(). */
FZ_FUNCTION Buffer::Buffer(const unsigned char *data, size_t size)
{
	this->m_internal = mupdf::new_buffer_from_shared_data(data, size);
}

/* Constructor using fz_new_buffer_from_stext_page(). */
FZ_FUNCTION Buffer::Buffer(const StextPage& text)
{
	this->m_internal = mupdf::new_buffer_from_stext_page(text.m_internal);
}

/* Constructor using fz_read_file(). */
FZ_FUNCTION Buffer::Buffer(const char *filename)
{
	this->m_internal = mupdf::read_file(filename);
}

/* Copy constructor using fz_keep_buffer(). */
FZ_FUNCTION Buffer::Buffer(const Buffer& rhs)
: m_internal(mupdf::keep_buffer(rhs.m_internal))
{
}

/* operator= using fz_keep_buffer() and fz_drop_buffer(). */
FZ_FUNCTION Buffer& Buffer::operator=(const Buffer& rhs)
{
	mupdf::drop_buffer(this->m_internal);
	mupdf::keep_buffer(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_new_buffer_from_copied_data(). */
FZ_FUNCTION Buffer Buffer::new_buffer_from_copied_data(const unsigned char *data, size_t size)
{
	fz_buffer* temp = mupdf::new_buffer_from_copied_data(data, size);
	return Buffer(temp);
}

/* Wrapper for fz_append_bits(). */
FZ_FUNCTION void Buffer::append_bits(int value, int count)
{
	return mupdf::append_bits(this->m_internal, value, count);
}

/* Wrapper for fz_append_bits_pad(). */
FZ_FUNCTION void Buffer::append_bits_pad()
{
	return mupdf::append_bits_pad(this->m_internal);
}

/* Wrapper for fz_append_buffer(). */
FZ_FUNCTION void Buffer::append_buffer(const Buffer& source)
{
	return mupdf::append_buffer(this->m_internal, source.m_internal);
}

/* Wrapper for fz_append_byte(). */
FZ_FUNCTION void Buffer::append_byte(int c)
{
	return mupdf::append_byte(this->m_internal, c);
}

/* Wrapper for fz_append_data(). */
FZ_FUNCTION void Buffer::append_data(const void *data, size_t len)
{
	return mupdf::append_data(this->m_internal, data, len);
}

/* Wrapper for fz_append_int16_be(). */
FZ_FUNCTION void Buffer::append_int16_be(int x)
{
	return mupdf::append_int16_be(this->m_internal, x);
}

/* Wrapper for fz_append_int16_le(). */
FZ_FUNCTION void Buffer::append_int16_le(int x)
{
	return mupdf::append_int16_le(this->m_internal, x);
}

/* Wrapper for fz_append_int32_be(). */
FZ_FUNCTION void Buffer::append_int32_be(int x)
{
	return mupdf::append_int32_be(this->m_internal, x);
}

/* Wrapper for fz_append_int32_le(). */
FZ_FUNCTION void Buffer::append_int32_le(int x)
{
	return mupdf::append_int32_le(this->m_internal, x);
}

/* Wrapper for fz_append_pdf_string(). */
FZ_FUNCTION void Buffer::append_pdf_string(const char *text)
{
	return mupdf::append_pdf_string(this->m_internal, text);
}

/* Wrapper for fz_append_rune(). */
FZ_FUNCTION void Buffer::append_rune(int c)
{
	return mupdf::append_rune(this->m_internal, c);
}

/* Wrapper for fz_append_string(). */
FZ_FUNCTION void Buffer::append_string(const char *data)
{
	return mupdf::append_string(this->m_internal, data);
}

/* Wrapper for fz_append_vprintf(). */
FZ_FUNCTION void Buffer::append_vprintf(const char *fmt, va_list args)
{
	return mupdf::append_vprintf(this->m_internal, fmt, args);
}

/* Wrapper for fz_buffer_extract(). */
FZ_FUNCTION size_t Buffer::buffer_extract(unsigned char **data)
{
	return mupdf::buffer_extract(this->m_internal, data);
}

/* Wrapper for fz_buffer_storage(). */
FZ_FUNCTION size_t Buffer::buffer_storage(unsigned char **datap)
{
	return mupdf::buffer_storage(this->m_internal, datap);
}

/* Wrapper for fz_clear_buffer(). */
FZ_FUNCTION void Buffer::clear_buffer()
{
	return mupdf::clear_buffer(this->m_internal);
}

/* Wrapper for fz_grow_buffer(). */
FZ_FUNCTION void Buffer::grow_buffer()
{
	return mupdf::grow_buffer(this->m_internal);
}

/* Wrapper for fz_load_jbig2_globals(). */
FZ_FUNCTION Jbig2Globals Buffer::load_jbig2_globals()
{
	fz_jbig2_globals* temp = mupdf::load_jbig2_globals(this->m_internal);
	return Jbig2Globals(temp);
}

/* Wrapper for fz_md5_buffer(). */
FZ_FUNCTION void Buffer::md5_buffer(unsigned char digest[16])
{
	return mupdf::md5_buffer(this->m_internal, digest);
}

/* Wrapper for fz_new_display_list_from_svg(). */
FZ_FUNCTION DisplayList Buffer::new_display_list_from_svg(const char *base_uri, const Archive& zip, float *w, float *h)
{
	fz_display_list* temp = mupdf::new_display_list_from_svg(this->m_internal, base_uri, zip.m_internal, w, h);
	return DisplayList(temp);
}

/* Wrapper for fz_new_image_from_buffer(). */
FZ_FUNCTION Image Buffer::new_image_from_buffer()
{
	fz_image* temp = mupdf::new_image_from_buffer(this->m_internal);
	return Image(temp);
}

/* Wrapper for fz_new_image_from_svg(). */
FZ_FUNCTION Image Buffer::new_image_from_svg(const char *base_uri, const Archive& zip)
{
	fz_image* temp = mupdf::new_image_from_svg(this->m_internal, base_uri, zip.m_internal);
	return Image(temp);
}

/* Wrapper for fz_open_buffer(). */
FZ_FUNCTION Stream Buffer::open_buffer()
{
	fz_stream* temp = mupdf::open_buffer(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_parse_xml(). */
FZ_FUNCTION XmlDoc Buffer::parse_xml(int preserve_white)
{
	fz_xml_doc* temp = mupdf::parse_xml(this->m_internal, preserve_white);
	return XmlDoc(temp);
}

/* Wrapper for fz_parse_xml_from_html5(). */
FZ_FUNCTION XmlDoc Buffer::parse_xml_from_html5()
{
	fz_xml_doc* temp = mupdf::parse_xml_from_html5(this->m_internal);
	return XmlDoc(temp);
}

/* Wrapper for fz_resize_buffer(). */
FZ_FUNCTION void Buffer::resize_buffer(size_t capacity)
{
	return mupdf::resize_buffer(this->m_internal, capacity);
}

/* Wrapper for fz_save_buffer(). */
FZ_FUNCTION void Buffer::save_buffer(const char *filename)
{
	return mupdf::save_buffer(this->m_internal, filename);
}

/* Wrapper for fz_string_from_buffer(). */
FZ_FUNCTION const char *Buffer::string_from_buffer()
{
	return mupdf::string_from_buffer(this->m_internal);
}

/* Wrapper for fz_terminate_buffer(). */
FZ_FUNCTION void Buffer::terminate_buffer()
{
	return mupdf::terminate_buffer(this->m_internal);
}

/* Wrapper for fz_trim_buffer(). */
FZ_FUNCTION void Buffer::trim_buffer()
{
	return mupdf::trim_buffer(this->m_internal);
}

/* Wrapper for pdf_append_token(). */
FZ_FUNCTION void Buffer::pdf_append_token(int tok, const PdfLexbuf& lex)
{
	return mupdf::ppdf_append_token(this->m_internal, tok, lex.m_internal);
}

/* Wrapper for pdf_new_buffer_processor(). */
FZ_FUNCTION PdfProcessor Buffer::pdf_new_buffer_processor(int ahxencode)
{
	pdf_processor* temp = mupdf::ppdf_new_buffer_processor(this->m_internal, ahxencode);
	return PdfProcessor(temp);
}

FZ_FUNCTION Buffer::Buffer(fz_buffer* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Buffer::~Buffer()
{
	mupdf::drop_buffer(m_internal);
}


/* Implementation of methods for ColorParams (wrapper for fz_color_params). */

FZ_FUNCTION ColorParams::ColorParams(const fz_color_params* internal)
{
	this->ri = internal->ri;
	this->bp = internal->bp;
	this->op = internal->op;
	this->opm = internal->opm;
}

FZ_FUNCTION ColorParams::ColorParams(const fz_color_params internal)
{
	this->ri = internal.ri;
	this->bp = internal.bp;
	this->op = internal.op;
	this->opm = internal.opm;
}

/* Constructor using raw copy of pre-existing fz_color_params. */
FZ_FUNCTION fz_color_params* ColorParams::internal()
{
	return (fz_color_params*) &this->ri;
}

/* Constructor using raw copy of pre-existing fz_color_params. */
FZ_FUNCTION const fz_color_params* ColorParams::internal() const
{
	return (const fz_color_params*) &this->ri;
}

FZ_FUNCTION std::string ColorParams::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const ColorParams& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Colorspace (wrapper for fz_colorspace). */

/* Constructor using fz_new_cal_gray_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(float wp[3], float bp[3], float gamma)
{
	this->m_internal = mupdf::new_cal_gray_colorspace(wp, bp, gamma);
}

/* Constructor using fz_new_cal_rgb_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(float wp[3], float bp[3], float gamma[3], float matrix[9])
{
	this->m_internal = mupdf::new_cal_rgb_colorspace(wp, bp, gamma, matrix);
}

/* Constructor using fz_new_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(enum fz_colorspace_type type, int flags, int n, const char *name)
{
	this->m_internal = mupdf::new_colorspace(type, flags, n, name);
}

/* Constructor using fz_new_icc_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(enum fz_colorspace_type type, int flags, const char *name, const Buffer& buf)
{
	this->m_internal = mupdf::new_icc_colorspace(type, flags, name, buf.m_internal);
}

/* Constructor using fz_new_indexed_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(const Colorspace& base, int high, unsigned char *lookup)
{
	this->m_internal = mupdf::new_indexed_colorspace(base.m_internal, high, lookup);
}

/* Custom constructor. */
FZ_FUNCTION Colorspace::Colorspace(Fixed fixed)
{
	if (0) {}
	else if ( fixed == Fixed_GRAY)  m_internal = mupdf::device_gray();
	else if ( fixed == Fixed_RGB)   m_internal = mupdf::device_rgb();
	else if ( fixed == Fixed_BGR)   m_internal = mupdf::device_bgr();
	else if ( fixed == Fixed_CMYK)  m_internal = mupdf::device_cmyk();
	else if ( fixed == Fixed_LAB)   m_internal = mupdf::device_lab();
	else {
		std::string message = "Unrecognised fixed colorspace id";
		throw ErrorGeneric(message.c_str());
	}
	mupdf::keep_colorspace(m_internal);
}

/* Custom constructor. */
FZ_FUNCTION Colorspace::Colorspace()
: m_internal( NULL)
{
}

/* Copy constructor using fz_keep_colorspace(). */
FZ_FUNCTION Colorspace::Colorspace(const Colorspace& rhs)
: m_internal(mupdf::keep_colorspace(rhs.m_internal))
{
}

/* operator= using fz_keep_colorspace() and fz_drop_colorspace(). */
FZ_FUNCTION Colorspace& Colorspace::operator=(const Colorspace& rhs)
{
	mupdf::drop_colorspace(this->m_internal);
	mupdf::keep_colorspace(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_clamp_color(). */
FZ_FUNCTION void Colorspace::clamp_color(const float *in, float *out)
{
	return mupdf::clamp_color(this->m_internal, in, out);
}

/* Wrapper for fz_colorspace_colorant(). */
FZ_FUNCTION const char *Colorspace::colorspace_colorant(int n)
{
	return mupdf::colorspace_colorant(this->m_internal, n);
}

/* Wrapper for fz_colorspace_device_n_has_cmyk(). */
FZ_FUNCTION int Colorspace::colorspace_device_n_has_cmyk()
{
	return mupdf::colorspace_device_n_has_cmyk(this->m_internal);
}

/* Wrapper for fz_colorspace_device_n_has_only_cmyk(). */
FZ_FUNCTION int Colorspace::colorspace_device_n_has_only_cmyk()
{
	return mupdf::colorspace_device_n_has_only_cmyk(this->m_internal);
}

/* Wrapper for fz_colorspace_is_cmyk(). */
FZ_FUNCTION int Colorspace::colorspace_is_cmyk()
{
	return mupdf::colorspace_is_cmyk(this->m_internal);
}

/* Wrapper for fz_colorspace_is_device(). */
FZ_FUNCTION int Colorspace::colorspace_is_device()
{
	return mupdf::colorspace_is_device(this->m_internal);
}

/* Wrapper for fz_colorspace_is_device_cmyk(). */
FZ_FUNCTION int Colorspace::colorspace_is_device_cmyk()
{
	return mupdf::colorspace_is_device_cmyk(this->m_internal);
}

/* Wrapper for fz_colorspace_is_device_gray(). */
FZ_FUNCTION int Colorspace::colorspace_is_device_gray()
{
	return mupdf::colorspace_is_device_gray(this->m_internal);
}

/* Wrapper for fz_colorspace_is_device_n(). */
FZ_FUNCTION int Colorspace::colorspace_is_device_n()
{
	return mupdf::colorspace_is_device_n(this->m_internal);
}

/* Wrapper for fz_colorspace_is_gray(). */
FZ_FUNCTION int Colorspace::colorspace_is_gray()
{
	return mupdf::colorspace_is_gray(this->m_internal);
}

/* Wrapper for fz_colorspace_is_indexed(). */
FZ_FUNCTION int Colorspace::colorspace_is_indexed()
{
	return mupdf::colorspace_is_indexed(this->m_internal);
}

/* Wrapper for fz_colorspace_is_lab(). */
FZ_FUNCTION int Colorspace::colorspace_is_lab()
{
	return mupdf::colorspace_is_lab(this->m_internal);
}

/* Wrapper for fz_colorspace_is_lab_icc(). */
FZ_FUNCTION int Colorspace::colorspace_is_lab_icc()
{
	return mupdf::colorspace_is_lab_icc(this->m_internal);
}

/* Wrapper for fz_colorspace_is_rgb(). */
FZ_FUNCTION int Colorspace::colorspace_is_rgb()
{
	return mupdf::colorspace_is_rgb(this->m_internal);
}

/* Wrapper for fz_colorspace_is_subtractive(). */
FZ_FUNCTION int Colorspace::colorspace_is_subtractive()
{
	return mupdf::colorspace_is_subtractive(this->m_internal);
}

/* Wrapper for fz_colorspace_n(). */
FZ_FUNCTION int Colorspace::colorspace_n()
{
	return mupdf::colorspace_n(this->m_internal);
}

/* Wrapper for fz_colorspace_name(). */
FZ_FUNCTION const char *Colorspace::colorspace_name()
{
	return mupdf::colorspace_name(this->m_internal);
}

/* Wrapper for fz_colorspace_name_colorant(). */
FZ_FUNCTION void Colorspace::colorspace_name_colorant(int n, const char *name)
{
	return mupdf::colorspace_name_colorant(this->m_internal, n, name);
}

/* Wrapper for fz_colorspace_type(). */
FZ_FUNCTION enum fz_colorspace_type Colorspace::colorspace_type()
{
	return mupdf::colorspace_type(this->m_internal);
}

/* Wrapper for fz_convert_color(). */
FZ_FUNCTION void Colorspace::convert_color(const float *sv, const Colorspace& ds, float *dv, const Colorspace& is, ColorParams& params)
{
	return mupdf::convert_color(this->m_internal, sv, ds.m_internal, dv, is.m_internal, *(fz_color_params*) &params.ri);
}

/* Wrapper for fz_convert_separation_colors(). */
FZ_FUNCTION void Colorspace::convert_separation_colors(const float *src_color, const Separations& dst_seps, const Colorspace& dst_cs, float *dst_color, ColorParams& color_params)
{
	return mupdf::convert_separation_colors(this->m_internal, src_color, dst_seps.m_internal, dst_cs.m_internal, dst_color, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_is_valid_blend_colorspace(). */
FZ_FUNCTION int Colorspace::is_valid_blend_colorspace()
{
	return mupdf::is_valid_blend_colorspace(this->m_internal);
}

/* Wrapper for fz_new_indexed_colorspace(). */
FZ_FUNCTION Colorspace Colorspace::new_indexed_colorspace(int high, unsigned char *lookup)
{
	fz_colorspace* temp = mupdf::new_indexed_colorspace(this->m_internal, high, lookup);
	return Colorspace(temp);
}

/* Wrapper for fz_new_pixmap(). */
FZ_FUNCTION Pixmap Colorspace::new_pixmap(int w, int h, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap(this->m_internal, w, h, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_with_bbox(). */
FZ_FUNCTION Pixmap Colorspace::new_pixmap_with_bbox(Irect& bbox, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_with_bbox(this->m_internal, *(fz_irect*) &bbox.x0, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_with_bbox_and_data(). */
FZ_FUNCTION Pixmap Colorspace::new_pixmap_with_bbox_and_data(Irect& rect, const Separations& seps, int alpha, unsigned char *samples)
{
	fz_pixmap* temp = mupdf::new_pixmap_with_bbox_and_data(this->m_internal, *(fz_irect*) &rect.x0, seps.m_internal, alpha, samples);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_with_data(). */
FZ_FUNCTION Pixmap Colorspace::new_pixmap_with_data(int w, int h, const Separations& seps, int alpha, int stride, unsigned char *samples)
{
	fz_pixmap* temp = mupdf::new_pixmap_with_data(this->m_internal, w, h, seps.m_internal, alpha, stride, samples);
	return Pixmap(temp);
}

/* Wrapper for pdf_is_tint_colorspace(). */
FZ_FUNCTION int Colorspace::pdf_is_tint_colorspace()
{
	return mupdf::ppdf_is_tint_colorspace(this->m_internal);
}

FZ_FUNCTION Colorspace::Colorspace(fz_colorspace* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Colorspace::~Colorspace()
{
	mupdf::drop_colorspace(m_internal);
}


/* Implementation of methods for ColorspaceContext (wrapper for fz_colorspace_context). */

FZ_FUNCTION ColorspaceContext::ColorspaceContext(fz_colorspace_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for CompressedBuffer (wrapper for fz_compressed_buffer). */

/* Wrapper for fz_compressed_buffer_size(). */
FZ_FUNCTION size_t CompressedBuffer::compressed_buffer_size()
{
	return mupdf::compressed_buffer_size(this->m_internal);
}

/* Wrapper for fz_open_compressed_buffer(). */
FZ_FUNCTION Stream CompressedBuffer::open_compressed_buffer()
{
	fz_stream* temp = mupdf::open_compressed_buffer(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_image_decomp_stream_from_buffer(). */
FZ_FUNCTION Stream CompressedBuffer::open_image_decomp_stream_from_buffer(int *l2factor)
{
	fz_stream* temp = mupdf::open_image_decomp_stream_from_buffer(this->m_internal, l2factor);
	return Stream(temp);
}

FZ_FUNCTION CompressedBuffer::CompressedBuffer(fz_compressed_buffer* internal)
: m_internal(internal)
{
}

FZ_FUNCTION CompressedBuffer::~CompressedBuffer()
{
	mupdf::drop_compressed_buffer(m_internal);
}


/* Implementation of methods for CompressedImage (wrapper for fz_compressed_image). */

/* Wrapper for fz_set_compressed_image_buffer(). */
FZ_FUNCTION void CompressedImage::set_compressed_image_buffer(const CompressedBuffer& buf)
{
	return mupdf::set_compressed_image_buffer(this->m_internal, buf.m_internal);
}

FZ_FUNCTION CompressedImage::CompressedImage(fz_compressed_image* internal)
: m_internal(internal)
{
}


/* Implementation of methods for CompressionParams (wrapper for fz_compression_params). */

FZ_FUNCTION CompressionParams::CompressionParams(fz_compression_params* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Context (wrapper for fz_context). */

/* Constructor using fz_new_context_imp(). */
FZ_FUNCTION Context::Context(const AllocContext& alloc, const LocksContext& locks, size_t max_store, const char *version)
{
	this->m_internal = mupdf::new_context_imp(alloc.m_internal, locks.m_internal, max_store, version);
}

FZ_FUNCTION Context::Context(fz_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Cookie (wrapper for fz_cookie). */

/* Custom constructor. */
FZ_FUNCTION Cookie::Cookie()
{
	this->m_internal.abort = 0;
	this->m_internal.progress = 0;
	this->m_internal.progress_max = (size_t) -1;
	this->m_internal.errors = 0;
	this->m_internal.incomplete = 0;
}

/* Custom method. */
FZ_FUNCTION void Cookie::set_abort(){ m_internal.abort = 1; }

/* Custom method. */
FZ_FUNCTION int Cookie::get_progress(){ return m_internal.progress; }

/* Custom method. */
FZ_FUNCTION size_t Cookie::get_progress_max(){ return m_internal.progress_max; }

/* Custom method. */
FZ_FUNCTION int Cookie::get_errors(){ return m_internal.errors; }

/* Custom method. */
FZ_FUNCTION int Cookie::get_incomplete(){ return m_internal.incomplete; }

/* Custom method. */
FZ_FUNCTION void Cookie::increment_errors(int delta){ m_internal.errors += delta; }

FZ_FUNCTION int Cookie::abort()
{
	return m_internal.abort;
}

FZ_FUNCTION int Cookie::progress()
{
	return m_internal.progress;
}

FZ_FUNCTION size_t Cookie::progress_max()
{
	return m_internal.progress_max;
}

FZ_FUNCTION int Cookie::errors()
{
	return m_internal.errors;
}

FZ_FUNCTION int Cookie::incomplete()
{
	return m_internal.incomplete;
}

FZ_FUNCTION std::string Cookie::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Cookie& rhs)
{
	return out << rhs.m_internal;
}

/* Implementation of methods for DefaultColorspaces (wrapper for fz_default_colorspaces). */

/* Constructor using fz_new_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces::DefaultColorspaces()
{
	this->m_internal = mupdf::new_default_colorspaces();
}

/* Copy constructor using fz_keep_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces::DefaultColorspaces(const DefaultColorspaces& rhs)
: m_internal(mupdf::keep_default_colorspaces(rhs.m_internal))
{
}

/* operator= using fz_keep_default_colorspaces() and fz_drop_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces& DefaultColorspaces::operator=(const DefaultColorspaces& rhs)
{
	mupdf::drop_default_colorspaces(this->m_internal);
	mupdf::keep_default_colorspaces(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_clone_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces DefaultColorspaces::clone_default_colorspaces()
{
	fz_default_colorspaces* temp = mupdf::clone_default_colorspaces(this->m_internal);
	return DefaultColorspaces(temp);
}

/* Wrapper for fz_default_cmyk(). */
FZ_FUNCTION Colorspace DefaultColorspaces::default_cmyk()
{
	fz_colorspace* temp = mupdf::default_cmyk(this->m_internal);
	mupdf::keep_colorspace(temp);
	return Colorspace(temp);
}

/* Wrapper for fz_default_gray(). */
FZ_FUNCTION Colorspace DefaultColorspaces::default_gray()
{
	fz_colorspace* temp = mupdf::default_gray(this->m_internal);
	return Colorspace(temp);
}

/* Wrapper for fz_default_output_intent(). */
FZ_FUNCTION Colorspace DefaultColorspaces::default_output_intent()
{
	fz_colorspace* temp = mupdf::default_output_intent(this->m_internal);
	mupdf::keep_colorspace(temp);
	return Colorspace(temp);
}

/* Wrapper for fz_default_rgb(). */
FZ_FUNCTION Colorspace DefaultColorspaces::default_rgb()
{
	fz_colorspace* temp = mupdf::default_rgb(this->m_internal);
	mupdf::keep_colorspace(temp);
	return Colorspace(temp);
}

/* Wrapper for fz_set_default_cmyk(). */
FZ_FUNCTION void DefaultColorspaces::set_default_cmyk(const Colorspace& cs)
{
	return mupdf::set_default_cmyk(this->m_internal, cs.m_internal);
}

/* Wrapper for fz_set_default_gray(). */
FZ_FUNCTION void DefaultColorspaces::set_default_gray(const Colorspace& cs)
{
	return mupdf::set_default_gray(this->m_internal, cs.m_internal);
}

/* Wrapper for fz_set_default_output_intent(). */
FZ_FUNCTION void DefaultColorspaces::set_default_output_intent(const Colorspace& cs)
{
	return mupdf::set_default_output_intent(this->m_internal, cs.m_internal);
}

/* Wrapper for fz_set_default_rgb(). */
FZ_FUNCTION void DefaultColorspaces::set_default_rgb(const Colorspace& cs)
{
	return mupdf::set_default_rgb(this->m_internal, cs.m_internal);
}

/* Wrapper for pdf_update_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces DefaultColorspaces::pdf_update_default_colorspaces(const PdfObj& res)
{
	fz_default_colorspaces* temp = mupdf::ppdf_update_default_colorspaces(this->m_internal, res.m_internal);
	return DefaultColorspaces(temp);
}

FZ_FUNCTION DefaultColorspaces::DefaultColorspaces(fz_default_colorspaces* internal)
: m_internal(internal)
{
}

FZ_FUNCTION DefaultColorspaces::~DefaultColorspaces()
{
	mupdf::drop_default_colorspaces(m_internal);
}


/* Implementation of methods for Device (wrapper for fz_device). */

/* Constructor using fz_new_bbox_device(). */
FZ_FUNCTION Device::Device(Rect& rectp)
{
	this->m_internal = mupdf::new_bbox_device((fz_rect *) &rectp.x0);
}

/* Constructor using fz_new_device_of_size(). */
FZ_FUNCTION Device::Device(int size)
{
	this->m_internal = mupdf::new_device_of_size(size);
}

/* Constructor using fz_new_draw_device(). */
FZ_FUNCTION Device::Device(Matrix& transform, const Pixmap& dest)
{
	this->m_internal = mupdf::new_draw_device(*(fz_matrix*) &transform.a, dest.m_internal);
}

/* Constructor using fz_new_draw_device_with_bbox(). */
FZ_FUNCTION Device::Device(Matrix& transform, const Pixmap& dest, Irect& clip)
{
	this->m_internal = mupdf::new_draw_device_with_bbox(*(fz_matrix*) &transform.a, dest.m_internal, (const fz_irect *) &clip.x0);
}

/* Constructor using fz_new_draw_device_with_bbox_proof(). */
FZ_FUNCTION Device::Device(Matrix& transform, const Pixmap& dest, Irect& clip, const Colorspace& cs)
{
	this->m_internal = mupdf::new_draw_device_with_bbox_proof(*(fz_matrix*) &transform.a, dest.m_internal, (const fz_irect *) &clip.x0, cs.m_internal);
}

/* Constructor using fz_new_draw_device_with_proof(). */
FZ_FUNCTION Device::Device(Matrix& transform, const Pixmap& dest, const Colorspace& proof_cs)
{
	this->m_internal = mupdf::new_draw_device_with_proof(*(fz_matrix*) &transform.a, dest.m_internal, proof_cs.m_internal);
}

/* Constructor using fz_new_list_device(). */
FZ_FUNCTION Device::Device(const DisplayList& list)
{
	this->m_internal = mupdf::new_list_device(list.m_internal);
}

/* Constructor using fz_new_ocr_device(). */
FZ_FUNCTION Device::Device(const Device& target, Matrix& ctm, Rect& mediabox, int with_list, const char *language, int (*progress)(fz_context *, void *, int ), void *progress_arg)
{
	this->m_internal = mupdf::new_ocr_device(target.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &mediabox.x0, with_list, language, progress, progress_arg);
}

/* Constructor using fz_new_stext_device(). */
FZ_FUNCTION Device::Device(const StextPage& page, StextOptions& options)
{
	this->m_internal = mupdf::new_stext_device(page.m_internal, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_svg_device(). */
FZ_FUNCTION Device::Device(const Output& out, float page_width, float page_height, int text_format, int reuse_images)
{
	this->m_internal = mupdf::new_svg_device(out.m_internal, page_width, page_height, text_format, reuse_images);
}

/* Constructor using fz_new_svg_device_with_id(). */
FZ_FUNCTION Device::Device(const Output& out, float page_width, float page_height, int text_format, int reuse_images, int *id)
{
	this->m_internal = mupdf::new_svg_device_with_id(out.m_internal, page_width, page_height, text_format, reuse_images, id);
}

/* Constructor using fz_new_test_device(). */
FZ_FUNCTION Device::Device(int *is_color, float threshold, int options, const Device& passthrough)
{
	this->m_internal = mupdf::new_test_device(is_color, threshold, options, passthrough.m_internal);
}

/* Constructor using fz_new_trace_device(). */
FZ_FUNCTION Device::Device(const Output& out)
{
	this->m_internal = mupdf::new_trace_device(out.m_internal);
}

/* Custom constructor. */
FZ_FUNCTION Device::Device()
: m_internal( NULL)
{
}

/* Copy constructor using fz_keep_device(). */
FZ_FUNCTION Device::Device(const Device& rhs)
: m_internal(mupdf::keep_device(rhs.m_internal))
{
}

/* operator= using fz_keep_device() and fz_drop_device(). */
FZ_FUNCTION Device& Device::operator=(const Device& rhs)
{
	mupdf::drop_device(this->m_internal);
	mupdf::keep_device(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_new_xmltext_device(). */
FZ_FUNCTION Device Device::new_xmltext_device(const Output& out)
{
	fz_device* temp = mupdf::new_xmltext_device(out.m_internal);
	return Device(temp);
}

/* Wrapper for fz_new_draw_device_type3(). */
FZ_FUNCTION Device Device::new_draw_device_type3(Matrix& transform, const Pixmap& dest)
{
	fz_device* temp = mupdf::new_draw_device_type3(*(fz_matrix*) &transform.a, dest.m_internal);
	return Device(temp);
}

/* Wrapper for fz_begin_group(). */
FZ_FUNCTION void Device::begin_group(Rect& area, const Colorspace& cs, int isolated, int knockout, int blendmode, float alpha)
{
	return mupdf::begin_group(this->m_internal, *(fz_rect*) &area.x0, cs.m_internal, isolated, knockout, blendmode, alpha);
}

/* Wrapper for fz_begin_layer(). */
FZ_FUNCTION void Device::begin_layer(const char *layer_name)
{
	return mupdf::begin_layer(this->m_internal, layer_name);
}

/* Wrapper for fz_begin_mask(). */
FZ_FUNCTION void Device::begin_mask(Rect& area, int luminosity, const Colorspace& colorspace, const float *bc, ColorParams& color_params)
{
	return mupdf::begin_mask(this->m_internal, *(fz_rect*) &area.x0, luminosity, colorspace.m_internal, bc, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_begin_tile(). */
FZ_FUNCTION void Device::begin_tile(Rect& area, Rect& view, float xstep, float ystep, Matrix& ctm)
{
	return mupdf::begin_tile(this->m_internal, *(fz_rect*) &area.x0, *(fz_rect*) &view.x0, xstep, ystep, *(fz_matrix*) &ctm.a);
}

/* Wrapper for fz_begin_tile_id(). */
FZ_FUNCTION int Device::begin_tile_id(Rect& area, Rect& view, float xstep, float ystep, Matrix& ctm, int id)
{
	return mupdf::begin_tile_id(this->m_internal, *(fz_rect*) &area.x0, *(fz_rect*) &view.x0, xstep, ystep, *(fz_matrix*) &ctm.a, id);
}

/* Wrapper for fz_clip_image_mask(). */
FZ_FUNCTION void Device::clip_image_mask(const Image& image, Matrix& ctm, Rect& scissor)
{
	return mupdf::clip_image_mask(this->m_internal, image.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0);
}

/* Wrapper for fz_clip_path(). */
FZ_FUNCTION void Device::clip_path(const Path& path, int even_odd, Matrix& ctm, Rect& scissor)
{
	return mupdf::clip_path(this->m_internal, path.m_internal, even_odd, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0);
}

/* Wrapper for fz_clip_stroke_path(). */
FZ_FUNCTION void Device::clip_stroke_path(const Path& path, const StrokeState& stroke, Matrix& ctm, Rect& scissor)
{
	return mupdf::clip_stroke_path(this->m_internal, path.m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0);
}

/* Wrapper for fz_clip_stroke_text(). */
FZ_FUNCTION void Device::clip_stroke_text(const Text& text, const StrokeState& stroke, Matrix& ctm, Rect& scissor)
{
	return mupdf::clip_stroke_text(this->m_internal, text.m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0);
}

/* Wrapper for fz_clip_text(). */
FZ_FUNCTION void Device::clip_text(const Text& text, Matrix& ctm, Rect& scissor)
{
	return mupdf::clip_text(this->m_internal, text.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0);
}

/* Wrapper for fz_close_device(). */
FZ_FUNCTION void Device::close_device()
{
	return mupdf::close_device(this->m_internal);
}

/* Wrapper for fz_device_current_scissor(). */
FZ_FUNCTION Rect Device::device_current_scissor()
{
	fz_rect temp = mupdf::device_current_scissor(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for fz_disable_device_hints(). */
FZ_FUNCTION void Device::disable_device_hints(int hints)
{
	return mupdf::disable_device_hints(this->m_internal, hints);
}

/* Wrapper for fz_enable_device_hints(). */
FZ_FUNCTION void Device::enable_device_hints(int hints)
{
	return mupdf::enable_device_hints(this->m_internal, hints);
}

/* Wrapper for fz_end_group(). */
FZ_FUNCTION void Device::end_group()
{
	return mupdf::end_group(this->m_internal);
}

/* Wrapper for fz_end_layer(). */
FZ_FUNCTION void Device::end_layer()
{
	return mupdf::end_layer(this->m_internal);
}

/* Wrapper for fz_end_mask(). */
FZ_FUNCTION void Device::end_mask()
{
	return mupdf::end_mask(this->m_internal);
}

/* Wrapper for fz_end_tile(). */
FZ_FUNCTION void Device::end_tile()
{
	return mupdf::end_tile(this->m_internal);
}

/* Wrapper for fz_fill_image(). */
FZ_FUNCTION void Device::fill_image(const Image& image, Matrix& ctm, float alpha, ColorParams& color_params)
{
	return mupdf::fill_image(this->m_internal, image.m_internal, *(fz_matrix*) &ctm.a, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_fill_image_mask(). */
FZ_FUNCTION void Device::fill_image_mask(const Image& image, Matrix& ctm, const Colorspace& colorspace, const float *color, float alpha, ColorParams& color_params)
{
	return mupdf::fill_image_mask(this->m_internal, image.m_internal, *(fz_matrix*) &ctm.a, colorspace.m_internal, color, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_fill_path(). */
FZ_FUNCTION void Device::fill_path(const Path& path, int even_odd, Matrix& ctm, const Colorspace& colorspace, const float *color, float alpha, ColorParams& color_params)
{
	return mupdf::fill_path(this->m_internal, path.m_internal, even_odd, *(fz_matrix*) &ctm.a, colorspace.m_internal, color, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_fill_shade(). */
FZ_FUNCTION void Device::fill_shade(const Shade& shade, Matrix& ctm, float alpha, ColorParams& color_params)
{
	return mupdf::fill_shade(this->m_internal, shade.m_internal, *(fz_matrix*) &ctm.a, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_fill_text(). */
FZ_FUNCTION void Device::fill_text(const Text& text, Matrix& ctm, const Colorspace& colorspace, const float *color, float alpha, ColorParams& color_params)
{
	return mupdf::fill_text(this->m_internal, text.m_internal, *(fz_matrix*) &ctm.a, colorspace.m_internal, color, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_ignore_text(). */
FZ_FUNCTION void Device::ignore_text(const Text& text, Matrix& ctm)
{
	return mupdf::ignore_text(this->m_internal, text.m_internal, *(fz_matrix*) &ctm.a);
}

/* Wrapper for fz_new_ocr_device(). */
FZ_FUNCTION Device Device::new_ocr_device(Matrix& ctm, Rect& mediabox, int with_list, const char *language, int (*progress)(fz_context *, void *, int ), void *progress_arg)
{
	fz_device* temp = mupdf::new_ocr_device(this->m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &mediabox.x0, with_list, language, progress, progress_arg);
	return Device(temp);
}

/* Wrapper for fz_pop_clip(). */
FZ_FUNCTION void Device::pop_clip()
{
	return mupdf::pop_clip(this->m_internal);
}

/* Wrapper for fz_render_flags(). */
FZ_FUNCTION void Device::render_flags(int set, int clear)
{
	return mupdf::render_flags(this->m_internal, set, clear);
}

/* Wrapper for fz_render_t3_glyph_direct(). */
FZ_FUNCTION void Device::render_t3_glyph_direct(const Font& font, int gid, Matrix& trm, void *gstate, const DefaultColorspaces& def_cs)
{
	return mupdf::render_t3_glyph_direct(this->m_internal, font.m_internal, gid, *(fz_matrix*) &trm.a, gstate, def_cs.m_internal);
}

/* Wrapper for fz_set_default_colorspaces(). */
FZ_FUNCTION void Device::set_default_colorspaces(const DefaultColorspaces& default_cs)
{
	return mupdf::set_default_colorspaces(this->m_internal, default_cs.m_internal);
}

/* Wrapper for fz_stroke_path(). */
FZ_FUNCTION void Device::stroke_path(const Path& path, const StrokeState& stroke, Matrix& ctm, const Colorspace& colorspace, const float *color, float alpha, ColorParams& color_params)
{
	return mupdf::stroke_path(this->m_internal, path.m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a, colorspace.m_internal, color, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_stroke_text(). */
FZ_FUNCTION void Device::stroke_text(const Text& text, const StrokeState& stroke, Matrix& ctm, const Colorspace& colorspace, const float *color, float alpha, ColorParams& color_params)
{
	return mupdf::stroke_text(this->m_internal, text.m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a, colorspace.m_internal, color, alpha, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for pdf_new_run_processor(). */
FZ_FUNCTION PdfProcessor Device::pdf_new_run_processor(Matrix& ctm, const char *usage, const PdfGstate& gstate, const DefaultColorspaces& default_cs, Cookie& cookie)
{
	pdf_processor* temp = mupdf::ppdf_new_run_processor(this->m_internal, *(fz_matrix*) &ctm.a, usage, gstate.m_internal, default_cs.m_internal, &cookie.m_internal);
	return PdfProcessor(temp);
}

FZ_FUNCTION Device::Device(fz_device* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Device::~Device()
{
	mupdf::drop_device(m_internal);
}


/* Implementation of methods for DeviceContainerStack (wrapper for fz_device_container_stack). */

FZ_FUNCTION DeviceContainerStack::DeviceContainerStack(fz_device_container_stack* internal)
: m_internal(internal)
{
}


/* Implementation of methods for DisplayList (wrapper for fz_display_list). */

/* Constructor using fz_new_display_list(). */
FZ_FUNCTION DisplayList::DisplayList(Rect& mediabox)
{
	this->m_internal = mupdf::new_display_list(*(fz_rect*) &mediabox.x0);
}

/* Constructor using fz_new_display_list_from_page(). */
FZ_FUNCTION DisplayList::DisplayList(const Page& page)
{
	this->m_internal = mupdf::new_display_list_from_page(page.m_internal);
}

/* Constructor using fz_new_display_list_from_page_number(). */
FZ_FUNCTION DisplayList::DisplayList(const Document& doc, int number)
{
	this->m_internal = mupdf::new_display_list_from_page_number(doc.m_internal, number);
}

/* Constructor using fz_new_display_list_from_svg(). */
FZ_FUNCTION DisplayList::DisplayList(const Buffer& buf, const char *base_uri, const Archive& zip, float *w, float *h)
{
	this->m_internal = mupdf::new_display_list_from_svg(buf.m_internal, base_uri, zip.m_internal, w, h);
}

/* Constructor using fz_new_display_list_from_svg_xml(). */
FZ_FUNCTION DisplayList::DisplayList(const XmlDoc& xmldoc, const Xml& xml, const char *base_uri, const Archive& zip, float *w, float *h)
{
	this->m_internal = mupdf::new_display_list_from_svg_xml(xmldoc.m_internal, xml.m_internal, base_uri, zip.m_internal, w, h);
}

/* Copy constructor using fz_keep_display_list(). */
FZ_FUNCTION DisplayList::DisplayList(const DisplayList& rhs)
: m_internal(mupdf::keep_display_list(rhs.m_internal))
{
}

/* operator= using fz_keep_display_list() and fz_drop_display_list(). */
FZ_FUNCTION DisplayList& DisplayList::operator=(const DisplayList& rhs)
{
	mupdf::drop_display_list(this->m_internal);
	mupdf::keep_display_list(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_new_display_list_from_page_contents(). */
FZ_FUNCTION DisplayList DisplayList::new_display_list_from_page_contents(const Page& page)
{
	fz_display_list* temp = mupdf::new_display_list_from_page_contents(page.m_internal);
	return DisplayList(temp);
}

/* Wrapper for fz_bound_display_list(). */
FZ_FUNCTION Rect DisplayList::bound_display_list()
{
	fz_rect temp = mupdf::bound_display_list(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for fz_display_list_is_empty(). */
FZ_FUNCTION int DisplayList::display_list_is_empty()
{
	return mupdf::display_list_is_empty(this->m_internal);
}

/* Wrapper for fz_new_buffer_from_display_list(). */
FZ_FUNCTION Buffer DisplayList::new_buffer_from_display_list(StextOptions& options)
{
	fz_buffer* temp = mupdf::new_buffer_from_display_list(this->m_internal, (const fz_stext_options *) &options.flags);
	return Buffer(temp);
}

/* Wrapper for fz_new_list_device(). */
FZ_FUNCTION Device DisplayList::new_list_device()
{
	fz_device* temp = mupdf::new_list_device(this->m_internal);
	return Device(temp);
}

/* Wrapper for fz_new_pixmap_from_display_list(). */
FZ_FUNCTION Pixmap DisplayList::new_pixmap_from_display_list(Matrix& ctm, const Colorspace& cs, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_display_list(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_display_list_with_separations(). */
FZ_FUNCTION Pixmap DisplayList::new_pixmap_from_display_list_with_separations(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_display_list_with_separations(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_run_display_list(). */
FZ_FUNCTION void DisplayList::run_display_list(const Device& dev, Matrix& ctm, Rect& scissor, Cookie& cookie)
{
	return mupdf::run_display_list(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0, &cookie.m_internal);
}

/* Wrapper for fz_search_display_list(). */
FZ_FUNCTION int DisplayList::search_display_list(const char *needle, Quad& hit_bbox, int hit_max)
{
	return mupdf::search_display_list(this->m_internal, needle, (fz_quad *) &hit_bbox.ul, hit_max);
}

FZ_FUNCTION DisplayList::DisplayList(fz_display_list* internal)
: m_internal(internal)
{
}

FZ_FUNCTION DisplayList::~DisplayList()
{
	mupdf::drop_display_list(m_internal);
}


/* Implementation of methods for Document (wrapper for fz_document). */

/* Constructor using fz_open_accelerated_document(). */
FZ_FUNCTION Document::Document(const char *filename, const char *accel)
{
	this->m_internal = mupdf::open_accelerated_document(filename, accel);
}

/* Constructor using fz_open_accelerated_document_with_stream(). */
FZ_FUNCTION Document::Document(const char *magic, const Stream& stream, const Stream& accel)
{
	this->m_internal = mupdf::open_accelerated_document_with_stream(magic, stream.m_internal, accel.m_internal);
}

/* Constructor using fz_open_document(). */
FZ_FUNCTION Document::Document(const char *filename)
{
	this->m_internal = mupdf::open_document(filename);
}

/* Constructor using fz_open_document_with_stream(). */
FZ_FUNCTION Document::Document(const char *magic, const Stream& stream)
{
	this->m_internal = mupdf::open_document_with_stream(magic, stream.m_internal);
}

/* Copy constructor using fz_keep_document(). */
FZ_FUNCTION Document::Document(const Document& rhs)
: m_internal(mupdf::keep_document(rhs.m_internal))
{
}

/* operator= using fz_keep_document() and fz_drop_document(). */
FZ_FUNCTION Document& Document::operator=(const Document& rhs)
{
	mupdf::drop_document(this->m_internal);
	mupdf::keep_document(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_new_xhtml_document_from_document(). */
FZ_FUNCTION Document Document::new_xhtml_document_from_document(const Document& old_doc, StextOptions& opts)
{
	fz_document* temp = mupdf::new_xhtml_document_from_document(old_doc.m_internal, (const fz_stext_options *) &opts.flags);
	return Document(temp);
}

/* Wrapper for fz_authenticate_password(). */
FZ_FUNCTION int Document::authenticate_password(const char *password)
{
	return mupdf::authenticate_password(this->m_internal, password);
}

/* Wrapper for fz_clamp_location(). */
FZ_FUNCTION Location Document::clamp_location(Location& loc)
{
	fz_location temp = mupdf::clamp_location(this->m_internal, *(fz_location*) &loc.chapter);
	return Location(&temp);
}

/* Wrapper for fz_count_chapter_pages(). */
FZ_FUNCTION int Document::count_chapter_pages(int chapter)
{
	return mupdf::count_chapter_pages(this->m_internal, chapter);
}

/* Wrapper for fz_count_chapters(). */
FZ_FUNCTION int Document::count_chapters()
{
	return mupdf::count_chapters(this->m_internal);
}

/* Wrapper for fz_count_pages(). */
FZ_FUNCTION int Document::count_pages()
{
	return mupdf::count_pages(this->m_internal);
}

/* Wrapper for fz_document_output_intent(). */
FZ_FUNCTION Colorspace Document::document_output_intent()
{
	fz_colorspace* temp = mupdf::document_output_intent(this->m_internal);
	mupdf::keep_colorspace(temp);
	return Colorspace(temp);
}

/* Wrapper for fz_document_supports_accelerator(). */
FZ_FUNCTION int Document::document_supports_accelerator()
{
	return mupdf::document_supports_accelerator(this->m_internal);
}

/* Wrapper for fz_has_permission(). */
FZ_FUNCTION int Document::has_permission(fz_permission p)
{
	return mupdf::has_permission(this->m_internal, p);
}

/* Wrapper for fz_is_document_reflowable(). */
FZ_FUNCTION int Document::is_document_reflowable()
{
	return mupdf::is_document_reflowable(this->m_internal);
}

/* Wrapper for fz_last_page(). */
FZ_FUNCTION Location Document::last_page()
{
	fz_location temp = mupdf::last_page(this->m_internal);
	return Location(&temp);
}

/* Wrapper for fz_layout_document(). */
FZ_FUNCTION void Document::layout_document(float w, float h, float em)
{
	return mupdf::layout_document(this->m_internal, w, h, em);
}

/* Wrapper for fz_load_chapter_page(). */
FZ_FUNCTION Page Document::load_chapter_page(int chapter, int page)
{
	fz_page* temp = mupdf::load_chapter_page(this->m_internal, chapter, page);
	return Page(temp);
}

/* Wrapper for fz_load_outline(). */
FZ_FUNCTION Outline Document::load_outline()
{
	fz_outline* temp = mupdf::load_outline(this->m_internal);
	return Outline(temp);
}

/* Wrapper for fz_load_page(). */
FZ_FUNCTION Page Document::load_page(int number)
{
	fz_page* temp = mupdf::load_page(this->m_internal, number);
	return Page(temp);
}

/* Wrapper for fz_location_from_page_number(). */
FZ_FUNCTION Location Document::location_from_page_number(int number)
{
	fz_location temp = mupdf::location_from_page_number(this->m_internal, number);
	return Location(&temp);
}

/* Wrapper for fz_lookup_bookmark(). */
FZ_FUNCTION Location Document::lookup_bookmark(fz_bookmark mark)
{
	fz_location temp = mupdf::lookup_bookmark(this->m_internal, mark);
	return Location(&temp);
}

/* Wrapper for fz_make_bookmark(). */
FZ_FUNCTION fz_bookmark Document::make_bookmark(Location& loc)
{
	return mupdf::make_bookmark(this->m_internal, *(fz_location*) &loc.chapter);
}

/* Wrapper for fz_needs_password(). */
FZ_FUNCTION int Document::needs_password()
{
	return mupdf::needs_password(this->m_internal);
}

/* Wrapper for fz_new_buffer_from_page_number(). */
FZ_FUNCTION Buffer Document::new_buffer_from_page_number(int number, StextOptions& options)
{
	fz_buffer* temp = mupdf::new_buffer_from_page_number(this->m_internal, number, (const fz_stext_options *) &options.flags);
	return Buffer(temp);
}

/* Wrapper for fz_new_display_list_from_page_number(). */
FZ_FUNCTION DisplayList Document::new_display_list_from_page_number(int number)
{
	fz_display_list* temp = mupdf::new_display_list_from_page_number(this->m_internal, number);
	return DisplayList(temp);
}

/* Wrapper for fz_new_pixmap_from_page_number(). */
FZ_FUNCTION Pixmap Document::new_pixmap_from_page_number(int number, Matrix& ctm, const Colorspace& cs, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_number(this->m_internal, number, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_page_number_with_separations(). */
FZ_FUNCTION Pixmap Document::new_pixmap_from_page_number_with_separations(int number, Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_number_with_separations(this->m_internal, number, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_xhtml_document_from_document(). */
FZ_FUNCTION Document Document::new_xhtml_document_from_document(StextOptions& opts)
{
	fz_document* temp = mupdf::new_xhtml_document_from_document(this->m_internal, (const fz_stext_options *) &opts.flags);
	return Document(temp);
}

/* Wrapper for fz_next_page(). */
FZ_FUNCTION Location Document::next_page(Location& loc)
{
	fz_location temp = mupdf::next_page(this->m_internal, *(fz_location*) &loc.chapter);
	return Location(&temp);
}

/* Wrapper for fz_open_reflowed_document(). */
FZ_FUNCTION Document Document::open_reflowed_document(StextOptions& opts)
{
	fz_document* temp = mupdf::open_reflowed_document(this->m_internal, (const fz_stext_options *) &opts.flags);
	return Document(temp);
}

/* Wrapper for fz_output_accelerator(). */
FZ_FUNCTION void Document::output_accelerator(const Output& accel)
{
	return mupdf::output_accelerator(this->m_internal, accel.m_internal);
}

/* Wrapper for fz_page_number_from_location(). */
FZ_FUNCTION int Document::page_number_from_location(Location& loc)
{
	return mupdf::page_number_from_location(this->m_internal, *(fz_location*) &loc.chapter);
}

/* Wrapper for fz_previous_page(). */
FZ_FUNCTION Location Document::previous_page(Location& loc)
{
	fz_location temp = mupdf::previous_page(this->m_internal, *(fz_location*) &loc.chapter);
	return Location(&temp);
}

/* Wrapper for fz_process_opened_pages(). */
FZ_FUNCTION void *Document::process_opened_pages(fz_process_opened_page_fn *process_openend_page, void *state)
{
	return mupdf::process_opened_pages(this->m_internal, process_openend_page, state);
}

/* Wrapper for fz_resolve_link(). */
FZ_FUNCTION Location Document::resolve_link(const char *uri, float *xp, float *yp)
{
	fz_location temp = mupdf::resolve_link(this->m_internal, uri, xp, yp);
	return Location(&temp);
}

/* Wrapper for fz_save_accelerator(). */
FZ_FUNCTION void Document::save_accelerator(const char *accel)
{
	return mupdf::save_accelerator(this->m_internal, accel);
}

/* Wrapper for fz_search_chapter_page_number(). */
FZ_FUNCTION int Document::search_chapter_page_number(int chapter, int page, const char *needle, Quad& hit_bbox, int hit_max)
{
	return mupdf::search_chapter_page_number(this->m_internal, chapter, page, needle, (fz_quad *) &hit_bbox.ul, hit_max);
}

/* Wrapper for fz_search_page_number(). */
FZ_FUNCTION int Document::search_page_number(int number, const char *needle, Quad& hit_bbox, int hit_max)
{
	return mupdf::search_page_number(this->m_internal, number, needle, (fz_quad *) &hit_bbox.ul, hit_max);
}

/* Wrapper for pdf_count_pages_imp(). */
FZ_FUNCTION int Document::pdf_count_pages_imp(int chapter)
{
	return mupdf::ppdf_count_pages_imp(this->m_internal, chapter);
}

/* Wrapper for pdf_document_from_fz_document(). */
FZ_FUNCTION PdfDocument Document::pdf_document_from_fz_document()
{
	pdf_document* temp = mupdf::ppdf_document_from_fz_document(this->m_internal);
	return PdfDocument(temp);
}

/* Wrapper for pdf_load_page_imp(). */
FZ_FUNCTION Page Document::pdf_load_page_imp(int chapter, int number)
{
	fz_page* temp = mupdf::ppdf_load_page_imp(this->m_internal, chapter, number);
	return Page(temp);
}

/* Wrapper for pdf_specifics(). */
FZ_FUNCTION PdfDocument Document::pdf_specifics()
{
	pdf_document* temp = mupdf::ppdf_specifics(this->m_internal);
	return PdfDocument(temp);
}

/* Custom method. */
FZ_FUNCTION std::string Document::lookup_metadata(const char* key, int* o_out)
{
	return mupdf::lookup_metadata(m_internal, key, o_out);
}

FZ_FUNCTION Document::Document(fz_document* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Document::~Document()
{
	mupdf::drop_document(m_internal);
}


/* Implementation of methods for DocumentHandler (wrapper for fz_document_handler). */

/* Wrapper for fz_register_document_handler(). */
FZ_FUNCTION void DocumentHandler::register_document_handler()
{
	return mupdf::register_document_handler(this->m_internal);
}

FZ_FUNCTION DocumentHandler::DocumentHandler(fz_document_handler* internal)
: m_internal(internal)
{
}


/* Implementation of methods for DocumentHandlerContext (wrapper for fz_document_handler_context). */

FZ_FUNCTION DocumentHandlerContext::DocumentHandlerContext(fz_document_handler_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for DocumentWriter (wrapper for fz_document_writer). */

/* Constructor using fz_new_document_writer_of_size(). */
FZ_FUNCTION DocumentWriter::DocumentWriter(size_t size, fz_document_writer_begin_page_fn *begin_page, fz_document_writer_end_page_fn *end_page, fz_document_writer_close_writer_fn *close, fz_document_writer_drop_writer_fn *drop)
{
	this->m_internal = mupdf::new_document_writer_of_size(size, begin_page, end_page, close, drop);
}

/* Constructor using fz_new_pixmap_writer(). */
FZ_FUNCTION DocumentWriter::DocumentWriter(const char *path, const char *options, const char *default_path, int n, void (*save)(fz_context *, fz_pixmap *, const char *))
{
	this->m_internal = mupdf::new_pixmap_writer(path, options, default_path, n, save);
}

/* Custom constructor. */
FZ_FUNCTION DocumentWriter::DocumentWriter(const char *path, const char *options, PathType path_type)
{
	if (0) {}
	else if (path_type == PathType_CBZ)         m_internal = mupdf::new_cbz_writer(path, options);
	else if (path_type == PathType_DOCX)        m_internal = mupdf::new_docx_writer(path, options);
	else if (path_type == PathType_ODT)         m_internal = mupdf::new_odt_writer(path, options);
	else if (path_type == PathType_PAM_PIXMAP)  m_internal = mupdf::new_pam_pixmap_writer(path, options);
	else if (path_type == PathType_PBM_PIXMAP)  m_internal = mupdf::new_pbm_pixmap_writer(path, options);
	else if (path_type == PathType_PCL)         m_internal = mupdf::new_pcl_writer(path, options);
	else if (path_type == PathType_PCLM)        m_internal = mupdf::new_pclm_writer(path, options);
	else if (path_type == PathType_PDF)         m_internal = mupdf::new_pdf_writer(path, options);
	else if (path_type == PathType_PDFOCR)      m_internal = mupdf::new_pdfocr_writer(path, options);
	else if (path_type == PathType_PGM_PIXMAP)  m_internal = mupdf::new_pgm_pixmap_writer(path, options);
	else if (path_type == PathType_PKM_PIXMAP)  m_internal = mupdf::new_pkm_pixmap_writer(path, options);
	else if (path_type == PathType_PNG_PIXMAP)  m_internal = mupdf::new_png_pixmap_writer(path, options);
	else if (path_type == PathType_PNM_PIXMAP)  m_internal = mupdf::new_pnm_pixmap_writer(path, options);
	else if (path_type == PathType_PPM_PIXMAP)  m_internal = mupdf::new_ppm_pixmap_writer(path, options);
	else if (path_type == PathType_PS)          m_internal = mupdf::new_ps_writer(path, options);
	else if (path_type == PathType_PWG)         m_internal = mupdf::new_pwg_writer(path, options);
	else if (path_type == PathType_SVG)         m_internal = mupdf::new_svg_writer(path, options);
	else throw ErrorAbort( "Unrecognised Type value");
}

/* Custom constructor. */
FZ_FUNCTION DocumentWriter::DocumentWriter(Output& out, const char *options, OutputType output_type)
{
	/* All fz_new_*_writer_with_output() functions take
	ownership of the fz_output, even if they throw an
	exception. So we need to set out.m_internal to null
	here so its destructor does nothing. */
	fz_output* out2 = out.m_internal;
	out.m_internal = NULL;
	if (0) {}
	else if (output_type == OutputType_CBZ)     m_internal = mupdf::new_cbz_writer_with_output(out2, options);
	else if (output_type == OutputType_DOCX)    m_internal = mupdf::new_docx_writer_with_output(out2, options);
	else if (output_type == OutputType_ODT)     m_internal = mupdf::new_odt_writer_with_output(out2, options);
	else if (output_type == OutputType_PCL)     m_internal = mupdf::new_pcl_writer_with_output(out2, options);
	else if (output_type == OutputType_PCLM)    m_internal = mupdf::new_pclm_writer_with_output(out2, options);
	else if (output_type == OutputType_PDF)     m_internal = mupdf::new_pdf_writer_with_output(out2, options);
	else if (output_type == OutputType_PDFOCR)  m_internal = mupdf::new_pdfocr_writer_with_output(out2, options);
	else if (output_type == OutputType_PS)      m_internal = mupdf::new_ps_writer_with_output(out2, options);
	else if (output_type == OutputType_PWG)     m_internal = mupdf::new_pwg_writer_with_output(out2, options);
	else
	{
		/* Ensure that out2 is dropped before we return. */
		mupdf::drop_output(out2);
		throw ErrorAbort( "Unrecognised OutputType value");
	}
}

/* Custom constructor. */
FZ_FUNCTION DocumentWriter::DocumentWriter(const char *format, const char *path, const char *options, FormatPathType format_path_type)
{
	if (0) {}
	else if (format_path_type == FormatPathType_DOCUMENT)   m_internal = mupdf::new_document_writer(format, path, options);
	else if (format_path_type == FormatPathType_TEXT)       m_internal = mupdf::new_text_writer(format, path, options);
	else throw ErrorAbort( "Unrecognised OutputType value");
}

/* Custom constructor. */
FZ_FUNCTION DocumentWriter::DocumentWriter(Output& out, const char *format, const char *options)
{
	/* Need to transfer ownership of <out>. */
	fz_output* out2 = out.m_internal;
	out.m_internal = NULL;
	m_internal = mupdf::new_document_writer_with_output(out2, format, options);
}

/* Custom constructor. */
FZ_FUNCTION DocumentWriter::DocumentWriter(const char *format, Output& out, const char *options)
{
	/* Need to transfer ownership of <out>. */
	fz_output* out2 = out.m_internal;
	out.m_internal = NULL;
	m_internal = mupdf::new_text_writer_with_output(format, out2, options);
}

/* Wrapper for fz_close_document_writer(). */
FZ_FUNCTION void DocumentWriter::close_document_writer()
{
	return mupdf::close_document_writer(this->m_internal);
}

/* Wrapper for fz_end_page(). */
FZ_FUNCTION void DocumentWriter::end_page()
{
	return mupdf::end_page(this->m_internal);
}

/* Wrapper for fz_pdfocr_writer_set_progress(). */
FZ_FUNCTION void DocumentWriter::pdfocr_writer_set_progress(int (*progress)(fz_context *, void *, int ), void *arg_2)
{
	return mupdf::pdfocr_writer_set_progress(this->m_internal, progress, arg_2);
}

/* Wrapper for fz_write_document(). */
FZ_FUNCTION void DocumentWriter::write_document(const Document& doc)
{
	return mupdf::write_document(this->m_internal, doc.m_internal);
}

/* Custom method. */
FZ_FUNCTION Device DocumentWriter::begin_page(Rect& mediabox)
{
	/* fz_begin_page() doesn't transfer ownership, so
	we have to call fz_keep_device() before creating
	the Device instance. */
	fz_device* dev = mupdf::begin_page(m_internal, *(fz_rect*) &mediabox.x0);
	dev = mupdf::keep_device(dev);
	return Device(dev);
}

FZ_FUNCTION DocumentWriter::DocumentWriter(fz_document_writer* internal)
: m_internal(internal)
{
}

FZ_FUNCTION DocumentWriter::~DocumentWriter()
{
	mupdf::drop_document_writer(m_internal);
}


/* Implementation of methods for DrawOptions (wrapper for fz_draw_options). */

/* Constructor using fz_parse_draw_options(). */
FZ_FUNCTION DrawOptions::DrawOptions(DrawOptions& options, const char *string)
{
	*(fz_draw_options*) &this->rotate = *mupdf::parse_draw_options((fz_draw_options *) &options.rotate, string);
}

FZ_FUNCTION DrawOptions::DrawOptions(const fz_draw_options* internal)
{
	this->rotate = internal->rotate;
	this->x_resolution = internal->x_resolution;
	this->y_resolution = internal->y_resolution;
	this->width = internal->width;
	this->height = internal->height;
	this->colorspace = internal->colorspace;
	this->alpha = internal->alpha;
	this->graphics = internal->graphics;
	this->text = internal->text;
}

FZ_FUNCTION DrawOptions::DrawOptions(const fz_draw_options internal)
{
	this->rotate = internal.rotate;
	this->x_resolution = internal.x_resolution;
	this->y_resolution = internal.y_resolution;
	this->width = internal.width;
	this->height = internal.height;
	this->colorspace = internal.colorspace;
	this->alpha = internal.alpha;
	this->graphics = internal.graphics;
	this->text = internal.text;
}

/* Constructor using raw copy of pre-existing fz_draw_options. */
FZ_FUNCTION fz_draw_options* DrawOptions::internal()
{
	return (fz_draw_options*) &this->rotate;
}

/* Constructor using raw copy of pre-existing fz_draw_options. */
FZ_FUNCTION const fz_draw_options* DrawOptions::internal() const
{
	return (const fz_draw_options*) &this->rotate;
}

FZ_FUNCTION std::string DrawOptions::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const DrawOptions& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for ErrorContext (wrapper for fz_error_context). */

FZ_FUNCTION ErrorContext::ErrorContext(fz_error_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for ErrorStackSlot (wrapper for fz_error_stack_slot). */

FZ_FUNCTION ErrorStackSlot::ErrorStackSlot(fz_error_stack_slot* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Font (wrapper for fz_font). */

/* Constructor using fz_new_base14_font(). */
FZ_FUNCTION Font::Font(const char *name)
{
	this->m_internal = mupdf::new_base14_font(name);
}

/* Constructor using fz_new_builtin_font(). */
FZ_FUNCTION Font::Font(const char *name, int is_bold, int is_italic)
{
	this->m_internal = mupdf::new_builtin_font(name, is_bold, is_italic);
}

/* Constructor using fz_new_cjk_font(). */
FZ_FUNCTION Font::Font(int ordering)
{
	this->m_internal = mupdf::new_cjk_font(ordering);
}

/* Constructor using fz_new_font_from_buffer(). */
FZ_FUNCTION Font::Font(const char *name, const Buffer& buffer, int index, int use_glyph_bbox)
{
	this->m_internal = mupdf::new_font_from_buffer(name, buffer.m_internal, index, use_glyph_bbox);
}

/* Constructor using fz_new_font_from_file(). */
FZ_FUNCTION Font::Font(const char *name, const char *path, int index, int use_glyph_bbox)
{
	this->m_internal = mupdf::new_font_from_file(name, path, index, use_glyph_bbox);
}

/* Constructor using fz_new_font_from_memory(). */
FZ_FUNCTION Font::Font(const char *name, const unsigned char *data, int len, int index, int use_glyph_bbox)
{
	this->m_internal = mupdf::new_font_from_memory(name, data, len, index, use_glyph_bbox);
}

/* Constructor using fz_new_type3_font(). */
FZ_FUNCTION Font::Font(const char *name, Matrix& matrix)
{
	this->m_internal = mupdf::new_type3_font(name, *(fz_matrix*) &matrix.a);
}

/* Copy constructor using fz_keep_font(). */
FZ_FUNCTION Font::Font(const Font& rhs)
: m_internal(mupdf::keep_font(rhs.m_internal))
{
}

/* operator= using fz_keep_font() and fz_drop_font(). */
FZ_FUNCTION Font& Font::operator=(const Font& rhs)
{
	mupdf::drop_font(this->m_internal);
	mupdf::keep_font(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_advance_glyph(). */
FZ_FUNCTION float Font::advance_glyph(int glyph, int wmode)
{
	return mupdf::advance_glyph(this->m_internal, glyph, wmode);
}

/* Wrapper for fz_bound_glyph(). */
FZ_FUNCTION Rect Font::bound_glyph(int gid, Matrix& trm)
{
	fz_rect temp = mupdf::bound_glyph(this->m_internal, gid, *(fz_matrix*) &trm.a);
	return Rect(&temp);
}

/* Wrapper for fz_decouple_type3_font(). */
FZ_FUNCTION void Font::decouple_type3_font(void *t3doc)
{
	return mupdf::decouple_type3_font(this->m_internal, t3doc);
}

/* Wrapper for fz_encode_character(). */
FZ_FUNCTION int Font::encode_character(int unicode)
{
	return mupdf::encode_character(this->m_internal, unicode);
}

/* Wrapper for fz_encode_character_by_glyph_name(). */
FZ_FUNCTION int Font::encode_character_by_glyph_name(const char *glyphname)
{
	return mupdf::encode_character_by_glyph_name(this->m_internal, glyphname);
}

/* Wrapper for fz_encode_character_sc(). */
FZ_FUNCTION int Font::encode_character_sc(int unicode)
{
	return mupdf::encode_character_sc(this->m_internal, unicode);
}

/* Wrapper for fz_font_ascender(). */
FZ_FUNCTION float Font::font_ascender()
{
	return mupdf::font_ascender(this->m_internal);
}

/* Wrapper for fz_font_bbox(). */
FZ_FUNCTION Rect Font::font_bbox()
{
	fz_rect temp = mupdf::font_bbox(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for fz_font_descender(). */
FZ_FUNCTION float Font::font_descender()
{
	return mupdf::font_descender(this->m_internal);
}

/* Wrapper for fz_font_digest(). */
FZ_FUNCTION void Font::font_digest(unsigned char digest[16])
{
	return mupdf::font_digest(this->m_internal, digest);
}

/* Wrapper for fz_font_flags(). */
FZ_FUNCTION FontFlagsT Font::font_flags()
{
	fz_font_flags_t* temp = mupdf::font_flags(this->m_internal);
	return FontFlagsT(temp);
}

/* Wrapper for fz_font_ft_face(). */
FZ_FUNCTION void *Font::font_ft_face()
{
	return mupdf::font_ft_face(this->m_internal);
}

/* Wrapper for fz_font_is_bold(). */
FZ_FUNCTION int Font::font_is_bold()
{
	return mupdf::font_is_bold(this->m_internal);
}

/* Wrapper for fz_font_is_italic(). */
FZ_FUNCTION int Font::font_is_italic()
{
	return mupdf::font_is_italic(this->m_internal);
}

/* Wrapper for fz_font_is_monospaced(). */
FZ_FUNCTION int Font::font_is_monospaced()
{
	return mupdf::font_is_monospaced(this->m_internal);
}

/* Wrapper for fz_font_is_serif(). */
FZ_FUNCTION int Font::font_is_serif()
{
	return mupdf::font_is_serif(this->m_internal);
}

/* Wrapper for fz_font_name(). */
FZ_FUNCTION const char *Font::font_name()
{
	return mupdf::font_name(this->m_internal);
}

/* Wrapper for fz_font_shaper_data(). */
FZ_FUNCTION ShaperDataT Font::font_shaper_data()
{
	fz_shaper_data_t* temp = mupdf::font_shaper_data(this->m_internal);
	return ShaperDataT(temp);
}

/* Wrapper for fz_font_t3_procs(). */
FZ_FUNCTION fz_buffer **Font::font_t3_procs()
{
	return mupdf::font_t3_procs(this->m_internal);
}

/* Wrapper for fz_get_glyph_name(). */
FZ_FUNCTION void Font::get_glyph_name(int glyph, char *buf, int size)
{
	return mupdf::get_glyph_name(this->m_internal, glyph, buf, size);
}

/* Wrapper for fz_glyph_cacheable(). */
FZ_FUNCTION int Font::glyph_cacheable(int gid)
{
	return mupdf::glyph_cacheable(this->m_internal, gid);
}

/* Wrapper for fz_measure_string(). */
FZ_FUNCTION Matrix Font::measure_string(Matrix& trm, const char *s, int wmode, int bidi_level, fz_bidi_direction markup_dir, fz_text_language language)
{
	fz_matrix temp = mupdf::measure_string(this->m_internal, *(fz_matrix*) &trm.a, s, wmode, bidi_level, markup_dir, language);
	return Matrix(&temp);
}

/* Wrapper for fz_outline_glyph(). */
FZ_FUNCTION Path Font::outline_glyph(int gid, Matrix& ctm)
{
	fz_path* temp = mupdf::outline_glyph(this->m_internal, gid, *(fz_matrix*) &ctm.a);
	return Path(temp);
}

/* Wrapper for fz_prepare_t3_glyph(). */
FZ_FUNCTION void Font::prepare_t3_glyph(int gid)
{
	return mupdf::prepare_t3_glyph(this->m_internal, gid);
}

/* Wrapper for fz_render_glyph_pixmap(). */
FZ_FUNCTION Pixmap Font::render_glyph_pixmap(int gid, Matrix& ctm, Irect& scissor, int aa)
{
	fz_pixmap* temp = mupdf::render_glyph_pixmap(this->m_internal, gid, (fz_matrix *) &ctm.a, (const fz_irect *) &scissor.x0, aa);
	return Pixmap(temp);
}

/* Wrapper for fz_run_t3_glyph(). */
FZ_FUNCTION void Font::run_t3_glyph(int gid, Matrix& trm, const Device& dev)
{
	return mupdf::run_t3_glyph(this->m_internal, gid, *(fz_matrix*) &trm.a, dev.m_internal);
}

/* Wrapper for fz_set_font_bbox(). */
FZ_FUNCTION void Font::set_font_bbox(float xmin, float ymin, float xmax, float ymax)
{
	return mupdf::set_font_bbox(this->m_internal, xmin, ymin, xmax, ymax);
}

/* Wrapper for pdf_font_writing_supported(). */
FZ_FUNCTION int Font::pdf_font_writing_supported()
{
	return mupdf::ppdf_font_writing_supported(this->m_internal);
}

/* Wrapper for pdf_layout_fit_text(). */
FZ_FUNCTION Text Font::pdf_layout_fit_text(fz_text_language lang, const char *str, Rect& bounds)
{
	fz_text* temp = mupdf::ppdf_layout_fit_text(this->m_internal, lang, str, *(fz_rect*) &bounds.x0);
	return Text(temp);
}

FZ_FUNCTION Font::Font(fz_font* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Font::~Font()
{
	mupdf::drop_font(m_internal);
}


/* Implementation of methods for FontContext (wrapper for fz_font_context). */

FZ_FUNCTION FontContext::FontContext(fz_font_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for FontFlagsT (wrapper for fz_font_flags_t). */

FZ_FUNCTION FontFlagsT::FontFlagsT(fz_font_flags_t* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Glyph (wrapper for fz_glyph). */

/* Copy constructor using fz_keep_glyph(). */
FZ_FUNCTION Glyph::Glyph(const Glyph& rhs)
: m_internal(mupdf::keep_glyph(rhs.m_internal))
{
}

/* operator= using fz_keep_glyph() and fz_drop_glyph(). */
FZ_FUNCTION Glyph& Glyph::operator=(const Glyph& rhs)
{
	mupdf::drop_glyph(this->m_internal);
	mupdf::keep_glyph(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_glyph_bbox(). */
FZ_FUNCTION Irect Glyph::glyph_bbox()
{
	fz_irect temp = mupdf::glyph_bbox(this->m_internal);
	return Irect(&temp);
}

/* Wrapper for fz_glyph_bbox_no_ctx(). */
FZ_FUNCTION Irect Glyph::glyph_bbox_no_ctx()
{
	fz_irect temp = mupdf::glyph_bbox_no_ctx(this->m_internal);
	return Irect(&temp);
}

/* Wrapper for fz_glyph_height(). */
FZ_FUNCTION int Glyph::glyph_height()
{
	return mupdf::glyph_height(this->m_internal);
}

/* Wrapper for fz_glyph_width(). */
FZ_FUNCTION int Glyph::glyph_width()
{
	return mupdf::glyph_width(this->m_internal);
}

FZ_FUNCTION Glyph::Glyph(fz_glyph* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Glyph::~Glyph()
{
	mupdf::drop_glyph(m_internal);
}


/* Implementation of methods for GlyphCache (wrapper for fz_glyph_cache). */

FZ_FUNCTION GlyphCache::GlyphCache(fz_glyph_cache* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Halftone (wrapper for fz_halftone). */

/* Copy constructor using fz_keep_halftone(). */
FZ_FUNCTION Halftone::Halftone(const Halftone& rhs)
: m_internal(mupdf::keep_halftone(rhs.m_internal))
{
}

/* operator= using fz_keep_halftone() and fz_drop_halftone(). */
FZ_FUNCTION Halftone& Halftone::operator=(const Halftone& rhs)
{
	mupdf::drop_halftone(this->m_internal);
	mupdf::keep_halftone(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

FZ_FUNCTION Halftone::Halftone(fz_halftone* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Halftone::~Halftone()
{
	mupdf::drop_halftone(m_internal);
}


/* Implementation of methods for HashTable (wrapper for fz_hash_table). */

/* Constructor using fz_new_hash_table(). */
FZ_FUNCTION HashTable::HashTable(int initialsize, int keylen, int lock, fz_hash_table_drop_fn *drop_val)
{
	this->m_internal = mupdf::new_hash_table(initialsize, keylen, lock, drop_val);
}

/* Wrapper for fz_hash_filter(). */
FZ_FUNCTION void HashTable::hash_filter(void *state, fz_hash_table_filter_fn *callback)
{
	return mupdf::hash_filter(this->m_internal, state, callback);
}

/* Wrapper for fz_hash_find(). */
FZ_FUNCTION void *HashTable::hash_find(const void *key)
{
	return mupdf::hash_find(this->m_internal, key);
}

/* Wrapper for fz_hash_for_each(). */
FZ_FUNCTION void HashTable::hash_for_each(void *state, fz_hash_table_for_each_fn *callback)
{
	return mupdf::hash_for_each(this->m_internal, state, callback);
}

/* Wrapper for fz_hash_insert(). */
FZ_FUNCTION void *HashTable::hash_insert(const void *key, void *val)
{
	return mupdf::hash_insert(this->m_internal, key, val);
}

/* Wrapper for fz_hash_remove(). */
FZ_FUNCTION void HashTable::hash_remove(const void *key)
{
	return mupdf::hash_remove(this->m_internal, key);
}

FZ_FUNCTION HashTable::HashTable(fz_hash_table* internal)
: m_internal(internal)
{
}

FZ_FUNCTION HashTable::~HashTable()
{
	mupdf::drop_hash_table(m_internal);
}


/* Implementation of methods for IccProfile (wrapper for fz_icc_profile). */

FZ_FUNCTION IccProfile::IccProfile(fz_icc_profile* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Image (wrapper for fz_image). */

/* Constructor using fz_new_image_from_buffer(). */
FZ_FUNCTION Image::Image(const Buffer& buffer)
{
	this->m_internal = mupdf::new_image_from_buffer(buffer.m_internal);
}

/* Constructor using fz_new_image_from_compressed_buffer(). */
FZ_FUNCTION Image::Image(int w, int h, int bpc, const Colorspace& colorspace, int xres, int yres, int interpolate, int imagemask, float *decode, int *colorkey, const CompressedBuffer& buffer, const Image& mask)
{
	this->m_internal = mupdf::new_image_from_compressed_buffer(w, h, bpc, colorspace.m_internal, xres, yres, interpolate, imagemask, decode, colorkey, buffer.m_internal, mask.m_internal);
}

/* Constructor using fz_new_image_from_display_list(). */
FZ_FUNCTION Image::Image(float w, float h, const DisplayList& list)
{
	this->m_internal = mupdf::new_image_from_display_list(w, h, list.m_internal);
}

/* Constructor using fz_new_image_from_file(). */
FZ_FUNCTION Image::Image(const char *path)
{
	this->m_internal = mupdf::new_image_from_file(path);
}

/* Constructor using fz_new_image_from_pixmap(). */
FZ_FUNCTION Image::Image(const Pixmap& pixmap, const Image& mask)
{
	this->m_internal = mupdf::new_image_from_pixmap(pixmap.m_internal, mask.m_internal);
}

/* Constructor using fz_new_image_from_svg(). */
FZ_FUNCTION Image::Image(const Buffer& buf, const char *base_uri, const Archive& zip)
{
	this->m_internal = mupdf::new_image_from_svg(buf.m_internal, base_uri, zip.m_internal);
}

/* Constructor using fz_new_image_from_svg_xml(). */
FZ_FUNCTION Image::Image(const XmlDoc& xmldoc, const Xml& xml, const char *base_uri, const Archive& zip)
{
	this->m_internal = mupdf::new_image_from_svg_xml(xmldoc.m_internal, xml.m_internal, base_uri, zip.m_internal);
}

/* Constructor using fz_new_image_of_size(). */
FZ_FUNCTION Image::Image(int w, int h, int bpc, const Colorspace& colorspace, int xres, int yres, int interpolate, int imagemask, float *decode, int *colorkey, const Image& mask, size_t size, fz_image_get_pixmap_fn *get_pixmap, fz_image_get_size_fn *get_size, fz_drop_image_fn *drop)
{
	this->m_internal = mupdf::new_image_of_size(w, h, bpc, colorspace.m_internal, xres, yres, interpolate, imagemask, decode, colorkey, mask.m_internal, size, get_pixmap, get_size, drop);
}

/* Copy constructor using fz_keep_image(). */
FZ_FUNCTION Image::Image(const Image& rhs)
: m_internal(mupdf::keep_image(rhs.m_internal))
{
}

/* operator= using fz_keep_image() and fz_drop_image(). */
FZ_FUNCTION Image& Image::operator=(const Image& rhs)
{
	mupdf::drop_image(this->m_internal);
	mupdf::keep_image(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_compressed_image_buffer(). */
FZ_FUNCTION CompressedBuffer Image::compressed_image_buffer()
{
	fz_compressed_buffer* temp = mupdf::compressed_image_buffer(this->m_internal);
	return CompressedBuffer(temp);
}

/* Wrapper for fz_get_pixmap_from_image(). */
FZ_FUNCTION Pixmap Image::get_pixmap_from_image(Irect& subarea, Matrix& ctm, int *w, int *h)
{
	fz_pixmap* temp = mupdf::get_pixmap_from_image(this->m_internal, (const fz_irect *) &subarea.x0, (fz_matrix *) &ctm.a, w, h);
	return Pixmap(temp);
}

/* Wrapper for fz_get_unscaled_pixmap_from_image(). */
FZ_FUNCTION Pixmap Image::get_unscaled_pixmap_from_image()
{
	fz_pixmap* temp = mupdf::get_unscaled_pixmap_from_image(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_image_orientation(). */
FZ_FUNCTION uint8_t Image::image_orientation()
{
	return mupdf::image_orientation(this->m_internal);
}

/* Wrapper for fz_image_orientation_matrix(). */
FZ_FUNCTION Matrix Image::image_orientation_matrix()
{
	fz_matrix temp = mupdf::image_orientation_matrix(this->m_internal);
	return Matrix(&temp);
}

/* Wrapper for fz_image_resolution(). */
FZ_FUNCTION void Image::image_resolution(int *xres, int *yres)
{
	return mupdf::image_resolution(this->m_internal, xres, yres);
}

/* Wrapper for fz_image_size(). */
FZ_FUNCTION size_t Image::image_size()
{
	return mupdf::image_size(this->m_internal);
}

/* Wrapper for fz_new_buffer_from_image_as_png(). */
FZ_FUNCTION Buffer Image::new_buffer_from_image_as_png(ColorParams& color_params)
{
	fz_buffer* temp = mupdf::new_buffer_from_image_as_png(this->m_internal, *(fz_color_params*) &color_params.ri);
	return Buffer(temp);
}

FZ_FUNCTION Image::Image(fz_image* internal)
: m_internal(internal)
{
}

FZ_FUNCTION fz_key_storable Image::key_storable()
{
	return m_internal->key_storable;
}

FZ_FUNCTION int Image::w()
{
	return m_internal->w;
}

FZ_FUNCTION int Image::h()
{
	return m_internal->h;
}

FZ_FUNCTION int Image::n()
{
	return m_internal->n;
}

FZ_FUNCTION int Image::bpc()
{
	return m_internal->bpc;
}

FZ_FUNCTION unsigned int Image::imagemask()
{
	return m_internal->imagemask;
}

FZ_FUNCTION unsigned int Image::interpolate()
{
	return m_internal->interpolate;
}

FZ_FUNCTION unsigned int Image::use_colorkey()
{
	return m_internal->use_colorkey;
}

FZ_FUNCTION unsigned int Image::use_decode()
{
	return m_internal->use_decode;
}

FZ_FUNCTION unsigned int Image::invert_cmyk_jpeg()
{
	return m_internal->invert_cmyk_jpeg;
}

FZ_FUNCTION unsigned int Image::decoded()
{
	return m_internal->decoded;
}

FZ_FUNCTION unsigned int Image::scalable()
{
	return m_internal->scalable;
}

FZ_FUNCTION int Image::orientation()
{
	return m_internal->orientation;
}

FZ_FUNCTION Image Image::mask()
{
	mupdf::keep_image(m_internal->mask);
	return m_internal->mask;
}

FZ_FUNCTION int Image::xres()
{
	return m_internal->xres;
}

FZ_FUNCTION int Image::yres()
{
	return m_internal->yres;
}

FZ_FUNCTION Colorspace Image::colorspace()
{
	mupdf::keep_colorspace(m_internal->colorspace);
	return m_internal->colorspace;
}

FZ_FUNCTION int * Image::colorkey()
{
	return m_internal->colorkey;
}

FZ_FUNCTION float * Image::decode()
{
	return m_internal->decode;
}

FZ_FUNCTION Image::~Image()
{
	mupdf::drop_image(m_internal);
}


/* Implementation of methods for Irect (wrapper for fz_irect). */

/* Constructor using fz_irect_from_rect(). */
FZ_FUNCTION Irect::Irect(Rect& rect)
{
	*(fz_irect*) &this->x0 = mupdf::irect_from_rect(*(fz_rect*) &rect.x0);
}

/* Constructor using fz_make_irect(). */
FZ_FUNCTION Irect::Irect(int x0, int y0, int x1, int y1)
{
	*(fz_irect*) &this->x0 = mupdf::make_irect(x0, y0, x1, y1);
}

/* Wrapper for fz_expand_irect(). */
FZ_FUNCTION Irect Irect::expand_irect(int expand)
{
	fz_irect temp = mupdf::expand_irect(*(fz_irect*) &this->x0, expand);
	return Irect(&temp);
}

/* Wrapper for fz_intersect_irect(). */
FZ_FUNCTION Irect Irect::intersect_irect(Irect& b)
{
	fz_irect temp = mupdf::intersect_irect(*(fz_irect*) &this->x0, *(fz_irect*) &b.x0);
	return Irect(&temp);
}

/* Wrapper for fz_irect_height(). */
FZ_FUNCTION int Irect::irect_height()
{
	return mupdf::irect_height(*(fz_irect*) &this->x0);
}

/* Wrapper for fz_irect_width(). */
FZ_FUNCTION unsigned int Irect::irect_width()
{
	return mupdf::irect_width(*(fz_irect*) &this->x0);
}

/* Wrapper for fz_is_empty_irect(). */
FZ_FUNCTION int Irect::is_empty_irect()
{
	return mupdf::is_empty_irect(*(fz_irect*) &this->x0);
}

/* Wrapper for fz_is_infinite_irect(). */
FZ_FUNCTION int Irect::is_infinite_irect()
{
	return mupdf::is_infinite_irect(*(fz_irect*) &this->x0);
}

/* Wrapper for fz_is_valid_irect(). */
FZ_FUNCTION int Irect::is_valid_irect()
{
	return mupdf::is_valid_irect(*(fz_irect*) &this->x0);
}

/* Wrapper for fz_rect_from_irect(). */
FZ_FUNCTION Rect Irect::rect_from_irect()
{
	fz_rect temp = mupdf::rect_from_irect(*(fz_irect*) &this->x0);
	return Rect(&temp);
}

/* Wrapper for fz_translate_irect(). */
FZ_FUNCTION Irect Irect::translate_irect(int xoff, int yoff)
{
	fz_irect temp = mupdf::translate_irect(*(fz_irect*) &this->x0, xoff, yoff);
	return Irect(&temp);
}

FZ_FUNCTION Irect::Irect(const fz_irect* internal)
{
	this->x0 = internal->x0;
	this->y0 = internal->y0;
	this->x1 = internal->x1;
	this->y1 = internal->y1;
}

FZ_FUNCTION Irect::Irect(const fz_irect internal)
{
	this->x0 = internal.x0;
	this->y0 = internal.y0;
	this->x1 = internal.x1;
	this->y1 = internal.y1;
}

/* Constructor using raw copy of pre-existing fz_irect. */
FZ_FUNCTION fz_irect* Irect::internal()
{
	return (fz_irect*) &this->x0;
}

/* Constructor using raw copy of pre-existing fz_irect. */
FZ_FUNCTION const fz_irect* Irect::internal() const
{
	return (const fz_irect*) &this->x0;
}

FZ_FUNCTION std::string Irect::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Irect& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Jbig2Globals (wrapper for fz_jbig2_globals). */

/* Copy constructor using fz_keep_jbig2_globals(). */
FZ_FUNCTION Jbig2Globals::Jbig2Globals(const Jbig2Globals& rhs)
: m_internal(mupdf::keep_jbig2_globals(rhs.m_internal))
{
}

/* operator= using fz_keep_jbig2_globals() and fz_drop_jbig2_globals(). */
FZ_FUNCTION Jbig2Globals& Jbig2Globals::operator=(const Jbig2Globals& rhs)
{
	mupdf::drop_jbig2_globals(this->m_internal);
	mupdf::keep_jbig2_globals(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_jbig2_globals_data(). */
FZ_FUNCTION Buffer Jbig2Globals::jbig2_globals_data()
{
	fz_buffer* temp = mupdf::jbig2_globals_data(this->m_internal);
	return Buffer(temp);
}

FZ_FUNCTION Jbig2Globals::Jbig2Globals(fz_jbig2_globals* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Jbig2Globals::~Jbig2Globals()
{
	mupdf::drop_jbig2_globals(m_internal);
}


/* Implementation of methods for KeyStorable (wrapper for fz_key_storable). */

/* Copy constructor using fz_keep_key_storable(). */
FZ_FUNCTION KeyStorable::KeyStorable(const KeyStorable& rhs)
: m_internal((fz_key_storable*) mupdf::keep_key_storable(rhs.m_internal))
{
}

/* operator= using fz_keep_key_storable() and fz_drop_key_storable(). */
FZ_FUNCTION KeyStorable& KeyStorable::operator=(const KeyStorable& rhs)
{
	mupdf::drop_key_storable(this->m_internal);
	mupdf::keep_key_storable(rhs.m_internal);
	this->m_internal = (fz_key_storable*) rhs.m_internal;
	return *this;
}

FZ_FUNCTION KeyStorable::KeyStorable(fz_key_storable* internal)
: m_internal(internal)
{
}

FZ_FUNCTION KeyStorable::~KeyStorable()
{
	mupdf::drop_key_storable(m_internal);
}


/* Implementation of methods for LayoutBlock (wrapper for fz_layout_block). */

/* Constructor using fz_new_layout(). */
FZ_FUNCTION LayoutBlock::LayoutBlock()
{
	this->m_internal = mupdf::new_layout();
}

/* Wrapper for fz_add_layout_char(). */
FZ_FUNCTION void LayoutBlock::add_layout_char(float x, float w, const char *p)
{
	return mupdf::add_layout_char(this->m_internal, x, w, p);
}

/* Wrapper for fz_add_layout_line(). */
FZ_FUNCTION void LayoutBlock::add_layout_line(float x, float y, float h, const char *p)
{
	return mupdf::add_layout_line(this->m_internal, x, y, h, p);
}

FZ_FUNCTION LayoutBlock::LayoutBlock(fz_layout_block* internal)
: m_internal(internal)
{
}


/* Implementation of methods for LayoutChar (wrapper for fz_layout_char). */

FZ_FUNCTION LayoutChar::LayoutChar(fz_layout_char* internal)
: m_internal(internal)
{
}


/* Implementation of methods for LayoutLine (wrapper for fz_layout_line). */

FZ_FUNCTION LayoutLine::LayoutLine(fz_layout_line* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Link (wrapper for fz_link). */

/* Constructor using fz_new_link(). */
FZ_FUNCTION Link::Link(Rect& bbox, const char *uri)
{
	this->m_internal = mupdf::new_link(*(fz_rect*) &bbox.x0, uri);
}

/* Copy constructor using fz_keep_link(). */
FZ_FUNCTION Link::Link(const Link& rhs)
: m_internal(mupdf::keep_link(rhs.m_internal))
{
}

/* operator= using fz_keep_link() and fz_drop_link(). */
FZ_FUNCTION Link& Link::operator=(const Link& rhs)
{
	mupdf::drop_link(this->m_internal);
	mupdf::keep_link(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Custom method. */
FZ_FUNCTION LinkIterator Link::begin()
{
	return LinkIterator(m_internal);
}

/* Custom method. */
FZ_FUNCTION LinkIterator Link::end()
{
	return LinkIterator(NULL);
}

FZ_FUNCTION Link::Link(fz_link* internal)
: m_internal(internal)
{
}

FZ_FUNCTION int Link::refs()
{
	return m_internal->refs;
}

FZ_FUNCTION Link Link::next()
{
	mupdf::keep_link(m_internal->next);
	return m_internal->next;
}

FZ_FUNCTION fz_rect Link::rect()
{
	return m_internal->rect;
}

FZ_FUNCTION const char *Link::uri()
{
	return m_internal->uri;
}

FZ_FUNCTION Link::~Link()
{
	mupdf::drop_link(m_internal);
}


FZ_FUNCTION LinkIterator::LinkIterator(const Link& item)
: m_item( item)
{
}
FZ_FUNCTION LinkIterator& LinkIterator::operator++()
{
	mupdf::keep_link(m_item.m_internal->next);
	m_item = Link(m_item.m_internal->next);
	return *this;
}
FZ_FUNCTION bool LinkIterator::operator==( const LinkIterator& rhs)
{
	return m_item.m_internal == rhs.m_item.m_internal;
}
FZ_FUNCTION bool LinkIterator::operator!=( const LinkIterator& rhs)
{
	return m_item.m_internal != rhs.m_item.m_internal;
}
FZ_FUNCTION Link LinkIterator::operator*()
{
	return m_item;
}
FZ_FUNCTION Link* LinkIterator::operator->()
{
	return &m_item;
}

void test(Link& item)
{
	for( LinkIterator it = item.begin(); it != item.end(); ++it) {
		(void) *it;
	}
	for ( auto i: item) {
		(void) i;
	}
}


/* Implementation of methods for Location (wrapper for fz_location). */

/* Constructor using fz_make_location(). */
FZ_FUNCTION Location::Location(int chapter, int page)
{
	*(fz_location*) &this->chapter = mupdf::make_location(chapter, page);
}

FZ_FUNCTION Location::Location(const fz_location* internal)
{
	this->chapter = internal->chapter;
	this->page = internal->page;
}

FZ_FUNCTION Location::Location(const fz_location internal)
{
	this->chapter = internal.chapter;
	this->page = internal.page;
}

/* Constructor using raw copy of pre-existing fz_location. */
FZ_FUNCTION fz_location* Location::internal()
{
	return (fz_location*) &this->chapter;
}

/* Constructor using raw copy of pre-existing fz_location. */
FZ_FUNCTION const fz_location* Location::internal() const
{
	return (const fz_location*) &this->chapter;
}

FZ_FUNCTION std::string Location::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Location& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for LocksContext (wrapper for fz_locks_context). */

FZ_FUNCTION LocksContext::LocksContext(fz_locks_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Matrix (wrapper for fz_matrix). */

/* Constructor using fz_make_matrix(). */
FZ_FUNCTION Matrix::Matrix(float a, float b, float c, float d, float e, float f)
{
	*(fz_matrix*) &this->a = mupdf::make_matrix(a, b, c, d, e, f);
}

/* Custom constructor. */
FZ_FUNCTION Matrix::Matrix()
: a(1), b(0), c(0), d(1), e(0), f(0)
{
}

/* Wrapper for fz_concat(). */
FZ_FUNCTION Matrix Matrix::concat(Matrix& left, Matrix& right)
{
	fz_matrix temp = mupdf::concat(*(fz_matrix*) &left.a, *(fz_matrix*) &right.a);
	return Matrix(&temp);
}

/* Wrapper for fz_scale(). */
FZ_FUNCTION Matrix Matrix::scale(float sx, float sy)
{
	fz_matrix temp = mupdf::scale(sx, sy);
	return Matrix(&temp);
}

/* Wrapper for fz_shear(). */
FZ_FUNCTION Matrix Matrix::shear(float sx, float sy)
{
	fz_matrix temp = mupdf::shear(sx, sy);
	return Matrix(&temp);
}

/* Wrapper for fz_rotate(). */
FZ_FUNCTION Matrix Matrix::rotate(float degrees)
{
	fz_matrix temp = mupdf::rotate(degrees);
	return Matrix(&temp);
}

/* Wrapper for fz_translate(). */
FZ_FUNCTION Matrix Matrix::translate(float tx, float ty)
{
	fz_matrix temp = mupdf::translate(tx, ty);
	return Matrix(&temp);
}

/* Wrapper for fz_transform_page(). */
FZ_FUNCTION Matrix Matrix::transform_page(Rect& mediabox, float resolution, float rotate)
{
	fz_matrix temp = mupdf::transform_page(*(fz_rect*) &mediabox.x0, resolution, rotate);
	return Matrix(&temp);
}

/* Wrapper for fz_concat(). */
FZ_FUNCTION Matrix Matrix::concat(Matrix& right)
{
	fz_matrix temp = mupdf::concat(*(fz_matrix*) &this->a, *(fz_matrix*) &right.a);
	return Matrix(&temp);
}

/* Wrapper for fz_invert_matrix(). */
FZ_FUNCTION Matrix Matrix::invert_matrix()
{
	fz_matrix temp = mupdf::invert_matrix(*(fz_matrix*) &this->a);
	return Matrix(&temp);
}

/* Wrapper for fz_is_identity(). */
FZ_FUNCTION int Matrix::is_identity()
{
	return mupdf::is_identity(*(fz_matrix*) &this->a);
}

/* Wrapper for fz_is_rectilinear(). */
FZ_FUNCTION int Matrix::is_rectilinear()
{
	return mupdf::is_rectilinear(*(fz_matrix*) &this->a);
}

/* Wrapper for fz_matrix_expansion(). */
FZ_FUNCTION float Matrix::matrix_expansion()
{
	return mupdf::matrix_expansion(*(fz_matrix*) &this->a);
}

/* Wrapper for fz_matrix_max_expansion(). */
FZ_FUNCTION float Matrix::matrix_max_expansion()
{
	return mupdf::matrix_max_expansion(*(fz_matrix*) &this->a);
}

/* Wrapper for fz_post_scale(). */
FZ_FUNCTION Matrix Matrix::post_scale(float sx, float sy)
{
	fz_matrix temp = mupdf::post_scale(*(fz_matrix*) &this->a, sx, sy);
	return Matrix(&temp);
}

/* Wrapper for fz_pre_rotate(). */
FZ_FUNCTION Matrix Matrix::pre_rotate(float degrees)
{
	fz_matrix temp = mupdf::pre_rotate(*(fz_matrix*) &this->a, degrees);
	return Matrix(&temp);
}

/* Wrapper for fz_pre_scale(). */
FZ_FUNCTION Matrix Matrix::pre_scale(float sx, float sy)
{
	fz_matrix temp = mupdf::pre_scale(*(fz_matrix*) &this->a, sx, sy);
	return Matrix(&temp);
}

/* Wrapper for fz_pre_shear(). */
FZ_FUNCTION Matrix Matrix::pre_shear(float sx, float sy)
{
	fz_matrix temp = mupdf::pre_shear(*(fz_matrix*) &this->a, sx, sy);
	return Matrix(&temp);
}

/* Wrapper for fz_pre_translate(). */
FZ_FUNCTION Matrix Matrix::pre_translate(float tx, float ty)
{
	fz_matrix temp = mupdf::pre_translate(*(fz_matrix*) &this->a, tx, ty);
	return Matrix(&temp);
}

/* Wrapper for fz_subpixel_adjust(). */
FZ_FUNCTION float Matrix::subpixel_adjust(Matrix& subpix_ctm, unsigned char *qe, unsigned char *qf)
{
	return mupdf::subpixel_adjust((fz_matrix *) &this->a, (fz_matrix *) &subpix_ctm.a, qe, qf);
}

/* Wrapper for fz_try_invert_matrix(). */
FZ_FUNCTION int Matrix::try_invert_matrix(Matrix& src)
{
	return mupdf::try_invert_matrix((fz_matrix *) &this->a, *(fz_matrix*) &src.a);
}

FZ_FUNCTION Matrix::Matrix(const fz_matrix* internal)
{
	this->a = internal->a;
	this->b = internal->b;
	this->c = internal->c;
	this->d = internal->d;
	this->e = internal->e;
	this->f = internal->f;
}

FZ_FUNCTION Matrix::Matrix(const fz_matrix internal)
{
	this->a = internal.a;
	this->b = internal.b;
	this->c = internal.c;
	this->d = internal.d;
	this->e = internal.e;
	this->f = internal.f;
}

/* Constructor using raw copy of pre-existing fz_matrix. */
FZ_FUNCTION fz_matrix* Matrix::internal()
{
	return (fz_matrix*) &this->a;
}

/* Constructor using raw copy of pre-existing fz_matrix. */
FZ_FUNCTION const fz_matrix* Matrix::internal() const
{
	return (const fz_matrix*) &this->a;
}

FZ_FUNCTION std::string Matrix::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Matrix& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Md5 (wrapper for fz_md5). */

/* Wrapper for fz_md5_final(). */
FZ_FUNCTION void Md5::md5_final(unsigned char digest[16])
{
	return mupdf::md5_final(this->m_internal, digest);
}

/* Wrapper for fz_md5_init(). */
FZ_FUNCTION void Md5::md5_init()
{
	return mupdf::md5_init(this->m_internal);
}

/* Wrapper for fz_md5_update(). */
FZ_FUNCTION void Md5::md5_update(const unsigned char *input, size_t inlen)
{
	return mupdf::md5_update(this->m_internal, input, inlen);
}

/* Wrapper for fz_md5_update_int64(). */
FZ_FUNCTION void Md5::md5_update_int64(int64_t i)
{
	return mupdf::md5_update_int64(this->m_internal, i);
}

FZ_FUNCTION Md5::Md5(fz_md5* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Outline (wrapper for fz_outline). */

/* Constructor using fz_load_outline(). */
FZ_FUNCTION Outline::Outline(const Document& doc)
{
	this->m_internal = mupdf::load_outline(doc.m_internal);
}

/* Constructor using fz_new_outline(). */
FZ_FUNCTION Outline::Outline()
{
	this->m_internal = mupdf::new_outline();
}

/* Copy constructor using fz_keep_outline(). */
FZ_FUNCTION Outline::Outline(const Outline& rhs)
: m_internal(mupdf::keep_outline(rhs.m_internal))
{
}

/* operator= using fz_keep_outline() and fz_drop_outline(). */
FZ_FUNCTION Outline& Outline::operator=(const Outline& rhs)
{
	mupdf::drop_outline(this->m_internal);
	mupdf::keep_outline(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Custom method. */
FZ_FUNCTION OutlineIterator Outline::begin()
{
	return OutlineIterator(*this);
}

/* Custom method. */
FZ_FUNCTION OutlineIterator Outline::end()
{
	return OutlineIterator();
}

FZ_FUNCTION Outline::Outline(fz_outline* internal)
: m_internal(internal)
{
}

FZ_FUNCTION int Outline::refs()
{
	return m_internal->refs;
}

FZ_FUNCTION const char *Outline::title()
{
	return m_internal->title;
}

FZ_FUNCTION const char *Outline::uri()
{
	return m_internal->uri;
}

FZ_FUNCTION int Outline::page()
{
	return m_internal->page;
}

FZ_FUNCTION float Outline::x()
{
	return m_internal->x;
}

FZ_FUNCTION float Outline::y()
{
	return m_internal->y;
}

FZ_FUNCTION Outline Outline::next()
{
	mupdf::keep_outline(m_internal->next);
	return m_internal->next;
}

FZ_FUNCTION Outline Outline::down()
{
	mupdf::keep_outline(m_internal->down);
	return m_internal->down;
}

FZ_FUNCTION int Outline::is_open()
{
	return m_internal->is_open;
}

FZ_FUNCTION Outline::~Outline()
{
	mupdf::drop_outline(m_internal);
}


FZ_FUNCTION OutlineIterator::OutlineIterator(const Outline& item)
: m_outline(item), m_depth(0)
{
}
FZ_FUNCTION OutlineIterator::OutlineIterator()
: m_outline(NULL)
{
}
FZ_FUNCTION OutlineIterator& OutlineIterator::operator++()
{
	if (m_outline.m_internal->down)
	{
		m_up.push_back(m_outline.m_internal);
		mupdf::keep_outline(m_outline.m_internal->down);
		m_outline = Outline(m_outline.m_internal->down);
		m_depth += 1;
	}
	else if (m_outline.m_internal->next)
	{
		mupdf::keep_outline(m_outline.m_internal->next);
		m_outline = Outline(m_outline.m_internal->next);
	}
	else
	{
		/* Go up and across in the tree. */
		for(;;)
		{
			if (m_up.empty())
			{
				m_outline = Outline(NULL);
				assert(m_depth == 0);
				break;
			}
			fz_outline* p = m_up.back();
			m_up.pop_back();
			m_depth -= 1;
			if (p->next)
			{
				mupdf::keep_outline(p->next);
				m_outline = Outline(p->next);
				break;
			}
		}
	}
	return *this;
}
FZ_FUNCTION bool OutlineIterator::operator==(const OutlineIterator& rhs)
{
	bool ret = m_outline.m_internal == rhs.m_outline.m_internal;
	return ret;
}
FZ_FUNCTION bool OutlineIterator::operator!=(const OutlineIterator& rhs)
{
	return m_outline.m_internal != rhs.m_outline.m_internal;
}
FZ_FUNCTION OutlineIterator& OutlineIterator::operator*()
{
	return *this;
}
FZ_FUNCTION OutlineIterator* OutlineIterator::operator->()
{
	return this;
}

void test(Outline& item)
{
	for( OutlineIterator it = item.begin(); it != item.end(); ++it)
	{
		(void) *it;
	}
	for (auto i: item)
	{
		(void) i;
	}
}


/* Implementation of methods for Output (wrapper for fz_output). */

/* Constructor using fz_new_arc4_output(). */
FZ_FUNCTION Output::Output(const Output& chain, unsigned char *key, size_t keylen)
{
	this->m_internal = mupdf::new_arc4_output(chain.m_internal, key, keylen);
}

/* Constructor using fz_new_deflate_output(). */
FZ_FUNCTION Output::Output(const Output& chain, int effort, int raw)
{
	this->m_internal = mupdf::new_deflate_output(chain.m_internal, effort, raw);
}

/* Constructor using fz_new_log_for_module(). */
FZ_FUNCTION Output::Output(const char *module)
{
	this->m_internal = mupdf::new_log_for_module(module);
}

/* Constructor using fz_new_output(). */
FZ_FUNCTION Output::Output(int bufsiz, void *state, fz_output_write_fn *write, fz_output_close_fn *close, fz_output_drop_fn *drop)
{
	this->m_internal = mupdf::new_output(bufsiz, state, write, close, drop);
}

/* Constructor using fz_new_output_with_buffer(). */
FZ_FUNCTION Output::Output(const Buffer& buf)
{
	this->m_internal = mupdf::new_output_with_buffer(buf.m_internal);
}

/* Constructor using fz_new_output_with_path(). */
FZ_FUNCTION Output::Output(const char *filename, int append)
{
	this->m_internal = mupdf::new_output_with_path(filename, append);
}

/* Custom constructor. */
FZ_FUNCTION Output::Output(Fixed out)
{
	if (0)  {}
	else if (out == Fixed_STDOUT) {
		m_internal = mupdf::stdout_();
	}
	else if (out == Fixed_STDERR) {
		m_internal = mupdf::stderr_();
	}
	else {
		throw ErrorAbort("Unrecognised Fixed value");
	}
}

/* Custom constructor. */
FZ_FUNCTION Output::Output(const Output& chain, Filter filter)
{
	if (0)  {}
	else if (filter == Filter_HEX) {
		m_internal = mupdf::new_asciihex_output(chain.m_internal);
	}
	else if (filter == Filter_85) {
		m_internal = mupdf::new_ascii85_output(chain.m_internal);
	}
	else if (filter == Filter_RLE) {
		m_internal = mupdf::new_rle_output(chain.m_internal);
	}
	else {
		throw ErrorAbort("Unrecognised Filter value");
	}
}

/* Wrapper for fz_close_output(). */
FZ_FUNCTION void Output::close_output()
{
	return mupdf::close_output(this->m_internal);
}

/* Wrapper for fz_debug_store(). */
FZ_FUNCTION void Output::debug_store()
{
	return mupdf::debug_store(this->m_internal);
}

/* Wrapper for fz_dump_glyph_cache_stats(). */
FZ_FUNCTION void Output::dump_glyph_cache_stats()
{
	return mupdf::dump_glyph_cache_stats(this->m_internal);
}

/* Wrapper for fz_flush_output(). */
FZ_FUNCTION void Output::flush_output()
{
	return mupdf::flush_output(this->m_internal);
}

/* Wrapper for fz_new_svg_device(). */
FZ_FUNCTION Device Output::new_svg_device(float page_width, float page_height, int text_format, int reuse_images)
{
	fz_device* temp = mupdf::new_svg_device(this->m_internal, page_width, page_height, text_format, reuse_images);
	return Device(temp);
}

/* Wrapper for fz_new_svg_device_with_id(). */
FZ_FUNCTION Device Output::new_svg_device_with_id(float page_width, float page_height, int text_format, int reuse_images, int *id)
{
	fz_device* temp = mupdf::new_svg_device_with_id(this->m_internal, page_width, page_height, text_format, reuse_images, id);
	return Device(temp);
}

/* Wrapper for fz_new_trace_device(). */
FZ_FUNCTION Device Output::new_trace_device()
{
	fz_device* temp = mupdf::new_trace_device(this->m_internal);
	return Device(temp);
}

/* Wrapper for fz_new_xmltext_device(). */
FZ_FUNCTION Device Output::new_xmltext_device()
{
	fz_device* temp = mupdf::new_xmltext_device(this->m_internal);
	return Device(temp);
}

/* Wrapper for fz_new_zip_writer_with_output(). */
FZ_FUNCTION ZipWriter Output::new_zip_writer_with_output()
{
	fz_zip_writer* temp = mupdf::new_zip_writer_with_output(this->m_internal);
	return ZipWriter(temp);
}

/* Wrapper for fz_output_supports_stream(). */
FZ_FUNCTION int Output::output_supports_stream()
{
	return mupdf::output_supports_stream(this->m_internal);
}

/* Wrapper for fz_print_stext_header_as_html(). */
FZ_FUNCTION void Output::print_stext_header_as_html()
{
	return mupdf::print_stext_header_as_html(this->m_internal);
}

/* Wrapper for fz_print_stext_header_as_xhtml(). */
FZ_FUNCTION void Output::print_stext_header_as_xhtml()
{
	return mupdf::print_stext_header_as_xhtml(this->m_internal);
}

/* Wrapper for fz_print_stext_page_as_html(). */
FZ_FUNCTION void Output::print_stext_page_as_html(const StextPage& page, int id)
{
	return mupdf::print_stext_page_as_html(this->m_internal, page.m_internal, id);
}

/* Wrapper for fz_print_stext_page_as_json(). */
FZ_FUNCTION void Output::print_stext_page_as_json(const StextPage& page, float scale)
{
	return mupdf::print_stext_page_as_json(this->m_internal, page.m_internal, scale);
}

/* Wrapper for fz_print_stext_page_as_text(). */
FZ_FUNCTION void Output::print_stext_page_as_text(const StextPage& page)
{
	return mupdf::print_stext_page_as_text(this->m_internal, page.m_internal);
}

/* Wrapper for fz_print_stext_page_as_xhtml(). */
FZ_FUNCTION void Output::print_stext_page_as_xhtml(const StextPage& page, int id)
{
	return mupdf::print_stext_page_as_xhtml(this->m_internal, page.m_internal, id);
}

/* Wrapper for fz_print_stext_page_as_xml(). */
FZ_FUNCTION void Output::print_stext_page_as_xml(const StextPage& page, int id)
{
	return mupdf::print_stext_page_as_xml(this->m_internal, page.m_internal, id);
}

/* Wrapper for fz_print_stext_trailer_as_html(). */
FZ_FUNCTION void Output::print_stext_trailer_as_html()
{
	return mupdf::print_stext_trailer_as_html(this->m_internal);
}

/* Wrapper for fz_print_stext_trailer_as_xhtml(). */
FZ_FUNCTION void Output::print_stext_trailer_as_xhtml()
{
	return mupdf::print_stext_trailer_as_xhtml(this->m_internal);
}

/* Wrapper for fz_seek_output(). */
FZ_FUNCTION void Output::seek_output(int64_t off, int whence)
{
	return mupdf::seek_output(this->m_internal, off, whence);
}

/* Wrapper for fz_set_stddbg(). */
FZ_FUNCTION void Output::set_stddbg()
{
	return mupdf::set_stddbg(this->m_internal);
}

/* Wrapper for fz_stream_from_output(). */
FZ_FUNCTION Stream Output::stream_from_output()
{
	fz_stream* temp = mupdf::stream_from_output(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_tell_output(). */
FZ_FUNCTION int64_t Output::tell_output()
{
	return mupdf::tell_output(this->m_internal);
}

/* Wrapper for fz_truncate_output(). */
FZ_FUNCTION void Output::truncate_output()
{
	return mupdf::truncate_output(this->m_internal);
}

/* Wrapper for fz_write_base64(). */
FZ_FUNCTION void Output::write_base64(const unsigned char *data, size_t size, int newline)
{
	return mupdf::write_base64(this->m_internal, data, size, newline);
}

/* Wrapper for fz_write_base64_buffer(). */
FZ_FUNCTION void Output::write_base64_buffer(const Buffer& data, int newline)
{
	return mupdf::write_base64_buffer(this->m_internal, data.m_internal, newline);
}

/* Wrapper for fz_write_bitmap_as_pbm(). */
FZ_FUNCTION void Output::write_bitmap_as_pbm(const Bitmap& bitmap)
{
	return mupdf::write_bitmap_as_pbm(this->m_internal, bitmap.m_internal);
}

/* Wrapper for fz_write_bitmap_as_pcl(). */
FZ_FUNCTION void Output::write_bitmap_as_pcl(const Bitmap& bitmap, const PclOptions& pcl)
{
	return mupdf::write_bitmap_as_pcl(this->m_internal, bitmap.m_internal, pcl.m_internal);
}

/* Wrapper for fz_write_bitmap_as_pkm(). */
FZ_FUNCTION void Output::write_bitmap_as_pkm(const Bitmap& bitmap)
{
	return mupdf::write_bitmap_as_pkm(this->m_internal, bitmap.m_internal);
}

/* Wrapper for fz_write_bitmap_as_pwg(). */
FZ_FUNCTION void Output::write_bitmap_as_pwg(const Bitmap& bitmap, PwgOptions& pwg)
{
	return mupdf::write_bitmap_as_pwg(this->m_internal, bitmap.m_internal, &pwg.m_internal);
}

/* Wrapper for fz_write_bitmap_as_pwg_page(). */
FZ_FUNCTION void Output::write_bitmap_as_pwg_page(const Bitmap& bitmap, PwgOptions& pwg)
{
	return mupdf::write_bitmap_as_pwg_page(this->m_internal, bitmap.m_internal, &pwg.m_internal);
}

/* Wrapper for fz_write_byte(). */
FZ_FUNCTION void Output::write_byte(unsigned char x)
{
	return mupdf::write_byte(this->m_internal, x);
}

/* Wrapper for fz_write_char(). */
FZ_FUNCTION void Output::write_char(char x)
{
	return mupdf::write_char(this->m_internal, x);
}

/* Wrapper for fz_write_data(). */
FZ_FUNCTION void Output::write_data(const void *data, size_t size)
{
	return mupdf::write_data(this->m_internal, data, size);
}

/* Wrapper for fz_write_float_be(). */
FZ_FUNCTION void Output::write_float_be(float f)
{
	return mupdf::write_float_be(this->m_internal, f);
}

/* Wrapper for fz_write_float_le(). */
FZ_FUNCTION void Output::write_float_le(float f)
{
	return mupdf::write_float_le(this->m_internal, f);
}

/* Wrapper for fz_write_image_as_data_uri(). */
FZ_FUNCTION void Output::write_image_as_data_uri(const Image& image)
{
	return mupdf::write_image_as_data_uri(this->m_internal, image.m_internal);
}

/* Wrapper for fz_write_int16_be(). */
FZ_FUNCTION void Output::write_int16_be(int x)
{
	return mupdf::write_int16_be(this->m_internal, x);
}

/* Wrapper for fz_write_int16_le(). */
FZ_FUNCTION void Output::write_int16_le(int x)
{
	return mupdf::write_int16_le(this->m_internal, x);
}

/* Wrapper for fz_write_int32_be(). */
FZ_FUNCTION void Output::write_int32_be(int x)
{
	return mupdf::write_int32_be(this->m_internal, x);
}

/* Wrapper for fz_write_int32_le(). */
FZ_FUNCTION void Output::write_int32_le(int x)
{
	return mupdf::write_int32_le(this->m_internal, x);
}

/* Wrapper for fz_write_pixmap_as_data_uri(). */
FZ_FUNCTION void Output::write_pixmap_as_data_uri(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_data_uri(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pam(). */
FZ_FUNCTION void Output::write_pixmap_as_pam(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_pam(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pcl(). */
FZ_FUNCTION void Output::write_pixmap_as_pcl(const Pixmap& pixmap, const PclOptions& pcl)
{
	return mupdf::write_pixmap_as_pcl(this->m_internal, pixmap.m_internal, pcl.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pclm(). */
FZ_FUNCTION void Output::write_pixmap_as_pclm(const Pixmap& pixmap, const PclmOptions& options)
{
	return mupdf::write_pixmap_as_pclm(this->m_internal, pixmap.m_internal, options.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pdfocr(). */
FZ_FUNCTION void Output::write_pixmap_as_pdfocr(const Pixmap& pixmap, const PdfocrOptions& options)
{
	return mupdf::write_pixmap_as_pdfocr(this->m_internal, pixmap.m_internal, options.m_internal);
}

/* Wrapper for fz_write_pixmap_as_png(). */
FZ_FUNCTION void Output::write_pixmap_as_png(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_png(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pnm(). */
FZ_FUNCTION void Output::write_pixmap_as_pnm(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_pnm(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_ps(). */
FZ_FUNCTION void Output::write_pixmap_as_ps(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_ps(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_psd(). */
FZ_FUNCTION void Output::write_pixmap_as_psd(const Pixmap& pixmap)
{
	return mupdf::write_pixmap_as_psd(this->m_internal, pixmap.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pwg(). */
FZ_FUNCTION void Output::write_pixmap_as_pwg(const Pixmap& pixmap, PwgOptions& pwg)
{
	return mupdf::write_pixmap_as_pwg(this->m_internal, pixmap.m_internal, &pwg.m_internal);
}

/* Wrapper for fz_write_pixmap_as_pwg_page(). */
FZ_FUNCTION void Output::write_pixmap_as_pwg_page(const Pixmap& pixmap, PwgOptions& pwg)
{
	return mupdf::write_pixmap_as_pwg_page(this->m_internal, pixmap.m_internal, &pwg.m_internal);
}

/* Wrapper for fz_write_ps_file_header(). */
FZ_FUNCTION void Output::write_ps_file_header()
{
	return mupdf::write_ps_file_header(this->m_internal);
}

/* Wrapper for fz_write_ps_file_trailer(). */
FZ_FUNCTION void Output::write_ps_file_trailer(int pages)
{
	return mupdf::write_ps_file_trailer(this->m_internal, pages);
}

/* Wrapper for fz_write_pwg_file_header(). */
FZ_FUNCTION void Output::write_pwg_file_header()
{
	return mupdf::write_pwg_file_header(this->m_internal);
}

/* Wrapper for fz_write_rune(). */
FZ_FUNCTION void Output::write_rune(int rune)
{
	return mupdf::write_rune(this->m_internal, rune);
}

/* Wrapper for fz_write_string(). */
FZ_FUNCTION void Output::write_string(const char *s)
{
	return mupdf::write_string(this->m_internal, s);
}

/* Wrapper for fz_write_uint16_be(). */
FZ_FUNCTION void Output::write_uint16_be(unsigned int x)
{
	return mupdf::write_uint16_be(this->m_internal, x);
}

/* Wrapper for fz_write_uint16_le(). */
FZ_FUNCTION void Output::write_uint16_le(unsigned int x)
{
	return mupdf::write_uint16_le(this->m_internal, x);
}

/* Wrapper for fz_write_uint32_be(). */
FZ_FUNCTION void Output::write_uint32_be(unsigned int x)
{
	return mupdf::write_uint32_be(this->m_internal, x);
}

/* Wrapper for fz_write_uint32_le(). */
FZ_FUNCTION void Output::write_uint32_le(unsigned int x)
{
	return mupdf::write_uint32_le(this->m_internal, x);
}

/* Wrapper for fz_write_vprintf(). */
FZ_FUNCTION void Output::write_vprintf(const char *fmt, va_list ap)
{
	return mupdf::write_vprintf(this->m_internal, fmt, ap);
}

/* Wrapper for pdf_new_output_processor(). */
FZ_FUNCTION PdfProcessor Output::pdf_new_output_processor(int ahxencode)
{
	pdf_processor* temp = mupdf::ppdf_new_output_processor(this->m_internal, ahxencode);
	return PdfProcessor(temp);
}

/* Wrapper for pdf_print_crypt(). */
FZ_FUNCTION void Output::pdf_print_crypt(const PdfCrypt& crypt)
{
	return mupdf::ppdf_print_crypt(this->m_internal, crypt.m_internal);
}

/* Wrapper for pdf_print_encrypted_obj(). */
FZ_FUNCTION void Output::pdf_print_encrypted_obj(const PdfObj& obj, int tight, int ascii, const PdfCrypt& crypt, int num, int gen)
{
	return mupdf::ppdf_print_encrypted_obj(this->m_internal, obj.m_internal, tight, ascii, crypt.m_internal, num, gen);
}

/* Wrapper for pdf_print_font(). */
FZ_FUNCTION void Output::pdf_print_font(const PdfFontDesc& fontdesc)
{
	return mupdf::ppdf_print_font(this->m_internal, fontdesc.m_internal);
}

/* Wrapper for pdf_print_obj(). */
FZ_FUNCTION void Output::pdf_print_obj(const PdfObj& obj, int tight, int ascii)
{
	return mupdf::ppdf_print_obj(this->m_internal, obj.m_internal, tight, ascii);
}

/* Wrapper for pdf_write_digest(). */
FZ_FUNCTION void Output::pdf_write_digest(const PdfObj& byte_range, const PdfObj& field, size_t digest_offset, size_t digest_length, const PdfPkcs7Signer& signer)
{
	return mupdf::ppdf_write_digest(this->m_internal, byte_range.m_internal, field.m_internal, digest_offset, digest_length, signer.m_internal);
}

FZ_FUNCTION Output::Output(fz_output* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Output::~Output()
{
	mupdf::drop_output(m_internal);
}


/* Implementation of methods for Overprint (wrapper for fz_overprint). */

FZ_FUNCTION Overprint::Overprint(fz_overprint* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Page (wrapper for fz_page). */

/* Constructor using fz_load_chapter_page(). */
FZ_FUNCTION Page::Page(const Document& doc, int chapter, int page)
{
	this->m_internal = mupdf::load_chapter_page(doc.m_internal, chapter, page);
}

/* Constructor using fz_load_page(). */
FZ_FUNCTION Page::Page(const Document& doc, int number)
{
	this->m_internal = mupdf::load_page(doc.m_internal, number);
}

/* Constructor using fz_new_page_of_size(). */
FZ_FUNCTION Page::Page(int size, const Document& doc)
{
	this->m_internal = mupdf::new_page_of_size(size, doc.m_internal);
}

/* Copy constructor using fz_keep_page(). */
FZ_FUNCTION Page::Page(const Page& rhs)
: m_internal(mupdf::keep_page(rhs.m_internal))
{
}

/* operator= using fz_keep_page() and fz_drop_page(). */
FZ_FUNCTION Page& Page::operator=(const Page& rhs)
{
	mupdf::drop_page(this->m_internal);
	mupdf::keep_page(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_bound_page(). */
FZ_FUNCTION Rect Page::bound_page()
{
	fz_rect temp = mupdf::bound_page(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for fz_create_link(). */
FZ_FUNCTION Link Page::create_link(Rect& bbox, const char *uri)
{
	fz_link* temp = mupdf::create_link(this->m_internal, *(fz_rect*) &bbox.x0, uri);
	return Link(temp);
}

/* Wrapper for fz_load_links(). */
FZ_FUNCTION Link Page::load_links()
{
	fz_link* temp = mupdf::load_links(this->m_internal);
	return Link(temp);
}

/* Wrapper for fz_new_buffer_from_page(). */
FZ_FUNCTION Buffer Page::new_buffer_from_page(StextOptions& options)
{
	fz_buffer* temp = mupdf::new_buffer_from_page(this->m_internal, (const fz_stext_options *) &options.flags);
	return Buffer(temp);
}

/* Wrapper for fz_new_buffer_from_page_with_format(). */
FZ_FUNCTION Buffer Page::new_buffer_from_page_with_format(const char *format, const char *options, Matrix& transform, Cookie& cookie)
{
	fz_buffer* temp = mupdf::new_buffer_from_page_with_format(this->m_internal, format, options, *(fz_matrix*) &transform.a, &cookie.m_internal);
	return Buffer(temp);
}

/* Wrapper for fz_new_display_list_from_page(). */
FZ_FUNCTION DisplayList Page::new_display_list_from_page()
{
	fz_display_list* temp = mupdf::new_display_list_from_page(this->m_internal);
	return DisplayList(temp);
}

/* Wrapper for fz_new_display_list_from_page_contents(). */
FZ_FUNCTION DisplayList Page::new_display_list_from_page_contents()
{
	fz_display_list* temp = mupdf::new_display_list_from_page_contents(this->m_internal);
	return DisplayList(temp);
}

/* Wrapper for fz_new_pixmap_from_page(). */
FZ_FUNCTION Pixmap Page::new_pixmap_from_page(Matrix& ctm, const Colorspace& cs, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_page_contents(). */
FZ_FUNCTION Pixmap Page::new_pixmap_from_page_contents(Matrix& ctm, const Colorspace& cs, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_contents(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_page_contents_with_separations(). */
FZ_FUNCTION Pixmap Page::new_pixmap_from_page_contents_with_separations(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_contents_with_separations(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_page_with_separations(). */
FZ_FUNCTION Pixmap Page::new_pixmap_from_page_with_separations(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_with_separations(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_page_presentation(). */
FZ_FUNCTION Transition Page::page_presentation(Transition& transition, float *duration)
{
	fz_transition* temp = mupdf::page_presentation(this->m_internal, (fz_transition *) &transition.type, duration);
	return Transition(temp);
}

/* Wrapper for fz_page_separations(). */
FZ_FUNCTION Separations Page::page_separations()
{
	fz_separations* temp = mupdf::page_separations(this->m_internal);
	return Separations(temp);
}

/* Wrapper for fz_page_uses_overprint(). */
FZ_FUNCTION int Page::page_uses_overprint()
{
	return mupdf::page_uses_overprint(this->m_internal);
}

/* Wrapper for fz_run_page(). */
FZ_FUNCTION void Page::run_page(const Device& dev, Matrix& transform, Cookie& cookie)
{
	return mupdf::run_page(this->m_internal, dev.m_internal, *(fz_matrix*) &transform.a, &cookie.m_internal);
}

/* Wrapper for fz_run_page_annots(). */
FZ_FUNCTION void Page::run_page_annots(const Device& dev, Matrix& transform, Cookie& cookie)
{
	return mupdf::run_page_annots(this->m_internal, dev.m_internal, *(fz_matrix*) &transform.a, &cookie.m_internal);
}

/* Wrapper for fz_run_page_contents(). */
FZ_FUNCTION void Page::run_page_contents(const Device& dev, Matrix& transform, Cookie& cookie)
{
	return mupdf::run_page_contents(this->m_internal, dev.m_internal, *(fz_matrix*) &transform.a, &cookie.m_internal);
}

/* Wrapper for fz_run_page_widgets(). */
FZ_FUNCTION void Page::run_page_widgets(const Device& dev, Matrix& transform, Cookie& cookie)
{
	return mupdf::run_page_widgets(this->m_internal, dev.m_internal, *(fz_matrix*) &transform.a, &cookie.m_internal);
}

/* Wrapper for pdf_page_from_fz_page(). */
FZ_FUNCTION PdfPage Page::pdf_page_from_fz_page()
{
	pdf_page* temp = mupdf::ppdf_page_from_fz_page(this->m_internal);
	return PdfPage(temp);
}

/* Custom method. */
FZ_FUNCTION std::vector<Quad> Page::search_page(const char* needle, int max)
{
	std::vector<Quad> ret(max);
	fz_quad* hit_bbox = ret[0].internal();
	int n = mupdf::search_page(m_internal, needle, hit_bbox, (int) ret.size());
	ret.resize(n);
	return ret;
}

FZ_FUNCTION Page::Page(fz_page* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Page::~Page()
{
	mupdf::drop_page(m_internal);
}


/* Implementation of methods for Path (wrapper for fz_path). */

/* Constructor using fz_new_path(). */
FZ_FUNCTION Path::Path()
{
	this->m_internal = mupdf::new_path();
}

/* Copy constructor using fz_keep_path(). */
FZ_FUNCTION Path::Path(const Path& rhs)
: m_internal(mupdf::keep_path(rhs.m_internal))
{
}

/* operator= using fz_keep_path() and fz_drop_path(). */
FZ_FUNCTION Path& Path::operator=(const Path& rhs)
{
	mupdf::drop_path(this->m_internal);
	mupdf::keep_path(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_bound_path(). */
FZ_FUNCTION Rect Path::bound_path(const StrokeState& stroke, Matrix& ctm)
{
	fz_rect temp = mupdf::bound_path(this->m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a);
	return Rect(&temp);
}

/* Wrapper for fz_clone_path(). */
FZ_FUNCTION Path Path::clone_path()
{
	fz_path* temp = mupdf::clone_path(this->m_internal);
	return Path(temp);
}

/* Wrapper for fz_closepath(). */
FZ_FUNCTION void Path::closepath()
{
	return mupdf::closepath(this->m_internal);
}

/* Wrapper for fz_currentpoint(). */
FZ_FUNCTION Point Path::currentpoint()
{
	fz_point temp = mupdf::currentpoint(this->m_internal);
	return Point(&temp);
}

/* Wrapper for fz_curveto(). */
FZ_FUNCTION void Path::curveto(float x0, float y0, float x1, float y1, float x2, float y2)
{
	return mupdf::curveto(this->m_internal, x0, y0, x1, y1, x2, y2);
}

/* Wrapper for fz_curvetov(). */
FZ_FUNCTION void Path::curvetov(float x1, float y1, float x2, float y2)
{
	return mupdf::curvetov(this->m_internal, x1, y1, x2, y2);
}

/* Wrapper for fz_curvetoy(). */
FZ_FUNCTION void Path::curvetoy(float x0, float y0, float x2, float y2)
{
	return mupdf::curvetoy(this->m_internal, x0, y0, x2, y2);
}

/* Wrapper for fz_lineto(). */
FZ_FUNCTION void Path::lineto(float x, float y)
{
	return mupdf::lineto(this->m_internal, x, y);
}

/* Wrapper for fz_moveto(). */
FZ_FUNCTION void Path::moveto(float x, float y)
{
	return mupdf::moveto(this->m_internal, x, y);
}

/* Wrapper for fz_packed_path_size(). */
FZ_FUNCTION int Path::packed_path_size()
{
	return mupdf::packed_path_size(this->m_internal);
}

/* Wrapper for fz_quadto(). */
FZ_FUNCTION void Path::quadto(float x0, float y0, float x1, float y1)
{
	return mupdf::quadto(this->m_internal, x0, y0, x1, y1);
}

/* Wrapper for fz_rectto(). */
FZ_FUNCTION void Path::rectto(float x0, float y0, float x1, float y1)
{
	return mupdf::rectto(this->m_internal, x0, y0, x1, y1);
}

/* Wrapper for fz_transform_path(). */
FZ_FUNCTION void Path::transform_path(Matrix& transform)
{
	return mupdf::transform_path(this->m_internal, *(fz_matrix*) &transform.a);
}

/* Wrapper for fz_trim_path(). */
FZ_FUNCTION void Path::trim_path()
{
	return mupdf::trim_path(this->m_internal);
}

/* Wrapper for fz_walk_path(). */
FZ_FUNCTION void Path::walk_path(const PathWalker& walker, void *arg)
{
	return mupdf::walk_path(this->m_internal, walker.m_internal, arg);
}

FZ_FUNCTION Path::Path(fz_path* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Path::~Path()
{
	mupdf::drop_path(m_internal);
}


/* Implementation of methods for PathWalker (wrapper for fz_path_walker). */

FZ_FUNCTION PathWalker::PathWalker(fz_path_walker* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PclOptions (wrapper for fz_pcl_options). */

/* Constructor using fz_parse_pcl_options(). */
FZ_FUNCTION PclOptions::PclOptions(const PclOptions& opts, const char *args)
{
	this->m_internal = mupdf::parse_pcl_options(opts.m_internal, args);
}

/* Wrapper for fz_pcl_preset(). */
FZ_FUNCTION void PclOptions::pcl_preset(const char *preset)
{
	return mupdf::pcl_preset(this->m_internal, preset);
}

FZ_FUNCTION PclOptions::PclOptions(fz_pcl_options* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PclmOptions (wrapper for fz_pclm_options). */

/* Constructor using fz_parse_pclm_options(). */
FZ_FUNCTION PclmOptions::PclmOptions(const PclmOptions& opts, const char *args)
{
	this->m_internal = mupdf::parse_pclm_options(opts.m_internal, args);
}

/* Custom constructor. */
FZ_FUNCTION PclmOptions::PclmOptions(const char *args)
{
	mupdf::parse_pclm_options(m_internal, args);
}

FZ_FUNCTION PclmOptions::PclmOptions(fz_pclm_options* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfAlertEvent (wrapper for pdf_alert_event). */

FZ_FUNCTION PdfAlertEvent::PdfAlertEvent(pdf_alert_event* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfAnnot (wrapper for pdf_annot). */

/* Copy constructor using pdf_keep_annot(). */
FZ_FUNCTION PdfAnnot::PdfAnnot(const PdfAnnot& rhs)
: m_internal(mupdf::ppdf_keep_annot(rhs.m_internal))
{
}

/* operator= using pdf_keep_annot() and pdf_drop_annot(). */
FZ_FUNCTION PdfAnnot& PdfAnnot::operator=(const PdfAnnot& rhs)
{
	mupdf::ppdf_drop_annot(this->m_internal);
	mupdf::ppdf_keep_annot(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_add_annot_ink_list_stroke(). */
FZ_FUNCTION void PdfAnnot::add_annot_ink_list_stroke()
{
	return mupdf::ppdf_add_annot_ink_list_stroke(this->m_internal);
}

/* Wrapper for pdf_add_annot_ink_list_stroke_vertex(). */
FZ_FUNCTION void PdfAnnot::add_annot_ink_list_stroke_vertex(Point& p)
{
	return mupdf::ppdf_add_annot_ink_list_stroke_vertex(this->m_internal, *(fz_point*) &p.x);
}

/* Wrapper for pdf_add_annot_quad_point(). */
FZ_FUNCTION void PdfAnnot::add_annot_quad_point(Quad& quad)
{
	return mupdf::ppdf_add_annot_quad_point(this->m_internal, *(fz_quad*) &quad.ul);
}

/* Wrapper for pdf_add_annot_vertex(). */
FZ_FUNCTION void PdfAnnot::add_annot_vertex(Point& p)
{
	return mupdf::ppdf_add_annot_vertex(this->m_internal, *(fz_point*) &p.x);
}

/* Wrapper for pdf_annot_MK_BC(). */
FZ_FUNCTION void PdfAnnot::annot_MK_BC(int *n, float color[4])
{
	return mupdf::ppdf_annot_MK_BC(this->m_internal, n, color);
}

/* Wrapper for pdf_annot_MK_BC_rgb(). */
FZ_FUNCTION int PdfAnnot::annot_MK_BC_rgb(float rgb[3])
{
	return mupdf::ppdf_annot_MK_BC_rgb(this->m_internal, rgb);
}

/* Wrapper for pdf_annot_MK_BG(). */
FZ_FUNCTION void PdfAnnot::annot_MK_BG(int *n, float color[4])
{
	return mupdf::ppdf_annot_MK_BG(this->m_internal, n, color);
}

/* Wrapper for pdf_annot_MK_BG_rgb(). */
FZ_FUNCTION int PdfAnnot::annot_MK_BG_rgb(float rgb[3])
{
	return mupdf::ppdf_annot_MK_BG_rgb(this->m_internal, rgb);
}

/* Wrapper for pdf_annot_active(). */
FZ_FUNCTION int PdfAnnot::annot_active()
{
	return mupdf::ppdf_annot_active(this->m_internal);
}

/* Wrapper for pdf_annot_ap(). */
FZ_FUNCTION PdfObj PdfAnnot::annot_ap()
{
	pdf_obj* temp = mupdf::ppdf_annot_ap(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_annot_author(). */
FZ_FUNCTION const char *PdfAnnot::annot_author()
{
	return mupdf::ppdf_annot_author(this->m_internal);
}

/* Wrapper for pdf_annot_border(). */
FZ_FUNCTION float PdfAnnot::annot_border()
{
	return mupdf::ppdf_annot_border(this->m_internal);
}

/* Wrapper for pdf_annot_color(). */
FZ_FUNCTION void PdfAnnot::annot_color(int *n, float color[4])
{
	return mupdf::ppdf_annot_color(this->m_internal, n, color);
}

/* Wrapper for pdf_annot_contents(). */
FZ_FUNCTION const char *PdfAnnot::annot_contents()
{
	return mupdf::ppdf_annot_contents(this->m_internal);
}

/* Wrapper for pdf_annot_creation_date(). */
FZ_FUNCTION int64_t PdfAnnot::annot_creation_date()
{
	return mupdf::ppdf_annot_creation_date(this->m_internal);
}

/* Wrapper for pdf_annot_default_appearance(). */
FZ_FUNCTION void PdfAnnot::annot_default_appearance(const char **font, float *size, int *n, float color[4])
{
	return mupdf::ppdf_annot_default_appearance(this->m_internal, font, size, n, color);
}

/* Wrapper for pdf_annot_ensure_local_xref(). */
FZ_FUNCTION void PdfAnnot::annot_ensure_local_xref()
{
	return mupdf::ppdf_annot_ensure_local_xref(this->m_internal);
}

/* Wrapper for pdf_annot_event_blur(). */
FZ_FUNCTION void PdfAnnot::annot_event_blur()
{
	return mupdf::ppdf_annot_event_blur(this->m_internal);
}

/* Wrapper for pdf_annot_event_down(). */
FZ_FUNCTION void PdfAnnot::annot_event_down()
{
	return mupdf::ppdf_annot_event_down(this->m_internal);
}

/* Wrapper for pdf_annot_event_enter(). */
FZ_FUNCTION void PdfAnnot::annot_event_enter()
{
	return mupdf::ppdf_annot_event_enter(this->m_internal);
}

/* Wrapper for pdf_annot_event_exit(). */
FZ_FUNCTION void PdfAnnot::annot_event_exit()
{
	return mupdf::ppdf_annot_event_exit(this->m_internal);
}

/* Wrapper for pdf_annot_event_focus(). */
FZ_FUNCTION void PdfAnnot::annot_event_focus()
{
	return mupdf::ppdf_annot_event_focus(this->m_internal);
}

/* Wrapper for pdf_annot_event_page_close(). */
FZ_FUNCTION void PdfAnnot::annot_event_page_close()
{
	return mupdf::ppdf_annot_event_page_close(this->m_internal);
}

/* Wrapper for pdf_annot_event_page_invisible(). */
FZ_FUNCTION void PdfAnnot::annot_event_page_invisible()
{
	return mupdf::ppdf_annot_event_page_invisible(this->m_internal);
}

/* Wrapper for pdf_annot_event_page_open(). */
FZ_FUNCTION void PdfAnnot::annot_event_page_open()
{
	return mupdf::ppdf_annot_event_page_open(this->m_internal);
}

/* Wrapper for pdf_annot_event_page_visible(). */
FZ_FUNCTION void PdfAnnot::annot_event_page_visible()
{
	return mupdf::ppdf_annot_event_page_visible(this->m_internal);
}

/* Wrapper for pdf_annot_event_up(). */
FZ_FUNCTION void PdfAnnot::annot_event_up()
{
	return mupdf::ppdf_annot_event_up(this->m_internal);
}

/* Wrapper for pdf_annot_field_flags(). */
FZ_FUNCTION int PdfAnnot::annot_field_flags()
{
	return mupdf::ppdf_annot_field_flags(this->m_internal);
}

/* Wrapper for pdf_annot_field_label(). */
FZ_FUNCTION const char *PdfAnnot::annot_field_label()
{
	return mupdf::ppdf_annot_field_label(this->m_internal);
}

/* Wrapper for pdf_annot_field_value(). */
FZ_FUNCTION const char *PdfAnnot::annot_field_value()
{
	return mupdf::ppdf_annot_field_value(this->m_internal);
}

/* Wrapper for pdf_annot_flags(). */
FZ_FUNCTION int PdfAnnot::annot_flags()
{
	return mupdf::ppdf_annot_flags(this->m_internal);
}

/* Wrapper for pdf_annot_has_author(). */
FZ_FUNCTION int PdfAnnot::annot_has_author()
{
	return mupdf::ppdf_annot_has_author(this->m_internal);
}

/* Wrapper for pdf_annot_has_icon_name(). */
FZ_FUNCTION int PdfAnnot::annot_has_icon_name()
{
	return mupdf::ppdf_annot_has_icon_name(this->m_internal);
}

/* Wrapper for pdf_annot_has_ink_list(). */
FZ_FUNCTION int PdfAnnot::annot_has_ink_list()
{
	return mupdf::ppdf_annot_has_ink_list(this->m_internal);
}

/* Wrapper for pdf_annot_has_interior_color(). */
FZ_FUNCTION int PdfAnnot::annot_has_interior_color()
{
	return mupdf::ppdf_annot_has_interior_color(this->m_internal);
}

/* Wrapper for pdf_annot_has_line(). */
FZ_FUNCTION int PdfAnnot::annot_has_line()
{
	return mupdf::ppdf_annot_has_line(this->m_internal);
}

/* Wrapper for pdf_annot_has_line_ending_styles(). */
FZ_FUNCTION int PdfAnnot::annot_has_line_ending_styles()
{
	return mupdf::ppdf_annot_has_line_ending_styles(this->m_internal);
}

/* Wrapper for pdf_annot_has_open(). */
FZ_FUNCTION int PdfAnnot::annot_has_open()
{
	return mupdf::ppdf_annot_has_open(this->m_internal);
}

/* Wrapper for pdf_annot_has_quad_points(). */
FZ_FUNCTION int PdfAnnot::annot_has_quad_points()
{
	return mupdf::ppdf_annot_has_quad_points(this->m_internal);
}

/* Wrapper for pdf_annot_has_vertices(). */
FZ_FUNCTION int PdfAnnot::annot_has_vertices()
{
	return mupdf::ppdf_annot_has_vertices(this->m_internal);
}

/* Wrapper for pdf_annot_hot(). */
FZ_FUNCTION int PdfAnnot::annot_hot()
{
	return mupdf::ppdf_annot_hot(this->m_internal);
}

/* Wrapper for pdf_annot_icon_name(). */
FZ_FUNCTION const char *PdfAnnot::annot_icon_name()
{
	return mupdf::ppdf_annot_icon_name(this->m_internal);
}

/* Wrapper for pdf_annot_ink_list_count(). */
FZ_FUNCTION int PdfAnnot::annot_ink_list_count()
{
	return mupdf::ppdf_annot_ink_list_count(this->m_internal);
}

/* Wrapper for pdf_annot_ink_list_stroke_count(). */
FZ_FUNCTION int PdfAnnot::annot_ink_list_stroke_count(int i)
{
	return mupdf::ppdf_annot_ink_list_stroke_count(this->m_internal, i);
}

/* Wrapper for pdf_annot_ink_list_stroke_vertex(). */
FZ_FUNCTION Point PdfAnnot::annot_ink_list_stroke_vertex(int i, int k)
{
	fz_point temp = mupdf::ppdf_annot_ink_list_stroke_vertex(this->m_internal, i, k);
	return Point(&temp);
}

/* Wrapper for pdf_annot_interior_color(). */
FZ_FUNCTION void PdfAnnot::annot_interior_color(int *n, float color[4])
{
	return mupdf::ppdf_annot_interior_color(this->m_internal, n, color);
}

/* Wrapper for pdf_annot_is_open(). */
FZ_FUNCTION int PdfAnnot::annot_is_open()
{
	return mupdf::ppdf_annot_is_open(this->m_internal);
}

/* Wrapper for pdf_annot_language(). */
FZ_FUNCTION fz_text_language PdfAnnot::annot_language()
{
	return mupdf::ppdf_annot_language(this->m_internal);
}

/* Wrapper for pdf_annot_line(). */
FZ_FUNCTION void PdfAnnot::annot_line(Point& a, Point& b)
{
	return mupdf::ppdf_annot_line(this->m_internal, (fz_point *) &a.x, (fz_point *) &b.x);
}

/* Wrapper for pdf_annot_line_end_style(). */
FZ_FUNCTION enum pdf_line_ending PdfAnnot::annot_line_end_style()
{
	return mupdf::ppdf_annot_line_end_style(this->m_internal);
}

/* Wrapper for pdf_annot_line_ending_styles(). */
FZ_FUNCTION void PdfAnnot::annot_line_ending_styles(enum pdf_line_ending *start_style, enum pdf_line_ending *end_style)
{
	return mupdf::ppdf_annot_line_ending_styles(this->m_internal, start_style, end_style);
}

/* Wrapper for pdf_annot_line_start_style(). */
FZ_FUNCTION enum pdf_line_ending PdfAnnot::annot_line_start_style()
{
	return mupdf::ppdf_annot_line_start_style(this->m_internal);
}

/* Wrapper for pdf_annot_modification_date(). */
FZ_FUNCTION int64_t PdfAnnot::annot_modification_date()
{
	return mupdf::ppdf_annot_modification_date(this->m_internal);
}

/* Wrapper for pdf_annot_needs_resynthesis(). */
FZ_FUNCTION int PdfAnnot::annot_needs_resynthesis()
{
	return mupdf::ppdf_annot_needs_resynthesis(this->m_internal);
}

/* Wrapper for pdf_annot_obj(). */
FZ_FUNCTION PdfObj PdfAnnot::annot_obj()
{
	pdf_obj* temp = mupdf::ppdf_annot_obj(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_annot_opacity(). */
FZ_FUNCTION float PdfAnnot::annot_opacity()
{
	return mupdf::ppdf_annot_opacity(this->m_internal);
}

/* Wrapper for pdf_annot_page(). */
FZ_FUNCTION PdfPage PdfAnnot::annot_page()
{
	pdf_page* temp = mupdf::ppdf_annot_page(this->m_internal);
	return PdfPage(temp);
}

/* Wrapper for pdf_annot_pop_and_discard_local_xref(). */
FZ_FUNCTION void PdfAnnot::annot_pop_and_discard_local_xref()
{
	return mupdf::ppdf_annot_pop_and_discard_local_xref(this->m_internal);
}

/* Wrapper for pdf_annot_pop_local_xref(). */
FZ_FUNCTION void PdfAnnot::annot_pop_local_xref()
{
	return mupdf::ppdf_annot_pop_local_xref(this->m_internal);
}

/* Wrapper for pdf_annot_popup(). */
FZ_FUNCTION Rect PdfAnnot::annot_popup()
{
	fz_rect temp = mupdf::ppdf_annot_popup(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_annot_push_local_xref(). */
FZ_FUNCTION void PdfAnnot::annot_push_local_xref()
{
	return mupdf::ppdf_annot_push_local_xref(this->m_internal);
}

/* Wrapper for pdf_annot_quad_point(). */
FZ_FUNCTION Quad PdfAnnot::annot_quad_point(int i)
{
	fz_quad temp = mupdf::ppdf_annot_quad_point(this->m_internal, i);
	return Quad(&temp);
}

/* Wrapper for pdf_annot_quad_point_count(). */
FZ_FUNCTION int PdfAnnot::annot_quad_point_count()
{
	return mupdf::ppdf_annot_quad_point_count(this->m_internal);
}

/* Wrapper for pdf_annot_quadding(). */
FZ_FUNCTION int PdfAnnot::annot_quadding()
{
	return mupdf::ppdf_annot_quadding(this->m_internal);
}

/* Wrapper for pdf_annot_rect(). */
FZ_FUNCTION Rect PdfAnnot::annot_rect()
{
	fz_rect temp = mupdf::ppdf_annot_rect(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_annot_request_resynthesis(). */
FZ_FUNCTION void PdfAnnot::annot_request_resynthesis()
{
	return mupdf::ppdf_annot_request_resynthesis(this->m_internal);
}

/* Wrapper for pdf_annot_transform(). */
FZ_FUNCTION Matrix PdfAnnot::annot_transform()
{
	fz_matrix temp = mupdf::ppdf_annot_transform(this->m_internal);
	return Matrix(&temp);
}

/* Wrapper for pdf_annot_type(). */
FZ_FUNCTION enum pdf_annot_type PdfAnnot::annot_type()
{
	return mupdf::ppdf_annot_type(this->m_internal);
}

/* Wrapper for pdf_annot_vertex(). */
FZ_FUNCTION Point PdfAnnot::annot_vertex(int i)
{
	fz_point temp = mupdf::ppdf_annot_vertex(this->m_internal, i);
	return Point(&temp);
}

/* Wrapper for pdf_annot_vertex_count(). */
FZ_FUNCTION int PdfAnnot::annot_vertex_count()
{
	return mupdf::ppdf_annot_vertex_count(this->m_internal);
}

/* Wrapper for pdf_bound_annot(). */
FZ_FUNCTION Rect PdfAnnot::bound_annot()
{
	fz_rect temp = mupdf::ppdf_bound_annot(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_bound_widget(). */
FZ_FUNCTION Rect PdfAnnot::bound_widget()
{
	fz_rect temp = mupdf::ppdf_bound_widget(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_choice_widget_is_multiselect(). */
FZ_FUNCTION int PdfAnnot::choice_widget_is_multiselect()
{
	return mupdf::ppdf_choice_widget_is_multiselect(this->m_internal);
}

/* Wrapper for pdf_choice_widget_options(). */
FZ_FUNCTION int PdfAnnot::choice_widget_options(int exportval, const char *opts[])
{
	return mupdf::ppdf_choice_widget_options(this->m_internal, exportval, opts);
}

/* Wrapper for pdf_choice_widget_set_value(). */
FZ_FUNCTION void PdfAnnot::choice_widget_set_value(int n, const char *opts[])
{
	return mupdf::ppdf_choice_widget_set_value(this->m_internal, n, opts);
}

/* Wrapper for pdf_choice_widget_value(). */
FZ_FUNCTION int PdfAnnot::choice_widget_value(const char *opts[])
{
	return mupdf::ppdf_choice_widget_value(this->m_internal, opts);
}

/* Wrapper for pdf_clear_annot_ink_list(). */
FZ_FUNCTION void PdfAnnot::clear_annot_ink_list()
{
	return mupdf::ppdf_clear_annot_ink_list(this->m_internal);
}

/* Wrapper for pdf_clear_annot_quad_points(). */
FZ_FUNCTION void PdfAnnot::clear_annot_quad_points()
{
	return mupdf::ppdf_clear_annot_quad_points(this->m_internal);
}

/* Wrapper for pdf_clear_annot_vertices(). */
FZ_FUNCTION void PdfAnnot::clear_annot_vertices()
{
	return mupdf::ppdf_clear_annot_vertices(this->m_internal);
}

/* Wrapper for pdf_clear_signature(). */
FZ_FUNCTION void PdfAnnot::clear_signature()
{
	return mupdf::ppdf_clear_signature(this->m_internal);
}

/* Wrapper for pdf_dirty_annot(). */
FZ_FUNCTION void PdfAnnot::dirty_annot()
{
	return mupdf::ppdf_dirty_annot(this->m_internal);
}

/* Wrapper for pdf_edit_text_field_value(). */
FZ_FUNCTION int PdfAnnot::edit_text_field_value(const char *value, const char *change, int *selStart, int *selEnd, char **newvalue)
{
	return mupdf::ppdf_edit_text_field_value(this->m_internal, value, change, selStart, selEnd, newvalue);
}

/* Wrapper for pdf_get_widget_editing_state(). */
FZ_FUNCTION int PdfAnnot::get_widget_editing_state()
{
	return mupdf::ppdf_get_widget_editing_state(this->m_internal);
}

/* Wrapper for pdf_layout_text_widget(). */
FZ_FUNCTION LayoutBlock PdfAnnot::layout_text_widget()
{
	fz_layout_block* temp = mupdf::ppdf_layout_text_widget(this->m_internal);
	return LayoutBlock(temp);
}

/* Wrapper for pdf_new_display_list_from_annot(). */
FZ_FUNCTION DisplayList PdfAnnot::new_display_list_from_annot()
{
	fz_display_list* temp = mupdf::ppdf_new_display_list_from_annot(this->m_internal);
	return DisplayList(temp);
}

/* Wrapper for pdf_new_pixmap_from_annot(). */
FZ_FUNCTION Pixmap PdfAnnot::new_pixmap_from_annot(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::ppdf_new_pixmap_from_annot(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for pdf_next_annot(). */
FZ_FUNCTION PdfAnnot PdfAnnot::next_annot()
{
	pdf_annot* temp = mupdf::ppdf_next_annot(this->m_internal);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_next_widget(). */
FZ_FUNCTION PdfAnnot PdfAnnot::next_widget()
{
	pdf_annot* temp = mupdf::ppdf_next_widget(this->m_internal);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_run_annot(). */
FZ_FUNCTION void PdfAnnot::run_annot(const Device& dev, Matrix& ctm, Cookie& cookie)
{
	return mupdf::ppdf_run_annot(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, &cookie.m_internal);
}

/* Wrapper for pdf_set_annot_active(). */
FZ_FUNCTION void PdfAnnot::set_annot_active(int active)
{
	return mupdf::ppdf_set_annot_active(this->m_internal, active);
}

/* Wrapper for pdf_set_annot_appearance(). */
FZ_FUNCTION void PdfAnnot::set_annot_appearance(const char *appearance, const char *state, Matrix& ctm, Rect& bbox, const PdfObj& res, const Buffer& contents)
{
	return mupdf::ppdf_set_annot_appearance(this->m_internal, appearance, state, *(fz_matrix*) &ctm.a, *(fz_rect*) &bbox.x0, res.m_internal, contents.m_internal);
}

/* Wrapper for pdf_set_annot_appearance_from_display_list(). */
FZ_FUNCTION void PdfAnnot::set_annot_appearance_from_display_list(const char *appearance, const char *state, Matrix& ctm, const DisplayList& list)
{
	return mupdf::ppdf_set_annot_appearance_from_display_list(this->m_internal, appearance, state, *(fz_matrix*) &ctm.a, list.m_internal);
}

/* Wrapper for pdf_set_annot_author(). */
FZ_FUNCTION void PdfAnnot::set_annot_author(const char *author)
{
	return mupdf::ppdf_set_annot_author(this->m_internal, author);
}

/* Wrapper for pdf_set_annot_border(). */
FZ_FUNCTION void PdfAnnot::set_annot_border(float width)
{
	return mupdf::ppdf_set_annot_border(this->m_internal, width);
}

/* Wrapper for pdf_set_annot_color(). */
FZ_FUNCTION void PdfAnnot::set_annot_color(int n, const float *color)
{
	return mupdf::ppdf_set_annot_color(this->m_internal, n, color);
}

/* Wrapper for pdf_set_annot_contents(). */
FZ_FUNCTION void PdfAnnot::set_annot_contents(const char *text)
{
	return mupdf::ppdf_set_annot_contents(this->m_internal, text);
}

/* Wrapper for pdf_set_annot_creation_date(). */
FZ_FUNCTION void PdfAnnot::set_annot_creation_date(int64_t time)
{
	return mupdf::ppdf_set_annot_creation_date(this->m_internal, time);
}

/* Wrapper for pdf_set_annot_default_appearance(). */
FZ_FUNCTION void PdfAnnot::set_annot_default_appearance(const char *font, float size, int n, const float *color)
{
	return mupdf::ppdf_set_annot_default_appearance(this->m_internal, font, size, n, color);
}

/* Wrapper for pdf_set_annot_flags(). */
FZ_FUNCTION void PdfAnnot::set_annot_flags(int flags)
{
	return mupdf::ppdf_set_annot_flags(this->m_internal, flags);
}

/* Wrapper for pdf_set_annot_hot(). */
FZ_FUNCTION void PdfAnnot::set_annot_hot(int hot)
{
	return mupdf::ppdf_set_annot_hot(this->m_internal, hot);
}

/* Wrapper for pdf_set_annot_icon_name(). */
FZ_FUNCTION void PdfAnnot::set_annot_icon_name(const char *name)
{
	return mupdf::ppdf_set_annot_icon_name(this->m_internal, name);
}

/* Wrapper for pdf_set_annot_ink_list(). */
FZ_FUNCTION void PdfAnnot::set_annot_ink_list(int n, const int *count, Point& v)
{
	return mupdf::ppdf_set_annot_ink_list(this->m_internal, n, count, (const fz_point *) &v.x);
}

/* Wrapper for pdf_set_annot_interior_color(). */
FZ_FUNCTION void PdfAnnot::set_annot_interior_color(int n, const float *color)
{
	return mupdf::ppdf_set_annot_interior_color(this->m_internal, n, color);
}

/* Wrapper for pdf_set_annot_is_open(). */
FZ_FUNCTION void PdfAnnot::set_annot_is_open(int is_open)
{
	return mupdf::ppdf_set_annot_is_open(this->m_internal, is_open);
}

/* Wrapper for pdf_set_annot_language(). */
FZ_FUNCTION void PdfAnnot::set_annot_language(fz_text_language lang)
{
	return mupdf::ppdf_set_annot_language(this->m_internal, lang);
}

/* Wrapper for pdf_set_annot_line(). */
FZ_FUNCTION void PdfAnnot::set_annot_line(Point& a, Point& b)
{
	return mupdf::ppdf_set_annot_line(this->m_internal, *(fz_point*) &a.x, *(fz_point*) &b.x);
}

/* Wrapper for pdf_set_annot_line_end_style(). */
FZ_FUNCTION void PdfAnnot::set_annot_line_end_style(enum pdf_line_ending e)
{
	return mupdf::ppdf_set_annot_line_end_style(this->m_internal, e);
}

/* Wrapper for pdf_set_annot_line_ending_styles(). */
FZ_FUNCTION void PdfAnnot::set_annot_line_ending_styles(enum pdf_line_ending start_style, enum pdf_line_ending end_style)
{
	return mupdf::ppdf_set_annot_line_ending_styles(this->m_internal, start_style, end_style);
}

/* Wrapper for pdf_set_annot_line_start_style(). */
FZ_FUNCTION void PdfAnnot::set_annot_line_start_style(enum pdf_line_ending s)
{
	return mupdf::ppdf_set_annot_line_start_style(this->m_internal, s);
}

/* Wrapper for pdf_set_annot_modification_date(). */
FZ_FUNCTION void PdfAnnot::set_annot_modification_date(int64_t time)
{
	return mupdf::ppdf_set_annot_modification_date(this->m_internal, time);
}

/* Wrapper for pdf_set_annot_opacity(). */
FZ_FUNCTION void PdfAnnot::set_annot_opacity(float opacity)
{
	return mupdf::ppdf_set_annot_opacity(this->m_internal, opacity);
}

/* Wrapper for pdf_set_annot_popup(). */
FZ_FUNCTION void PdfAnnot::set_annot_popup(Rect& rect)
{
	return mupdf::ppdf_set_annot_popup(this->m_internal, *(fz_rect*) &rect.x0);
}

/* Wrapper for pdf_set_annot_quad_points(). */
FZ_FUNCTION void PdfAnnot::set_annot_quad_points(int n, Quad& qv)
{
	return mupdf::ppdf_set_annot_quad_points(this->m_internal, n, (const fz_quad *) &qv.ul);
}

/* Wrapper for pdf_set_annot_quadding(). */
FZ_FUNCTION void PdfAnnot::set_annot_quadding(int q)
{
	return mupdf::ppdf_set_annot_quadding(this->m_internal, q);
}

/* Wrapper for pdf_set_annot_rect(). */
FZ_FUNCTION void PdfAnnot::set_annot_rect(Rect& rect)
{
	return mupdf::ppdf_set_annot_rect(this->m_internal, *(fz_rect*) &rect.x0);
}

/* Wrapper for pdf_set_annot_resynthesised(). */
FZ_FUNCTION void PdfAnnot::set_annot_resynthesised()
{
	return mupdf::ppdf_set_annot_resynthesised(this->m_internal);
}

/* Wrapper for pdf_set_annot_vertex(). */
FZ_FUNCTION void PdfAnnot::set_annot_vertex(int i, Point& p)
{
	return mupdf::ppdf_set_annot_vertex(this->m_internal, i, *(fz_point*) &p.x);
}

/* Wrapper for pdf_set_annot_vertices(). */
FZ_FUNCTION void PdfAnnot::set_annot_vertices(int n, Point& v)
{
	return mupdf::ppdf_set_annot_vertices(this->m_internal, n, (const fz_point *) &v.x);
}

/* Wrapper for pdf_set_choice_field_value(). */
FZ_FUNCTION int PdfAnnot::set_choice_field_value(const char *value)
{
	return mupdf::ppdf_set_choice_field_value(this->m_internal, value);
}

/* Wrapper for pdf_set_text_field_value(). */
FZ_FUNCTION int PdfAnnot::set_text_field_value(const char *value)
{
	return mupdf::ppdf_set_text_field_value(this->m_internal, value);
}

/* Wrapper for pdf_set_widget_editing_state(). */
FZ_FUNCTION void PdfAnnot::set_widget_editing_state(int editing)
{
	return mupdf::ppdf_set_widget_editing_state(this->m_internal, editing);
}

/* Wrapper for pdf_sign_signature(). */
FZ_FUNCTION void PdfAnnot::sign_signature(const PdfPkcs7Signer& signer, int appearance_flags, const Image& graphic, const char *reason, const char *location)
{
	return mupdf::ppdf_sign_signature(this->m_internal, signer.m_internal, appearance_flags, graphic.m_internal, reason, location);
}

/* Wrapper for pdf_sign_signature_with_appearance(). */
FZ_FUNCTION void PdfAnnot::sign_signature_with_appearance(const PdfPkcs7Signer& signer, int64_t date, const DisplayList& disp_list)
{
	return mupdf::ppdf_sign_signature_with_appearance(this->m_internal, signer.m_internal, date, disp_list.m_internal);
}

/* Wrapper for pdf_text_widget_format(). */
FZ_FUNCTION int PdfAnnot::text_widget_format()
{
	return mupdf::ppdf_text_widget_format(this->m_internal);
}

/* Wrapper for pdf_text_widget_max_len(). */
FZ_FUNCTION int PdfAnnot::text_widget_max_len()
{
	return mupdf::ppdf_text_widget_max_len(this->m_internal);
}

/* Wrapper for pdf_toggle_widget(). */
FZ_FUNCTION int PdfAnnot::toggle_widget()
{
	return mupdf::ppdf_toggle_widget(this->m_internal);
}

/* Wrapper for pdf_update_annot(). */
FZ_FUNCTION int PdfAnnot::update_annot()
{
	return mupdf::ppdf_update_annot(this->m_internal);
}

/* Wrapper for pdf_update_widget(). */
FZ_FUNCTION int PdfAnnot::update_widget()
{
	return mupdf::ppdf_update_widget(this->m_internal);
}

/* Wrapper for pdf_validate_signature(). */
FZ_FUNCTION int PdfAnnot::validate_signature()
{
	return mupdf::ppdf_validate_signature(this->m_internal);
}

/* Wrapper for pdf_widget_is_readonly(). */
FZ_FUNCTION int PdfAnnot::widget_is_readonly()
{
	return mupdf::ppdf_widget_is_readonly(this->m_internal);
}

/* Wrapper for pdf_widget_is_signed(). */
FZ_FUNCTION int PdfAnnot::widget_is_signed()
{
	return mupdf::ppdf_widget_is_signed(this->m_internal);
}

/* Wrapper for pdf_widget_type(). */
FZ_FUNCTION enum pdf_widget_type PdfAnnot::widget_type()
{
	return mupdf::ppdf_widget_type(this->m_internal);
}

FZ_FUNCTION PdfAnnot::PdfAnnot(pdf_annot* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfAnnot::~PdfAnnot()
{
	mupdf::ppdf_drop_annot(m_internal);
}


/* Implementation of methods for PdfCmap (wrapper for pdf_cmap). */

/* Constructor using pdf_new_cmap(). */
FZ_FUNCTION PdfCmap::PdfCmap()
{
	this->m_internal = mupdf::ppdf_new_cmap();
}

/* Constructor using pdf_new_identity_cmap(). */
FZ_FUNCTION PdfCmap::PdfCmap(int wmode, int bytes)
{
	this->m_internal = mupdf::ppdf_new_identity_cmap(wmode, bytes);
}

/* Copy constructor using pdf_keep_cmap(). */
FZ_FUNCTION PdfCmap::PdfCmap(const PdfCmap& rhs)
: m_internal(mupdf::ppdf_keep_cmap(rhs.m_internal))
{
}

/* operator= using pdf_keep_cmap() and pdf_drop_cmap(). */
FZ_FUNCTION PdfCmap& PdfCmap::operator=(const PdfCmap& rhs)
{
	mupdf::ppdf_drop_cmap(this->m_internal);
	mupdf::ppdf_keep_cmap(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_add_codespace(). */
FZ_FUNCTION void PdfCmap::add_codespace(unsigned int low, unsigned int high, size_t n)
{
	return mupdf::ppdf_add_codespace(this->m_internal, low, high, n);
}

/* Wrapper for pdf_cmap_size(). */
FZ_FUNCTION size_t PdfCmap::cmap_size()
{
	return mupdf::ppdf_cmap_size(this->m_internal);
}

/* Wrapper for pdf_cmap_wmode(). */
FZ_FUNCTION int PdfCmap::cmap_wmode()
{
	return mupdf::ppdf_cmap_wmode(this->m_internal);
}

/* Wrapper for pdf_decode_cmap(). */
FZ_FUNCTION int PdfCmap::decode_cmap(unsigned char *s, unsigned char *e, unsigned int *cpt)
{
	return mupdf::ppdf_decode_cmap(this->m_internal, s, e, cpt);
}

/* Wrapper for pdf_lookup_cmap(). */
FZ_FUNCTION int PdfCmap::lookup_cmap(unsigned int cpt)
{
	return mupdf::ppdf_lookup_cmap(this->m_internal, cpt);
}

/* Wrapper for pdf_lookup_cmap_full(). */
FZ_FUNCTION int PdfCmap::lookup_cmap_full(unsigned int cpt, int *out)
{
	return mupdf::ppdf_lookup_cmap_full(this->m_internal, cpt, out);
}

/* Wrapper for pdf_map_one_to_many(). */
FZ_FUNCTION void PdfCmap::map_one_to_many(unsigned int one, int *many, size_t len)
{
	return mupdf::ppdf_map_one_to_many(this->m_internal, one, many, len);
}

/* Wrapper for pdf_map_range_to_range(). */
FZ_FUNCTION void PdfCmap::map_range_to_range(unsigned int srclo, unsigned int srchi, int dstlo)
{
	return mupdf::ppdf_map_range_to_range(this->m_internal, srclo, srchi, dstlo);
}

/* Wrapper for pdf_set_cmap_wmode(). */
FZ_FUNCTION void PdfCmap::set_cmap_wmode(int wmode)
{
	return mupdf::ppdf_set_cmap_wmode(this->m_internal, wmode);
}

/* Wrapper for pdf_set_usecmap(). */
FZ_FUNCTION void PdfCmap::set_usecmap(const PdfCmap& usecmap)
{
	return mupdf::ppdf_set_usecmap(this->m_internal, usecmap.m_internal);
}

/* Wrapper for pdf_sort_cmap(). */
FZ_FUNCTION void PdfCmap::sort_cmap()
{
	return mupdf::ppdf_sort_cmap(this->m_internal);
}

FZ_FUNCTION PdfCmap::PdfCmap(pdf_cmap* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfCmap::~PdfCmap()
{
	mupdf::ppdf_drop_cmap(m_internal);
}


/* Implementation of methods for PdfCrypt (wrapper for pdf_crypt). */

/* Constructor using pdf_new_crypt(). */
FZ_FUNCTION PdfCrypt::PdfCrypt(const PdfObj& enc, const PdfObj& id)
{
	this->m_internal = mupdf::ppdf_new_crypt(enc.m_internal, id.m_internal);
}

/* Constructor using pdf_new_encrypt(). */
FZ_FUNCTION PdfCrypt::PdfCrypt(const char *opwd_utf8, const char *upwd_utf8, const PdfObj& id, int permissions, int algorithm)
{
	this->m_internal = mupdf::ppdf_new_encrypt(opwd_utf8, upwd_utf8, id.m_internal, permissions, algorithm);
}

/* Wrapper for pdf_crypt_encrypt_metadata(). */
FZ_FUNCTION int PdfCrypt::crypt_encrypt_metadata()
{
	return mupdf::ppdf_crypt_encrypt_metadata(this->m_internal);
}

/* Wrapper for pdf_crypt_key(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_key()
{
	return mupdf::ppdf_crypt_key(this->m_internal);
}

/* Wrapper for pdf_crypt_length(). */
FZ_FUNCTION int PdfCrypt::crypt_length()
{
	return mupdf::ppdf_crypt_length(this->m_internal);
}

/* Wrapper for pdf_crypt_method(). */
FZ_FUNCTION char *PdfCrypt::crypt_method()
{
	return mupdf::ppdf_crypt_method(this->m_internal);
}

/* Wrapper for pdf_crypt_obj(). */
FZ_FUNCTION void PdfCrypt::crypt_obj(const PdfObj& obj, int num, int gen)
{
	return mupdf::ppdf_crypt_obj(this->m_internal, obj.m_internal, num, gen);
}

/* Wrapper for pdf_crypt_owner_encryption(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_owner_encryption()
{
	return mupdf::ppdf_crypt_owner_encryption(this->m_internal);
}

/* Wrapper for pdf_crypt_owner_password(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_owner_password()
{
	return mupdf::ppdf_crypt_owner_password(this->m_internal);
}

/* Wrapper for pdf_crypt_permissions(). */
FZ_FUNCTION int PdfCrypt::crypt_permissions()
{
	return mupdf::ppdf_crypt_permissions(this->m_internal);
}

/* Wrapper for pdf_crypt_permissions_encryption(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_permissions_encryption()
{
	return mupdf::ppdf_crypt_permissions_encryption(this->m_internal);
}

/* Wrapper for pdf_crypt_revision(). */
FZ_FUNCTION int PdfCrypt::crypt_revision()
{
	return mupdf::ppdf_crypt_revision(this->m_internal);
}

/* Wrapper for pdf_crypt_user_encryption(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_user_encryption()
{
	return mupdf::ppdf_crypt_user_encryption(this->m_internal);
}

/* Wrapper for pdf_crypt_user_password(). */
FZ_FUNCTION unsigned char *PdfCrypt::crypt_user_password()
{
	return mupdf::ppdf_crypt_user_password(this->m_internal);
}

/* Wrapper for pdf_crypt_version(). */
FZ_FUNCTION int PdfCrypt::crypt_version()
{
	return mupdf::ppdf_crypt_version(this->m_internal);
}

/* Wrapper for pdf_encrypt_data(). */
FZ_FUNCTION void PdfCrypt::encrypt_data(int num, int gen, void (*fmt_str_out)(fz_context *, void *, const unsigned char *, size_t ), void *arg, const unsigned char *s, size_t n)
{
	return mupdf::ppdf_encrypt_data(this->m_internal, num, gen, fmt_str_out, arg, s, n);
}

/* Wrapper for pdf_encrypted_len(). */
FZ_FUNCTION size_t PdfCrypt::encrypted_len(int num, int gen, size_t len)
{
	return mupdf::ppdf_encrypted_len(this->m_internal, num, gen, len);
}

FZ_FUNCTION PdfCrypt::PdfCrypt(pdf_crypt* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfCrypt::~PdfCrypt()
{
	mupdf::ppdf_drop_crypt(m_internal);
}


/* Implementation of methods for PdfCsi (wrapper for pdf_csi). */

FZ_FUNCTION PdfCsi::PdfCsi(pdf_csi* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfDocEvent (wrapper for pdf_doc_event). */

/* Wrapper for pdf_access_alert_event(). */
FZ_FUNCTION PdfAlertEvent PdfDocEvent::access_alert_event()
{
	pdf_alert_event* temp = mupdf::ppdf_access_alert_event(this->m_internal);
	return PdfAlertEvent(temp);
}

/* Wrapper for pdf_access_exec_menu_item_event(). */
FZ_FUNCTION const char *PdfDocEvent::access_exec_menu_item_event()
{
	return mupdf::ppdf_access_exec_menu_item_event(this->m_internal);
}

/* Wrapper for pdf_access_launch_url_event(). */
FZ_FUNCTION PdfLaunchUrlEvent PdfDocEvent::access_launch_url_event()
{
	pdf_launch_url_event* temp = mupdf::ppdf_access_launch_url_event(this->m_internal);
	return PdfLaunchUrlEvent(temp);
}

/* Wrapper for pdf_access_mail_doc_event(). */
FZ_FUNCTION PdfMailDocEvent PdfDocEvent::access_mail_doc_event()
{
	pdf_mail_doc_event* temp = mupdf::ppdf_access_mail_doc_event(this->m_internal);
	return PdfMailDocEvent(temp);
}

FZ_FUNCTION PdfDocEvent::PdfDocEvent(pdf_doc_event* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfDocument (wrapper for pdf_document). */

/* Constructor using pdf_create_document(). */
FZ_FUNCTION PdfDocument::PdfDocument()
{
	this->m_internal = mupdf::ppdf_create_document();
}

/* Constructor using pdf_open_document(). */
FZ_FUNCTION PdfDocument::PdfDocument(const char *filename)
{
	this->m_internal = mupdf::ppdf_open_document(filename);
}

/* Constructor using pdf_open_document_with_stream(). */
FZ_FUNCTION PdfDocument::PdfDocument(const Stream& file)
{
	this->m_internal = mupdf::ppdf_open_document_with_stream(file.m_internal);
}

/* Copy constructor using pdf_keep_document(). */
FZ_FUNCTION PdfDocument::PdfDocument(const PdfDocument& rhs)
: m_internal(mupdf::ppdf_keep_document(rhs.m_internal))
{
}

/* operator= using pdf_keep_document() and pdf_drop_document(). */
FZ_FUNCTION PdfDocument& PdfDocument::operator=(const PdfDocument& rhs)
{
	mupdf::ppdf_drop_document(this->m_internal);
	mupdf::ppdf_keep_document(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_add_cid_font(). */
FZ_FUNCTION PdfObj PdfDocument::add_cid_font(const Font& font)
{
	pdf_obj* temp = mupdf::ppdf_add_cid_font(this->m_internal, font.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_cjk_font(). */
FZ_FUNCTION PdfObj PdfDocument::add_cjk_font(const Font& font, int script, int wmode, int serif)
{
	pdf_obj* temp = mupdf::ppdf_add_cjk_font(this->m_internal, font.m_internal, script, wmode, serif);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_embedded_file(). */
FZ_FUNCTION PdfObj PdfDocument::add_embedded_file(const char *filename, const char *mimetype, const Buffer& contents)
{
	pdf_obj* temp = mupdf::ppdf_add_embedded_file(this->m_internal, filename, mimetype, contents.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_image(). */
FZ_FUNCTION PdfObj PdfDocument::add_image(const Image& image)
{
	pdf_obj* temp = mupdf::ppdf_add_image(this->m_internal, image.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_journal_fragment(). */
FZ_FUNCTION void PdfDocument::add_journal_fragment(int parent, const PdfObj& copy, const Buffer& copy_stream, int newobj)
{
	return mupdf::ppdf_add_journal_fragment(this->m_internal, parent, copy.m_internal, copy_stream.m_internal, newobj);
}

/* Wrapper for pdf_add_new_array(). */
FZ_FUNCTION PdfObj PdfDocument::add_new_array(int initial)
{
	pdf_obj* temp = mupdf::ppdf_add_new_array(this->m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_new_dict(). */
FZ_FUNCTION PdfObj PdfDocument::add_new_dict(int initial)
{
	pdf_obj* temp = mupdf::ppdf_add_new_dict(this->m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_object(). */
FZ_FUNCTION PdfObj PdfDocument::add_object(const PdfObj& obj)
{
	pdf_obj* temp = mupdf::ppdf_add_object(this->m_internal, obj.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_object_drop(). */
FZ_FUNCTION PdfObj PdfDocument::add_object_drop(const PdfObj& obj)
{
	pdf_obj* temp = mupdf::ppdf_add_object_drop(this->m_internal, obj.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_page(). */
FZ_FUNCTION PdfObj PdfDocument::add_page(Rect& mediabox, int rotate, const PdfObj& resources, const Buffer& contents)
{
	pdf_obj* temp = mupdf::ppdf_add_page(this->m_internal, *(fz_rect*) &mediabox.x0, rotate, resources.m_internal, contents.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_simple_font(). */
FZ_FUNCTION PdfObj PdfDocument::add_simple_font(const Font& font, int encoding)
{
	pdf_obj* temp = mupdf::ppdf_add_simple_font(this->m_internal, font.m_internal, encoding);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_stream(). */
FZ_FUNCTION PdfObj PdfDocument::add_stream(const Buffer& buf, const PdfObj& obj, int compressed)
{
	pdf_obj* temp = mupdf::ppdf_add_stream(this->m_internal, buf.m_internal, obj.m_internal, compressed);
	return PdfObj(temp);
}

/* Wrapper for pdf_add_substitute_font(). */
FZ_FUNCTION PdfObj PdfDocument::add_substitute_font(const Font& font)
{
	pdf_obj* temp = mupdf::ppdf_add_substitute_font(this->m_internal, font.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_annot_field_event_keystroke(). */
FZ_FUNCTION int PdfDocument::annot_field_event_keystroke(const PdfAnnot& annot, const PdfKeystrokeEvent& evt)
{
	return mupdf::ppdf_annot_field_event_keystroke(this->m_internal, annot.m_internal, evt.m_internal);
}

/* Wrapper for pdf_authenticate_password(). */
FZ_FUNCTION int PdfDocument::authenticate_password(const char *pw)
{
	return mupdf::ppdf_authenticate_password(this->m_internal, pw);
}

/* Wrapper for pdf_begin_implicit_operation(). */
FZ_FUNCTION void PdfDocument::begin_implicit_operation()
{
	return mupdf::ppdf_begin_implicit_operation(this->m_internal);
}

/* Wrapper for pdf_begin_operation(). */
FZ_FUNCTION void PdfDocument::begin_operation(const char *operation)
{
	return mupdf::ppdf_begin_operation(this->m_internal, operation);
}

/* Wrapper for pdf_cache_object(). */
FZ_FUNCTION PdfXrefEntry PdfDocument::cache_object(int num)
{
	pdf_xref_entry* temp = mupdf::ppdf_cache_object(this->m_internal, num);
	return PdfXrefEntry(temp);
}

/* Wrapper for pdf_calculate_form(). */
FZ_FUNCTION void PdfDocument::calculate_form()
{
	return mupdf::ppdf_calculate_form(this->m_internal);
}

/* Wrapper for pdf_can_be_saved_incrementally(). */
FZ_FUNCTION int PdfDocument::can_be_saved_incrementally()
{
	return mupdf::ppdf_can_be_saved_incrementally(this->m_internal);
}

/* Wrapper for pdf_can_redo(). */
FZ_FUNCTION int PdfDocument::can_redo()
{
	return mupdf::ppdf_can_redo(this->m_internal);
}

/* Wrapper for pdf_can_undo(). */
FZ_FUNCTION int PdfDocument::can_undo()
{
	return mupdf::ppdf_can_undo(this->m_internal);
}

/* Wrapper for pdf_clear_xref(). */
FZ_FUNCTION void PdfDocument::clear_xref()
{
	return mupdf::ppdf_clear_xref(this->m_internal);
}

/* Wrapper for pdf_clear_xref_to_mark(). */
FZ_FUNCTION void PdfDocument::clear_xref_to_mark()
{
	return mupdf::ppdf_clear_xref_to_mark(this->m_internal);
}

/* Wrapper for pdf_count_layer_config_ui(). */
FZ_FUNCTION int PdfDocument::count_layer_config_ui()
{
	return mupdf::ppdf_count_layer_config_ui(this->m_internal);
}

/* Wrapper for pdf_count_layer_configs(). */
FZ_FUNCTION int PdfDocument::count_layer_configs()
{
	return mupdf::ppdf_count_layer_configs(this->m_internal);
}

/* Wrapper for pdf_count_objects(). */
FZ_FUNCTION int PdfDocument::count_objects()
{
	return mupdf::ppdf_count_objects(this->m_internal);
}

/* Wrapper for pdf_count_pages(). */
FZ_FUNCTION int PdfDocument::count_pages()
{
	return mupdf::ppdf_count_pages(this->m_internal);
}

/* Wrapper for pdf_count_signatures(). */
FZ_FUNCTION int PdfDocument::count_signatures()
{
	return mupdf::ppdf_count_signatures(this->m_internal);
}

/* Wrapper for pdf_count_unsaved_versions(). */
FZ_FUNCTION int PdfDocument::count_unsaved_versions()
{
	return mupdf::ppdf_count_unsaved_versions(this->m_internal);
}

/* Wrapper for pdf_count_versions(). */
FZ_FUNCTION int PdfDocument::count_versions()
{
	return mupdf::ppdf_count_versions(this->m_internal);
}

/* Wrapper for pdf_create_field_name(). */
FZ_FUNCTION void PdfDocument::create_field_name(const char *prefix, char *buf, size_t len)
{
	return mupdf::ppdf_create_field_name(this->m_internal, prefix, buf, len);
}

/* Wrapper for pdf_create_object(). */
FZ_FUNCTION int PdfDocument::create_object()
{
	return mupdf::ppdf_create_object(this->m_internal);
}

/* Wrapper for pdf_debug_doc_changes(). */
FZ_FUNCTION void PdfDocument::debug_doc_changes()
{
	return mupdf::ppdf_debug_doc_changes(this->m_internal);
}

/* Wrapper for pdf_delete_object(). */
FZ_FUNCTION void PdfDocument::delete_object(int num)
{
	return mupdf::ppdf_delete_object(this->m_internal, num);
}

/* Wrapper for pdf_delete_page(). */
FZ_FUNCTION void PdfDocument::delete_page(int number)
{
	return mupdf::ppdf_delete_page(this->m_internal, number);
}

/* Wrapper for pdf_delete_page_range(). */
FZ_FUNCTION void PdfDocument::delete_page_range(int start, int end)
{
	return mupdf::ppdf_delete_page_range(this->m_internal, start, end);
}

/* Wrapper for pdf_deselect_layer_config_ui(). */
FZ_FUNCTION void PdfDocument::deselect_layer_config_ui(int ui)
{
	return mupdf::ppdf_deselect_layer_config_ui(this->m_internal, ui);
}

/* Wrapper for pdf_deserialise_journal(). */
FZ_FUNCTION void PdfDocument::deserialise_journal(const Stream& stm)
{
	return mupdf::ppdf_deserialise_journal(this->m_internal, stm.m_internal);
}

/* Wrapper for pdf_disable_js(). */
FZ_FUNCTION void PdfDocument::disable_js()
{
	return mupdf::ppdf_disable_js(this->m_internal);
}

/* Wrapper for pdf_doc_was_linearized(). */
FZ_FUNCTION int PdfDocument::doc_was_linearized()
{
	return mupdf::ppdf_doc_was_linearized(this->m_internal);
}

/* Wrapper for pdf_document_event_did_print(). */
FZ_FUNCTION void PdfDocument::document_event_did_print()
{
	return mupdf::ppdf_document_event_did_print(this->m_internal);
}

/* Wrapper for pdf_document_event_did_save(). */
FZ_FUNCTION void PdfDocument::document_event_did_save()
{
	return mupdf::ppdf_document_event_did_save(this->m_internal);
}

/* Wrapper for pdf_document_event_will_close(). */
FZ_FUNCTION void PdfDocument::document_event_will_close()
{
	return mupdf::ppdf_document_event_will_close(this->m_internal);
}

/* Wrapper for pdf_document_event_will_print(). */
FZ_FUNCTION void PdfDocument::document_event_will_print()
{
	return mupdf::ppdf_document_event_will_print(this->m_internal);
}

/* Wrapper for pdf_document_event_will_save(). */
FZ_FUNCTION void PdfDocument::document_event_will_save()
{
	return mupdf::ppdf_document_event_will_save(this->m_internal);
}

/* Wrapper for pdf_document_language(). */
FZ_FUNCTION fz_text_language PdfDocument::document_language()
{
	return mupdf::ppdf_document_language(this->m_internal);
}

/* Wrapper for pdf_document_output_intent(). */
FZ_FUNCTION Colorspace PdfDocument::document_output_intent()
{
	fz_colorspace* temp = mupdf::ppdf_document_output_intent(this->m_internal);
	return Colorspace(temp);
}

/* Wrapper for pdf_document_permissions(). */
FZ_FUNCTION int PdfDocument::document_permissions()
{
	return mupdf::ppdf_document_permissions(this->m_internal);
}

/* Wrapper for pdf_empty_store(). */
FZ_FUNCTION void PdfDocument::empty_store()
{
	return mupdf::ppdf_empty_store(this->m_internal);
}

/* Wrapper for pdf_enable_journal(). */
FZ_FUNCTION void PdfDocument::enable_journal()
{
	return mupdf::ppdf_enable_journal(this->m_internal);
}

/* Wrapper for pdf_enable_js(). */
FZ_FUNCTION void PdfDocument::enable_js()
{
	return mupdf::ppdf_enable_js(this->m_internal);
}

/* Wrapper for pdf_end_operation(). */
FZ_FUNCTION void PdfDocument::end_operation()
{
	return mupdf::ppdf_end_operation(this->m_internal);
}

/* Wrapper for pdf_ensure_solid_xref(). */
FZ_FUNCTION void PdfDocument::ensure_solid_xref(int num)
{
	return mupdf::ppdf_ensure_solid_xref(this->m_internal, num);
}

/* Wrapper for pdf_event_issue_alert(). */
FZ_FUNCTION void PdfDocument::event_issue_alert(const PdfAlertEvent& evt)
{
	return mupdf::ppdf_event_issue_alert(this->m_internal, evt.m_internal);
}

/* Wrapper for pdf_event_issue_exec_menu_item(). */
FZ_FUNCTION void PdfDocument::event_issue_exec_menu_item(const char *item)
{
	return mupdf::ppdf_event_issue_exec_menu_item(this->m_internal, item);
}

/* Wrapper for pdf_event_issue_launch_url(). */
FZ_FUNCTION void PdfDocument::event_issue_launch_url(const char *url, int new_frame)
{
	return mupdf::ppdf_event_issue_launch_url(this->m_internal, url, new_frame);
}

/* Wrapper for pdf_event_issue_mail_doc(). */
FZ_FUNCTION void PdfDocument::event_issue_mail_doc(const PdfMailDocEvent& evt)
{
	return mupdf::ppdf_event_issue_mail_doc(this->m_internal, evt.m_internal);
}

/* Wrapper for pdf_event_issue_print(). */
FZ_FUNCTION void PdfDocument::event_issue_print()
{
	return mupdf::ppdf_event_issue_print(this->m_internal);
}

/* Wrapper for pdf_field_event_calculate(). */
FZ_FUNCTION void PdfDocument::field_event_calculate(const PdfObj& field)
{
	return mupdf::ppdf_field_event_calculate(this->m_internal, field.m_internal);
}

/* Wrapper for pdf_field_event_format(). */
FZ_FUNCTION char *PdfDocument::field_event_format(const PdfObj& field)
{
	return mupdf::ppdf_field_event_format(this->m_internal, field.m_internal);
}

/* Wrapper for pdf_field_event_keystroke(). */
FZ_FUNCTION int PdfDocument::field_event_keystroke(const PdfObj& field, const PdfKeystrokeEvent& evt)
{
	return mupdf::ppdf_field_event_keystroke(this->m_internal, field.m_internal, evt.m_internal);
}

/* Wrapper for pdf_field_event_validate(). */
FZ_FUNCTION int PdfDocument::field_event_validate(const PdfObj& field, const char *value, char **newvalue)
{
	return mupdf::ppdf_field_event_validate(this->m_internal, field.m_internal, value, newvalue);
}

/* Wrapper for pdf_field_reset(). */
FZ_FUNCTION void PdfDocument::field_reset(const PdfObj& field)
{
	return mupdf::ppdf_field_reset(this->m_internal, field.m_internal);
}

/* Wrapper for pdf_filter_annot_contents(). */
FZ_FUNCTION void PdfDocument::filter_annot_contents(const PdfAnnot& annot, const PdfFilterOptions& filter)
{
	return mupdf::ppdf_filter_annot_contents(this->m_internal, annot.m_internal, filter.m_internal);
}

/* Wrapper for pdf_filter_page_contents(). */
FZ_FUNCTION void PdfDocument::filter_page_contents(const PdfPage& page, const PdfFilterOptions& filter)
{
	return mupdf::ppdf_filter_page_contents(this->m_internal, page.m_internal, filter.m_internal);
}

/* Wrapper for pdf_find_font_resource(). */
FZ_FUNCTION PdfObj PdfDocument::find_font_resource(int type, int encoding, const Font& item, const PdfFontResourceKey& key)
{
	pdf_obj* temp = mupdf::ppdf_find_font_resource(this->m_internal, type, encoding, item.m_internal, key.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_find_locked_fields(). */
FZ_FUNCTION PdfLockedFields PdfDocument::find_locked_fields(int version)
{
	pdf_locked_fields* temp = mupdf::ppdf_find_locked_fields(this->m_internal, version);
	return PdfLockedFields(temp);
}

/* Wrapper for pdf_find_locked_fields_for_sig(). */
FZ_FUNCTION PdfLockedFields PdfDocument::find_locked_fields_for_sig(const PdfObj& sig)
{
	pdf_locked_fields* temp = mupdf::ppdf_find_locked_fields_for_sig(this->m_internal, sig.m_internal);
	return PdfLockedFields(temp);
}

/* Wrapper for pdf_find_version_for_obj(). */
FZ_FUNCTION int PdfDocument::find_version_for_obj(const PdfObj& obj)
{
	return mupdf::ppdf_find_version_for_obj(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_forget_xref(). */
FZ_FUNCTION void PdfDocument::forget_xref()
{
	return mupdf::ppdf_forget_xref(this->m_internal);
}

/* Wrapper for pdf_get_doc_event_callback_data(). */
FZ_FUNCTION void *PdfDocument::get_doc_event_callback_data()
{
	return mupdf::ppdf_get_doc_event_callback_data(this->m_internal);
}

/* Wrapper for pdf_get_incremental_xref_entry(). */
FZ_FUNCTION PdfXrefEntry PdfDocument::get_incremental_xref_entry(int i)
{
	pdf_xref_entry* temp = mupdf::ppdf_get_incremental_xref_entry(this->m_internal, i);
	return PdfXrefEntry(temp);
}

/* Wrapper for pdf_get_populating_xref_entry(). */
FZ_FUNCTION PdfXrefEntry PdfDocument::get_populating_xref_entry(int i)
{
	pdf_xref_entry* temp = mupdf::ppdf_get_populating_xref_entry(this->m_internal, i);
	return PdfXrefEntry(temp);
}

/* Wrapper for pdf_get_xref_entry(). */
FZ_FUNCTION PdfXrefEntry PdfDocument::get_xref_entry(int i)
{
	pdf_xref_entry* temp = mupdf::ppdf_get_xref_entry(this->m_internal, i);
	return PdfXrefEntry(temp);
}

/* Wrapper for pdf_graft_object(). */
FZ_FUNCTION PdfObj PdfDocument::graft_object(const PdfObj& obj)
{
	pdf_obj* temp = mupdf::ppdf_graft_object(this->m_internal, obj.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_graft_page(). */
FZ_FUNCTION void PdfDocument::graft_page(int page_to, const PdfDocument& src, int page_from)
{
	return mupdf::ppdf_graft_page(this->m_internal, page_to, src.m_internal, page_from);
}

/* Wrapper for pdf_has_permission(). */
FZ_FUNCTION int PdfDocument::has_permission(fz_permission p)
{
	return mupdf::ppdf_has_permission(this->m_internal, p);
}

/* Wrapper for pdf_has_unsaved_changes(). */
FZ_FUNCTION int PdfDocument::has_unsaved_changes()
{
	return mupdf::ppdf_has_unsaved_changes(this->m_internal);
}

/* Wrapper for pdf_has_unsaved_sigs(). */
FZ_FUNCTION int PdfDocument::has_unsaved_sigs()
{
	return mupdf::ppdf_has_unsaved_sigs(this->m_internal);
}

/* Wrapper for pdf_insert_font_resource(). */
FZ_FUNCTION PdfObj PdfDocument::insert_font_resource(const PdfFontResourceKey& key, const PdfObj& obj)
{
	pdf_obj* temp = mupdf::ppdf_insert_font_resource(this->m_internal, key.m_internal, obj.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_insert_page(). */
FZ_FUNCTION void PdfDocument::insert_page(int at, const PdfObj& page)
{
	return mupdf::ppdf_insert_page(this->m_internal, at, page.m_internal);
}

/* Wrapper for pdf_invalidate_xfa(). */
FZ_FUNCTION void PdfDocument::invalidate_xfa()
{
	return mupdf::ppdf_invalidate_xfa(this->m_internal);
}

/* Wrapper for pdf_is_local_object(). */
FZ_FUNCTION int PdfDocument::is_local_object(const PdfObj& obj)
{
	return mupdf::ppdf_is_local_object(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_is_ocg_hidden(). */
FZ_FUNCTION int PdfDocument::is_ocg_hidden(const PdfObj& rdb, const char *usage, const PdfObj& ocg)
{
	return mupdf::ppdf_is_ocg_hidden(this->m_internal, rdb.m_internal, usage, ocg.m_internal);
}

/* Wrapper for pdf_js_supported(). */
FZ_FUNCTION int PdfDocument::js_supported()
{
	return mupdf::ppdf_js_supported(this->m_internal);
}

/* Wrapper for pdf_layer_config_info(). */
FZ_FUNCTION void PdfDocument::layer_config_info(int config_num, const PdfLayerConfig& info)
{
	return mupdf::ppdf_layer_config_info(this->m_internal, config_num, info.m_internal);
}

/* Wrapper for pdf_layer_config_ui_info(). */
FZ_FUNCTION void PdfDocument::layer_config_ui_info(int ui, const PdfLayerConfigUi& info)
{
	return mupdf::ppdf_layer_config_ui_info(this->m_internal, ui, info.m_internal);
}

/* Wrapper for pdf_load_compressed_inline_image(). */
FZ_FUNCTION void PdfDocument::load_compressed_inline_image(const PdfObj& dict, int length, const Stream& cstm, int indexed, const CompressedImage& image)
{
	return mupdf::ppdf_load_compressed_inline_image(this->m_internal, dict.m_internal, length, cstm.m_internal, indexed, image.m_internal);
}

/* Wrapper for pdf_load_compressed_stream(). */
FZ_FUNCTION CompressedBuffer PdfDocument::load_compressed_stream(int num)
{
	fz_compressed_buffer* temp = mupdf::ppdf_load_compressed_stream(this->m_internal, num);
	return CompressedBuffer(temp);
}

/* Wrapper for pdf_load_default_colorspaces(). */
FZ_FUNCTION DefaultColorspaces PdfDocument::load_default_colorspaces(const PdfPage& page)
{
	fz_default_colorspaces* temp = mupdf::ppdf_load_default_colorspaces(this->m_internal, page.m_internal);
	return DefaultColorspaces(temp);
}

/* Wrapper for pdf_load_embedded_cmap(). */
FZ_FUNCTION PdfCmap PdfDocument::load_embedded_cmap(const PdfObj& ref)
{
	pdf_cmap* temp = mupdf::ppdf_load_embedded_cmap(this->m_internal, ref.m_internal);
	return PdfCmap(temp);
}

/* Wrapper for pdf_load_font(). */
FZ_FUNCTION PdfFontDesc PdfDocument::load_font(const PdfObj& rdb, const PdfObj& obj)
{
	pdf_font_desc* temp = mupdf::ppdf_load_font(this->m_internal, rdb.m_internal, obj.m_internal);
	return PdfFontDesc(temp);
}

/* Wrapper for pdf_load_hail_mary_font(). */
FZ_FUNCTION PdfFontDesc PdfDocument::load_hail_mary_font()
{
	pdf_font_desc* temp = mupdf::ppdf_load_hail_mary_font(this->m_internal);
	return PdfFontDesc(temp);
}

/* Wrapper for pdf_load_image(). */
FZ_FUNCTION Image PdfDocument::load_image(const PdfObj& obj)
{
	fz_image* temp = mupdf::ppdf_load_image(this->m_internal, obj.m_internal);
	return Image(temp);
}

/* Wrapper for pdf_load_inline_image(). */
FZ_FUNCTION Image PdfDocument::load_inline_image(const PdfObj& rdb, const PdfObj& dict, const Stream& file)
{
	fz_image* temp = mupdf::ppdf_load_inline_image(this->m_internal, rdb.m_internal, dict.m_internal, file.m_internal);
	return Image(temp);
}

/* Wrapper for pdf_load_journal(). */
FZ_FUNCTION void PdfDocument::load_journal(const char *filename)
{
	return mupdf::ppdf_load_journal(this->m_internal, filename);
}

/* Wrapper for pdf_load_link_annots(). */
FZ_FUNCTION Link PdfDocument::load_link_annots(const PdfObj& annots, int pagenum, Matrix& page_ctm)
{
	fz_link* temp = mupdf::ppdf_load_link_annots(this->m_internal, annots.m_internal, pagenum, *(fz_matrix*) &page_ctm.a);
	return Link(temp);
}

/* Wrapper for pdf_load_name_tree(). */
FZ_FUNCTION PdfObj PdfDocument::load_name_tree(const PdfObj& which)
{
	pdf_obj* temp = mupdf::ppdf_load_name_tree(this->m_internal, which.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_load_object(). */
FZ_FUNCTION PdfObj PdfDocument::load_object(int num)
{
	pdf_obj* temp = mupdf::ppdf_load_object(this->m_internal, num);
	return PdfObj(temp);
}

/* Wrapper for pdf_load_outline(). */
FZ_FUNCTION Outline PdfDocument::load_outline()
{
	fz_outline* temp = mupdf::ppdf_load_outline(this->m_internal);
	return Outline(temp);
}

/* Wrapper for pdf_load_page(). */
FZ_FUNCTION PdfPage PdfDocument::load_page(int number)
{
	pdf_page* temp = mupdf::ppdf_load_page(this->m_internal, number);
	return PdfPage(temp);
}

/* Wrapper for pdf_load_page_tree(). */
FZ_FUNCTION void PdfDocument::load_page_tree()
{
	return mupdf::ppdf_load_page_tree(this->m_internal);
}

/* Wrapper for pdf_load_pattern(). */
FZ_FUNCTION PdfPattern PdfDocument::load_pattern(const PdfObj& obj)
{
	pdf_pattern* temp = mupdf::ppdf_load_pattern(this->m_internal, obj.m_internal);
	return PdfPattern(temp);
}

/* Wrapper for pdf_load_raw_stream_number(). */
FZ_FUNCTION Buffer PdfDocument::load_raw_stream_number(int num)
{
	fz_buffer* temp = mupdf::ppdf_load_raw_stream_number(this->m_internal, num);
	return Buffer(temp);
}

/* Wrapper for pdf_load_shading(). */
FZ_FUNCTION Shade PdfDocument::load_shading(const PdfObj& obj)
{
	fz_shade* temp = mupdf::ppdf_load_shading(this->m_internal, obj.m_internal);
	return Shade(temp);
}

/* Wrapper for pdf_load_stream_number(). */
FZ_FUNCTION Buffer PdfDocument::load_stream_number(int num)
{
	fz_buffer* temp = mupdf::ppdf_load_stream_number(this->m_internal, num);
	return Buffer(temp);
}

/* Wrapper for pdf_load_to_unicode(). */
FZ_FUNCTION void PdfDocument::load_to_unicode(const PdfFontDesc& font, const char **strings, char *collection, const PdfObj& cmapstm)
{
	return mupdf::ppdf_load_to_unicode(this->m_internal, font.m_internal, strings, collection, cmapstm.m_internal);
}

/* Wrapper for pdf_load_type3_font(). */
FZ_FUNCTION PdfFontDesc PdfDocument::load_type3_font(const PdfObj& rdb, const PdfObj& obj)
{
	pdf_font_desc* temp = mupdf::ppdf_load_type3_font(this->m_internal, rdb.m_internal, obj.m_internal);
	return PdfFontDesc(temp);
}

/* Wrapper for pdf_load_type3_glyphs(). */
FZ_FUNCTION void PdfDocument::load_type3_glyphs(const PdfFontDesc& fontdesc)
{
	return mupdf::ppdf_load_type3_glyphs(this->m_internal, fontdesc.m_internal);
}

/* Wrapper for pdf_load_unencrypted_object(). */
FZ_FUNCTION PdfObj PdfDocument::load_unencrypted_object(int num)
{
	pdf_obj* temp = mupdf::ppdf_load_unencrypted_object(this->m_internal, num);
	return PdfObj(temp);
}

/* Wrapper for pdf_lookup_anchor(). */
FZ_FUNCTION int PdfDocument::lookup_anchor(const char *name, float *xp, float *yp)
{
	return mupdf::ppdf_lookup_anchor(this->m_internal, name, xp, yp);
}

/* Wrapper for pdf_lookup_dest(). */
FZ_FUNCTION PdfObj PdfDocument::lookup_dest(const PdfObj& needle)
{
	pdf_obj* temp = mupdf::ppdf_lookup_dest(this->m_internal, needle.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_lookup_metadata(). */
FZ_FUNCTION int PdfDocument::lookup_metadata(const char *key, char *ptr, int size)
{
	return mupdf::ppdf_lookup_metadata(this->m_internal, key, ptr, size);
}

/* Wrapper for pdf_lookup_name(). */
FZ_FUNCTION PdfObj PdfDocument::lookup_name(const PdfObj& which, const PdfObj& needle)
{
	pdf_obj* temp = mupdf::ppdf_lookup_name(this->m_internal, which.m_internal, needle.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_lookup_page_number(). */
FZ_FUNCTION int PdfDocument::lookup_page_number(const PdfObj& pageobj)
{
	return mupdf::ppdf_lookup_page_number(this->m_internal, pageobj.m_internal);
}

/* Wrapper for pdf_lookup_page_obj(). */
FZ_FUNCTION PdfObj PdfDocument::lookup_page_obj(int needle)
{
	pdf_obj* temp = mupdf::ppdf_lookup_page_obj(this->m_internal, needle);
	return PdfObj(temp);
}

/* Wrapper for pdf_mark_xref(). */
FZ_FUNCTION void PdfDocument::mark_xref()
{
	return mupdf::ppdf_mark_xref(this->m_internal);
}

/* Wrapper for pdf_needs_password(). */
FZ_FUNCTION int PdfDocument::needs_password()
{
	return mupdf::ppdf_needs_password(this->m_internal);
}

/* Wrapper for pdf_new_array(). */
FZ_FUNCTION PdfObj PdfDocument::new_array(int initialcap)
{
	pdf_obj* temp = mupdf::ppdf_new_array(this->m_internal, initialcap);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_date(). */
FZ_FUNCTION PdfObj PdfDocument::new_date(int64_t time)
{
	pdf_obj* temp = mupdf::ppdf_new_date(this->m_internal, time);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_dict(). */
FZ_FUNCTION PdfObj PdfDocument::new_dict(int initialcap)
{
	pdf_obj* temp = mupdf::ppdf_new_dict(this->m_internal, initialcap);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_filter_processor(). */
FZ_FUNCTION PdfProcessor PdfDocument::new_filter_processor(const PdfProcessor& chain, const PdfObj& old_res, const PdfObj& new_res, int struct_parents, Matrix& transform, const PdfFilterOptions& filter)
{
	pdf_processor* temp = mupdf::ppdf_new_filter_processor(this->m_internal, chain.m_internal, old_res.m_internal, new_res.m_internal, struct_parents, *(fz_matrix*) &transform.a, filter.m_internal);
	return PdfProcessor(temp);
}

/* Wrapper for pdf_new_graft_map(). */
FZ_FUNCTION PdfGraftMap PdfDocument::new_graft_map()
{
	pdf_graft_map* temp = mupdf::ppdf_new_graft_map(this->m_internal);
	return PdfGraftMap(temp);
}

/* Wrapper for pdf_new_indirect(). */
FZ_FUNCTION PdfObj PdfDocument::new_indirect(int num, int gen)
{
	pdf_obj* temp = mupdf::ppdf_new_indirect(this->m_internal, num, gen);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_local_xref(). */
FZ_FUNCTION PdfXref PdfDocument::new_local_xref()
{
	pdf_xref* temp = mupdf::ppdf_new_local_xref(this->m_internal);
	return PdfXref(temp);
}

/* Wrapper for pdf_new_matrix(). */
FZ_FUNCTION PdfObj PdfDocument::new_matrix(Matrix& mtx)
{
	pdf_obj* temp = mupdf::ppdf_new_matrix(this->m_internal, *(fz_matrix*) &mtx.a);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_pdf_device(). */
FZ_FUNCTION Device PdfDocument::new_pdf_device(Matrix& topctm, const PdfObj& resources, const Buffer& contents)
{
	fz_device* temp = mupdf::ppdf_new_pdf_device(this->m_internal, *(fz_matrix*) &topctm.a, resources.m_internal, contents.m_internal);
	return Device(temp);
}

/* Wrapper for pdf_new_rect(). */
FZ_FUNCTION PdfObj PdfDocument::new_rect(Rect& rect)
{
	pdf_obj* temp = mupdf::ppdf_new_rect(this->m_internal, *(fz_rect*) &rect.x0);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_xobject(). */
FZ_FUNCTION PdfObj PdfDocument::new_xobject(Rect& bbox, Matrix& matrix, const PdfObj& res, const Buffer& buffer)
{
	pdf_obj* temp = mupdf::ppdf_new_xobject(this->m_internal, *(fz_rect*) &bbox.x0, *(fz_matrix*) &matrix.a, res.m_internal, buffer.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_obj_num_is_stream(). */
FZ_FUNCTION int PdfDocument::obj_num_is_stream(int num)
{
	return mupdf::ppdf_obj_num_is_stream(this->m_internal, num);
}

/* Wrapper for pdf_open_contents_stream(). */
FZ_FUNCTION Stream PdfDocument::open_contents_stream(const PdfObj& obj)
{
	fz_stream* temp = mupdf::ppdf_open_contents_stream(this->m_internal, obj.m_internal);
	return Stream(temp);
}

/* Wrapper for pdf_open_inline_stream(). */
FZ_FUNCTION Stream PdfDocument::open_inline_stream(const PdfObj& stmobj, int length, const Stream& chain, const CompressionParams& params)
{
	fz_stream* temp = mupdf::ppdf_open_inline_stream(this->m_internal, stmobj.m_internal, length, chain.m_internal, params.m_internal);
	return Stream(temp);
}

/* Wrapper for pdf_open_raw_stream_number(). */
FZ_FUNCTION Stream PdfDocument::open_raw_stream_number(int num)
{
	fz_stream* temp = mupdf::ppdf_open_raw_stream_number(this->m_internal, num);
	return Stream(temp);
}

/* Wrapper for pdf_open_stream_number(). */
FZ_FUNCTION Stream PdfDocument::open_stream_number(int num)
{
	fz_stream* temp = mupdf::ppdf_open_stream_number(this->m_internal, num);
	return Stream(temp);
}

/* Wrapper for pdf_open_stream_with_offset(). */
FZ_FUNCTION Stream PdfDocument::open_stream_with_offset(int num, const PdfObj& dict, int64_t stm_ofs)
{
	fz_stream* temp = mupdf::ppdf_open_stream_with_offset(this->m_internal, num, dict.m_internal, stm_ofs);
	return Stream(temp);
}

/* Wrapper for pdf_page_write(). */
FZ_FUNCTION Device PdfDocument::page_write(Rect& mediabox, PdfObj& presources, Buffer& pcontents)
{
	fz_device* temp = mupdf::ppdf_page_write(this->m_internal, *(fz_rect*) &mediabox.x0, &presources.m_internal, &pcontents.m_internal);
	return Device(temp);
}

/* Wrapper for pdf_parse_array(). */
FZ_FUNCTION PdfObj PdfDocument::parse_array(const Stream& f, const PdfLexbuf& buf)
{
	pdf_obj* temp = mupdf::ppdf_parse_array(this->m_internal, f.m_internal, buf.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_parse_dict(). */
FZ_FUNCTION PdfObj PdfDocument::parse_dict(const Stream& f, const PdfLexbuf& buf)
{
	pdf_obj* temp = mupdf::ppdf_parse_dict(this->m_internal, f.m_internal, buf.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_parse_ind_obj(). */
FZ_FUNCTION PdfObj PdfDocument::parse_ind_obj(const Stream& f, int *num, int *gen, int64_t *stm_ofs, int *try_repair)
{
	pdf_obj* temp = mupdf::ppdf_parse_ind_obj(this->m_internal, f.m_internal, num, gen, stm_ofs, try_repair);
	return PdfObj(temp);
}

/* Wrapper for pdf_parse_journal_obj(). */
FZ_FUNCTION PdfObj PdfDocument::parse_journal_obj(const Stream& stm, int *onum, Buffer& ostm, int *newobj)
{
	pdf_obj* temp = mupdf::ppdf_parse_journal_obj(this->m_internal, stm.m_internal, onum, &ostm.m_internal, newobj);
	return PdfObj(temp);
}

/* Wrapper for pdf_parse_link_action(). */
FZ_FUNCTION char *PdfDocument::parse_link_action(const PdfObj& obj, int pagenum)
{
	return mupdf::ppdf_parse_link_action(this->m_internal, obj.m_internal, pagenum);
}

/* Wrapper for pdf_parse_link_dest(). */
FZ_FUNCTION char *PdfDocument::parse_link_dest(const PdfObj& obj)
{
	return mupdf::ppdf_parse_link_dest(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_parse_stm_obj(). */
FZ_FUNCTION PdfObj PdfDocument::parse_stm_obj(const Stream& f, const PdfLexbuf& buf)
{
	pdf_obj* temp = mupdf::ppdf_parse_stm_obj(this->m_internal, f.m_internal, buf.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_progressive_advance(). */
FZ_FUNCTION PdfObj PdfDocument::progressive_advance(int pagenum)
{
	pdf_obj* temp = mupdf::ppdf_progressive_advance(this->m_internal, pagenum);
	return PdfObj(temp);
}

/* Wrapper for pdf_purge_local_font_resources(). */
FZ_FUNCTION void PdfDocument::purge_local_font_resources()
{
	return mupdf::ppdf_purge_local_font_resources(this->m_internal);
}

/* Wrapper for pdf_purge_locals_from_store(). */
FZ_FUNCTION void PdfDocument::purge_locals_from_store()
{
	return mupdf::ppdf_purge_locals_from_store(this->m_internal);
}

/* Wrapper for pdf_read_journal(). */
FZ_FUNCTION void PdfDocument::read_journal(const Stream& stm)
{
	return mupdf::ppdf_read_journal(this->m_internal, stm.m_internal);
}

/* Wrapper for pdf_read_ocg(). */
FZ_FUNCTION PdfOcgDescriptor PdfDocument::read_ocg()
{
	pdf_ocg_descriptor* temp = mupdf::ppdf_read_ocg(this->m_internal);
	return PdfOcgDescriptor(temp);
}

/* Wrapper for pdf_redact_page(). */
FZ_FUNCTION int PdfDocument::redact_page(const PdfPage& page, const PdfRedactOptions& opts)
{
	return mupdf::ppdf_redact_page(this->m_internal, page.m_internal, opts.m_internal);
}

/* Wrapper for pdf_redo(). */
FZ_FUNCTION void PdfDocument::redo()
{
	return mupdf::ppdf_redo(this->m_internal);
}

/* Wrapper for pdf_repair_obj(). */
FZ_FUNCTION int PdfDocument::repair_obj(const PdfLexbuf& buf, int64_t *stmofsp, int *stmlenp, PdfObj& encrypt, PdfObj& id, PdfObj& page, int64_t *tmpofs, PdfObj& root)
{
	return mupdf::ppdf_repair_obj(this->m_internal, buf.m_internal, stmofsp, stmlenp, &encrypt.m_internal, &id.m_internal, &page.m_internal, tmpofs, &root.m_internal);
}

/* Wrapper for pdf_repair_obj_stms(). */
FZ_FUNCTION void PdfDocument::repair_obj_stms()
{
	return mupdf::ppdf_repair_obj_stms(this->m_internal);
}

/* Wrapper for pdf_repair_trailer(). */
FZ_FUNCTION void PdfDocument::repair_trailer()
{
	return mupdf::ppdf_repair_trailer(this->m_internal);
}

/* Wrapper for pdf_repair_xref(). */
FZ_FUNCTION void PdfDocument::repair_xref()
{
	return mupdf::ppdf_repair_xref(this->m_internal);
}

/* Wrapper for pdf_replace_xref(). */
FZ_FUNCTION void PdfDocument::replace_xref(const PdfXrefEntry& entries, int n)
{
	return mupdf::ppdf_replace_xref(this->m_internal, entries.m_internal, n);
}

/* Wrapper for pdf_reset_form(). */
FZ_FUNCTION void PdfDocument::reset_form(const PdfObj& fields, int exclude)
{
	return mupdf::ppdf_reset_form(this->m_internal, fields.m_internal, exclude);
}

/* Wrapper for pdf_resolve_link(). */
FZ_FUNCTION int PdfDocument::resolve_link(const char *uri, float *xp, float *yp)
{
	return mupdf::ppdf_resolve_link(this->m_internal, uri, xp, yp);
}

/* Wrapper for pdf_run_glyph(). */
FZ_FUNCTION void PdfDocument::run_glyph(const PdfObj& resources, const Buffer& contents, const Device& dev, Matrix& ctm, void *gstate, const DefaultColorspaces& default_cs)
{
	return mupdf::ppdf_run_glyph(this->m_internal, resources.m_internal, contents.m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, gstate, default_cs.m_internal);
}

/* Wrapper for pdf_save_document(). */
FZ_FUNCTION void PdfDocument::save_document(const char *filename, PdfWriteOptions& opts)
{
	return mupdf::ppdf_save_document(this->m_internal, filename, (const pdf_write_options *) &opts.do_incremental);
}

/* Wrapper for pdf_save_journal(). */
FZ_FUNCTION void PdfDocument::save_journal(const char *filename)
{
	return mupdf::ppdf_save_journal(this->m_internal, filename);
}

/* Wrapper for pdf_save_snapshot(). */
FZ_FUNCTION void PdfDocument::save_snapshot(const char *filename)
{
	return mupdf::ppdf_save_snapshot(this->m_internal, filename);
}

/* Wrapper for pdf_select_layer_config(). */
FZ_FUNCTION void PdfDocument::select_layer_config(int config_num)
{
	return mupdf::ppdf_select_layer_config(this->m_internal, config_num);
}

/* Wrapper for pdf_select_layer_config_ui(). */
FZ_FUNCTION void PdfDocument::select_layer_config_ui(int ui)
{
	return mupdf::ppdf_select_layer_config_ui(this->m_internal, ui);
}

/* Wrapper for pdf_serialise_journal(). */
FZ_FUNCTION void PdfDocument::serialise_journal(const Output& out)
{
	return mupdf::ppdf_serialise_journal(this->m_internal, out.m_internal);
}

/* Wrapper for pdf_set_annot_field_value(). */
FZ_FUNCTION int PdfDocument::set_annot_field_value(const PdfAnnot& widget, const char *text, int ignore_trigger_events)
{
	return mupdf::ppdf_set_annot_field_value(this->m_internal, widget.m_internal, text, ignore_trigger_events);
}

/* Wrapper for pdf_set_doc_event_callback(). */
FZ_FUNCTION void PdfDocument::set_doc_event_callback(pdf_doc_event_cb *event_cb, pdf_free_doc_event_data_cb *free_event_data_cb, void *data)
{
	return mupdf::ppdf_set_doc_event_callback(this->m_internal, event_cb, free_event_data_cb, data);
}

/* Wrapper for pdf_set_document_language(). */
FZ_FUNCTION void PdfDocument::set_document_language(fz_text_language lang)
{
	return mupdf::ppdf_set_document_language(this->m_internal, lang);
}

/* Wrapper for pdf_set_field_value(). */
FZ_FUNCTION int PdfDocument::set_field_value(const PdfObj& field, const char *text, int ignore_trigger_events)
{
	return mupdf::ppdf_set_field_value(this->m_internal, field.m_internal, text, ignore_trigger_events);
}

/* Wrapper for pdf_set_layer_config_as_default(). */
FZ_FUNCTION void PdfDocument::set_layer_config_as_default()
{
	return mupdf::ppdf_set_layer_config_as_default(this->m_internal);
}

/* Wrapper for pdf_set_populating_xref_trailer(). */
FZ_FUNCTION void PdfDocument::set_populating_xref_trailer(const PdfObj& trailer)
{
	return mupdf::ppdf_set_populating_xref_trailer(this->m_internal, trailer.m_internal);
}

/* Wrapper for pdf_signature_byte_range(). */
FZ_FUNCTION int PdfDocument::signature_byte_range(const PdfObj& signature, const Range& byte_range)
{
	return mupdf::ppdf_signature_byte_range(this->m_internal, signature.m_internal, byte_range.m_internal);
}

/* Wrapper for pdf_signature_contents(). */
FZ_FUNCTION size_t PdfDocument::signature_contents(const PdfObj& signature, char **contents)
{
	return mupdf::ppdf_signature_contents(this->m_internal, signature.m_internal, contents);
}

/* Wrapper for pdf_signature_hash_bytes(). */
FZ_FUNCTION Stream PdfDocument::signature_hash_bytes(const PdfObj& signature)
{
	fz_stream* temp = mupdf::ppdf_signature_hash_bytes(this->m_internal, signature.m_internal);
	return Stream(temp);
}

/* Wrapper for pdf_signature_incremental_change_since_signing(). */
FZ_FUNCTION int PdfDocument::signature_incremental_change_since_signing(const PdfObj& signature)
{
	return mupdf::ppdf_signature_incremental_change_since_signing(this->m_internal, signature.m_internal);
}

/* Wrapper for pdf_signature_is_signed(). */
FZ_FUNCTION int PdfDocument::signature_is_signed(const PdfObj& field)
{
	return mupdf::ppdf_signature_is_signed(this->m_internal, field.m_internal);
}

/* Wrapper for pdf_signature_set_value(). */
FZ_FUNCTION void PdfDocument::signature_set_value(const PdfObj& field, const PdfPkcs7Signer& signer, int64_t stime)
{
	return mupdf::ppdf_signature_set_value(this->m_internal, field.m_internal, signer.m_internal, stime);
}

/* Wrapper for pdf_toggle_layer_config_ui(). */
FZ_FUNCTION void PdfDocument::toggle_layer_config_ui(int ui)
{
	return mupdf::ppdf_toggle_layer_config_ui(this->m_internal, ui);
}

/* Wrapper for pdf_trailer(). */
FZ_FUNCTION PdfObj PdfDocument::trailer()
{
	pdf_obj* temp = mupdf::ppdf_trailer(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_undo(). */
FZ_FUNCTION void PdfDocument::undo()
{
	return mupdf::ppdf_undo(this->m_internal);
}

/* Wrapper for pdf_undoredo_state(). */
FZ_FUNCTION int PdfDocument::undoredo_state(int *steps)
{
	return mupdf::ppdf_undoredo_state(this->m_internal, steps);
}

/* Wrapper for pdf_undoredo_step(). */
FZ_FUNCTION const char *PdfDocument::undoredo_step(int step)
{
	return mupdf::ppdf_undoredo_step(this->m_internal, step);
}

/* Wrapper for pdf_update_object(). */
FZ_FUNCTION void PdfDocument::update_object(int num, const PdfObj& obj)
{
	return mupdf::ppdf_update_object(this->m_internal, num, obj.m_internal);
}

/* Wrapper for pdf_update_stream(). */
FZ_FUNCTION void PdfDocument::update_stream(const PdfObj& ref, const Buffer& buf, int compressed)
{
	return mupdf::ppdf_update_stream(this->m_internal, ref.m_internal, buf.m_internal, compressed);
}

/* Wrapper for pdf_update_xobject(). */
FZ_FUNCTION void PdfDocument::update_xobject(const PdfObj& xobj, Rect& bbox, Matrix& mat, const PdfObj& res, const Buffer& buffer)
{
	return mupdf::ppdf_update_xobject(this->m_internal, xobj.m_internal, *(fz_rect*) &bbox.x0, *(fz_matrix*) &mat.a, res.m_internal, buffer.m_internal);
}

/* Wrapper for pdf_validate_change_history(). */
FZ_FUNCTION int PdfDocument::validate_change_history()
{
	return mupdf::ppdf_validate_change_history(this->m_internal);
}

/* Wrapper for pdf_validate_changes(). */
FZ_FUNCTION int PdfDocument::validate_changes(int version)
{
	return mupdf::ppdf_validate_changes(this->m_internal, version);
}

/* Wrapper for pdf_version(). */
FZ_FUNCTION int PdfDocument::version()
{
	return mupdf::ppdf_version(this->m_internal);
}

/* Wrapper for pdf_was_pure_xfa(). */
FZ_FUNCTION int PdfDocument::was_pure_xfa()
{
	return mupdf::ppdf_was_pure_xfa(this->m_internal);
}

/* Wrapper for pdf_was_repaired(). */
FZ_FUNCTION int PdfDocument::was_repaired()
{
	return mupdf::ppdf_was_repaired(this->m_internal);
}

/* Wrapper for pdf_write_document(). */
FZ_FUNCTION void PdfDocument::write_document(const Output& out, PdfWriteOptions& opts)
{
	return mupdf::ppdf_write_document(this->m_internal, out.m_internal, (const pdf_write_options *) &opts.do_incremental);
}

/* Wrapper for pdf_write_journal(). */
FZ_FUNCTION void PdfDocument::write_journal(const Output& out)
{
	return mupdf::ppdf_write_journal(this->m_internal, out.m_internal);
}

/* Wrapper for pdf_write_snapshot(). */
FZ_FUNCTION void PdfDocument::write_snapshot(const Output& out)
{
	return mupdf::ppdf_write_snapshot(this->m_internal, out.m_internal);
}

/* Wrapper for pdf_xref_ensure_incremental_object(). */
FZ_FUNCTION int PdfDocument::xref_ensure_incremental_object(int num)
{
	return mupdf::ppdf_xref_ensure_incremental_object(this->m_internal, num);
}

/* Wrapper for pdf_xref_ensure_local_object(). */
FZ_FUNCTION void PdfDocument::xref_ensure_local_object(int num)
{
	return mupdf::ppdf_xref_ensure_local_object(this->m_internal, num);
}

/* Wrapper for pdf_xref_is_incremental(). */
FZ_FUNCTION int PdfDocument::xref_is_incremental(int num)
{
	return mupdf::ppdf_xref_is_incremental(this->m_internal, num);
}

/* Wrapper for pdf_xref_len(). */
FZ_FUNCTION int PdfDocument::xref_len()
{
	return mupdf::ppdf_xref_len(this->m_internal);
}

/* Wrapper for pdf_xref_obj_is_unsaved_signature(). */
FZ_FUNCTION int PdfDocument::xref_obj_is_unsaved_signature(const PdfObj& obj)
{
	return mupdf::ppdf_xref_obj_is_unsaved_signature(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_xref_remove_unsaved_signature(). */
FZ_FUNCTION void PdfDocument::xref_remove_unsaved_signature(const PdfObj& field)
{
	return mupdf::ppdf_xref_remove_unsaved_signature(this->m_internal, field.m_internal);
}

/* Wrapper for pdf_xref_store_unsaved_signature(). */
FZ_FUNCTION void PdfDocument::xref_store_unsaved_signature(const PdfObj& field, const PdfPkcs7Signer& signer)
{
	return mupdf::ppdf_xref_store_unsaved_signature(this->m_internal, field.m_internal, signer.m_internal);
}

FZ_FUNCTION PdfDocument::PdfDocument(pdf_document* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfDocument::~PdfDocument()
{
	mupdf::ppdf_drop_document(m_internal);
}


/* Implementation of methods for PdfFilterOptions (wrapper for pdf_filter_options). */

FZ_FUNCTION PdfFilterOptions::PdfFilterOptions(pdf_filter_options* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfFontDesc (wrapper for pdf_font_desc). */

/* Constructor using pdf_new_font_desc(). */
FZ_FUNCTION PdfFontDesc::PdfFontDesc()
{
	this->m_internal = mupdf::ppdf_new_font_desc();
}

/* Wrapper for pdf_add_hmtx(). */
FZ_FUNCTION void PdfFontDesc::add_hmtx(int lo, int hi, int w)
{
	return mupdf::ppdf_add_hmtx(this->m_internal, lo, hi, w);
}

/* Wrapper for pdf_add_vmtx(). */
FZ_FUNCTION void PdfFontDesc::add_vmtx(int lo, int hi, int x, int y, int w)
{
	return mupdf::ppdf_add_vmtx(this->m_internal, lo, hi, x, y, w);
}

/* Wrapper for pdf_end_hmtx(). */
FZ_FUNCTION void PdfFontDesc::end_hmtx()
{
	return mupdf::ppdf_end_hmtx(this->m_internal);
}

/* Wrapper for pdf_end_vmtx(). */
FZ_FUNCTION void PdfFontDesc::end_vmtx()
{
	return mupdf::ppdf_end_vmtx(this->m_internal);
}

/* Wrapper for pdf_font_cid_to_gid(). */
FZ_FUNCTION int PdfFontDesc::font_cid_to_gid(int cid)
{
	return mupdf::ppdf_font_cid_to_gid(this->m_internal, cid);
}

/* Wrapper for pdf_lookup_hmtx(). */
FZ_FUNCTION PdfHmtx PdfFontDesc::lookup_hmtx(int cid)
{
	pdf_hmtx temp = mupdf::ppdf_lookup_hmtx(this->m_internal, cid);
	return PdfHmtx(&temp);
}

/* Wrapper for pdf_lookup_vmtx(). */
FZ_FUNCTION PdfVmtx PdfFontDesc::lookup_vmtx(int cid)
{
	pdf_vmtx temp = mupdf::ppdf_lookup_vmtx(this->m_internal, cid);
	return PdfVmtx(&temp);
}

/* Wrapper for pdf_set_default_hmtx(). */
FZ_FUNCTION void PdfFontDesc::set_default_hmtx(int w)
{
	return mupdf::ppdf_set_default_hmtx(this->m_internal, w);
}

/* Wrapper for pdf_set_default_vmtx(). */
FZ_FUNCTION void PdfFontDesc::set_default_vmtx(int y, int w)
{
	return mupdf::ppdf_set_default_vmtx(this->m_internal, y, w);
}

/* Wrapper for pdf_set_font_wmode(). */
FZ_FUNCTION void PdfFontDesc::set_font_wmode(int wmode)
{
	return mupdf::ppdf_set_font_wmode(this->m_internal, wmode);
}

FZ_FUNCTION PdfFontDesc::PdfFontDesc(pdf_font_desc* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfFontResourceKey (wrapper for pdf_font_resource_key). */

FZ_FUNCTION PdfFontResourceKey::PdfFontResourceKey(pdf_font_resource_key* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfFunction (wrapper for pdf_function). */

/* Copy constructor using pdf_keep_function(). */
FZ_FUNCTION PdfFunction::PdfFunction(const PdfFunction& rhs)
: m_internal(mupdf::ppdf_keep_function(rhs.m_internal))
{
}

/* operator= using pdf_keep_function() and pdf_drop_function(). */
FZ_FUNCTION PdfFunction& PdfFunction::operator=(const PdfFunction& rhs)
{
	mupdf::ppdf_drop_function(this->m_internal);
	mupdf::ppdf_keep_function(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_eval_function(). */
FZ_FUNCTION void PdfFunction::eval_function(const float *in, int inlen, float *out, int outlen)
{
	return mupdf::ppdf_eval_function(this->m_internal, in, inlen, out, outlen);
}

/* Wrapper for pdf_function_size(). */
FZ_FUNCTION size_t PdfFunction::function_size()
{
	return mupdf::ppdf_function_size(this->m_internal);
}

FZ_FUNCTION PdfFunction::PdfFunction(pdf_function* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfFunction::~PdfFunction()
{
	mupdf::ppdf_drop_function(m_internal);
}


/* Implementation of methods for PdfGraftMap (wrapper for pdf_graft_map). */

/* Constructor using pdf_new_graft_map(). */
FZ_FUNCTION PdfGraftMap::PdfGraftMap(const PdfDocument& dst)
{
	this->m_internal = mupdf::ppdf_new_graft_map(dst.m_internal);
}

/* Copy constructor using pdf_keep_graft_map(). */
FZ_FUNCTION PdfGraftMap::PdfGraftMap(const PdfGraftMap& rhs)
: m_internal(mupdf::ppdf_keep_graft_map(rhs.m_internal))
{
}

/* operator= using pdf_keep_graft_map() and pdf_drop_graft_map(). */
FZ_FUNCTION PdfGraftMap& PdfGraftMap::operator=(const PdfGraftMap& rhs)
{
	mupdf::ppdf_drop_graft_map(this->m_internal);
	mupdf::ppdf_keep_graft_map(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_graft_mapped_object(). */
FZ_FUNCTION PdfObj PdfGraftMap::graft_mapped_object(const PdfObj& obj)
{
	pdf_obj* temp = mupdf::ppdf_graft_mapped_object(this->m_internal, obj.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_graft_mapped_page(). */
FZ_FUNCTION void PdfGraftMap::graft_mapped_page(int page_to, const PdfDocument& src, int page_from)
{
	return mupdf::ppdf_graft_mapped_page(this->m_internal, page_to, src.m_internal, page_from);
}

FZ_FUNCTION PdfGraftMap::PdfGraftMap(pdf_graft_map* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfGraftMap::~PdfGraftMap()
{
	mupdf::ppdf_drop_graft_map(m_internal);
}


/* Implementation of methods for PdfGstate (wrapper for pdf_gstate). */

FZ_FUNCTION PdfGstate::PdfGstate(pdf_gstate* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfHintPage (wrapper for pdf_hint_page). */

FZ_FUNCTION PdfHintPage::PdfHintPage(pdf_hint_page* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfHintShared (wrapper for pdf_hint_shared). */

FZ_FUNCTION PdfHintShared::PdfHintShared(pdf_hint_shared* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfHmtx (wrapper for pdf_hmtx). */

FZ_FUNCTION PdfHmtx::PdfHmtx(pdf_hmtx* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfJournal (wrapper for pdf_journal). */

/* Wrapper for pdf_discard_journal(). */
FZ_FUNCTION void PdfJournal::discard_journal()
{
	return mupdf::ppdf_discard_journal(this->m_internal);
}

FZ_FUNCTION PdfJournal::PdfJournal(pdf_journal* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfJournal::~PdfJournal()
{
	mupdf::ppdf_drop_journal(m_internal);
}


/* Implementation of methods for PdfJs (wrapper for pdf_js). */

/* Wrapper for pdf_js_event_init(). */
FZ_FUNCTION void PdfJs::js_event_init(const PdfObj& target, const char *value, int willCommit)
{
	return mupdf::ppdf_js_event_init(this->m_internal, target.m_internal, value, willCommit);
}

/* Wrapper for pdf_js_event_init_keystroke(). */
FZ_FUNCTION void PdfJs::js_event_init_keystroke(const PdfObj& target, const PdfKeystrokeEvent& evt)
{
	return mupdf::ppdf_js_event_init_keystroke(this->m_internal, target.m_internal, evt.m_internal);
}

/* Wrapper for pdf_js_event_result(). */
FZ_FUNCTION int PdfJs::js_event_result()
{
	return mupdf::ppdf_js_event_result(this->m_internal);
}

/* Wrapper for pdf_js_event_result_keystroke(). */
FZ_FUNCTION int PdfJs::js_event_result_keystroke(const PdfKeystrokeEvent& evt)
{
	return mupdf::ppdf_js_event_result_keystroke(this->m_internal, evt.m_internal);
}

/* Wrapper for pdf_js_event_result_validate(). */
FZ_FUNCTION int PdfJs::js_event_result_validate(char **newvalue)
{
	return mupdf::ppdf_js_event_result_validate(this->m_internal, newvalue);
}

/* Wrapper for pdf_js_event_value(). */
FZ_FUNCTION char *PdfJs::js_event_value()
{
	return mupdf::ppdf_js_event_value(this->m_internal);
}

/* Wrapper for pdf_js_execute(). */
FZ_FUNCTION void PdfJs::js_execute(const char *name, const char *code)
{
	return mupdf::ppdf_js_execute(this->m_internal, name, code);
}

FZ_FUNCTION PdfJs::PdfJs(pdf_js* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfJs::~PdfJs()
{
	mupdf::ppdf_drop_js(m_internal);
}


/* Implementation of methods for PdfKeystrokeEvent (wrapper for pdf_keystroke_event). */

FZ_FUNCTION PdfKeystrokeEvent::PdfKeystrokeEvent(pdf_keystroke_event* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLaunchUrlEvent (wrapper for pdf_launch_url_event). */

FZ_FUNCTION PdfLaunchUrlEvent::PdfLaunchUrlEvent(pdf_launch_url_event* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLayerConfig (wrapper for pdf_layer_config). */

FZ_FUNCTION PdfLayerConfig::PdfLayerConfig(pdf_layer_config* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLayerConfigUi (wrapper for pdf_layer_config_ui). */

FZ_FUNCTION PdfLayerConfigUi::PdfLayerConfigUi(pdf_layer_config_ui* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLexbuf (wrapper for pdf_lexbuf). */

/* Wrapper for pdf_lexbuf_fin(). */
FZ_FUNCTION void PdfLexbuf::lexbuf_fin()
{
	return mupdf::ppdf_lexbuf_fin(this->m_internal);
}

/* Wrapper for pdf_lexbuf_grow(). */
FZ_FUNCTION ptrdiff_t PdfLexbuf::lexbuf_grow()
{
	return mupdf::ppdf_lexbuf_grow(this->m_internal);
}

/* Wrapper for pdf_lexbuf_init(). */
FZ_FUNCTION void PdfLexbuf::lexbuf_init(int size)
{
	return mupdf::ppdf_lexbuf_init(this->m_internal, size);
}

FZ_FUNCTION PdfLexbuf::PdfLexbuf(pdf_lexbuf* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLexbufLarge (wrapper for pdf_lexbuf_large). */

FZ_FUNCTION PdfLexbufLarge::PdfLexbufLarge(pdf_lexbuf_large* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfLockedFields (wrapper for pdf_locked_fields). */

/* Wrapper for pdf_is_field_locked(). */
FZ_FUNCTION int PdfLockedFields::is_field_locked(const char *name)
{
	return mupdf::ppdf_is_field_locked(this->m_internal, name);
}

FZ_FUNCTION PdfLockedFields::PdfLockedFields(pdf_locked_fields* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfLockedFields::~PdfLockedFields()
{
	mupdf::ppdf_drop_locked_fields(m_internal);
}


/* Implementation of methods for PdfMailDocEvent (wrapper for pdf_mail_doc_event). */

FZ_FUNCTION PdfMailDocEvent::PdfMailDocEvent(pdf_mail_doc_event* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfMrange (wrapper for pdf_mrange). */

FZ_FUNCTION PdfMrange::PdfMrange(pdf_mrange* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfObj (wrapper for pdf_obj). */

/* Constructor using pdf_new_array(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, int initialcap)
{
	this->m_internal = mupdf::ppdf_new_array(doc.m_internal, initialcap);
}

/* Constructor using pdf_new_date(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, int64_t time)
{
	this->m_internal = mupdf::ppdf_new_date(doc.m_internal, time);
}

/* Constructor using pdf_new_indirect(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, int num, int gen)
{
	this->m_internal = mupdf::ppdf_new_indirect(doc.m_internal, num, gen);
}

/* Constructor using pdf_new_int(). */
FZ_FUNCTION PdfObj::PdfObj(int64_t i)
{
	this->m_internal = mupdf::ppdf_new_int(i);
}

/* Constructor using pdf_new_matrix(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, Matrix& mtx)
{
	this->m_internal = mupdf::ppdf_new_matrix(doc.m_internal, *(fz_matrix*) &mtx.a);
}

/* Constructor using pdf_new_name(). */
FZ_FUNCTION PdfObj::PdfObj(const char *str)
{
	this->m_internal = mupdf::ppdf_new_name(str);
}

/* Constructor using pdf_new_real(). */
FZ_FUNCTION PdfObj::PdfObj(float f)
{
	this->m_internal = mupdf::ppdf_new_real(f);
}

/* Constructor using pdf_new_rect(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, Rect& rect)
{
	this->m_internal = mupdf::ppdf_new_rect(doc.m_internal, *(fz_rect*) &rect.x0);
}

/* Constructor using pdf_new_string(). */
FZ_FUNCTION PdfObj::PdfObj(const char *str, size_t len)
{
	this->m_internal = mupdf::ppdf_new_string(str, len);
}

/* Constructor using pdf_new_xobject(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfDocument& doc, Rect& bbox, Matrix& matrix, const PdfObj& res, const Buffer& buffer)
{
	this->m_internal = mupdf::ppdf_new_xobject(doc.m_internal, *(fz_rect*) &bbox.x0, *(fz_matrix*) &matrix.a, res.m_internal, buffer.m_internal);
}

/* Copy constructor using pdf_keep_obj(). */
FZ_FUNCTION PdfObj::PdfObj(const PdfObj& rhs)
: m_internal(mupdf::ppdf_keep_obj(rhs.m_internal))
{
}

/* operator= using pdf_keep_obj() and pdf_drop_obj(). */
FZ_FUNCTION PdfObj& PdfObj::operator=(const PdfObj& rhs)
{
	mupdf::ppdf_drop_obj(this->m_internal);
	mupdf::ppdf_keep_obj(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for pdf_new_text_string(). */
FZ_FUNCTION PdfObj PdfObj::new_text_string(const char *s)
{
	pdf_obj* temp = mupdf::ppdf_new_text_string(s);
	return PdfObj(temp);
}

/* Wrapper for pdf_new_dict(). */
FZ_FUNCTION PdfObj PdfObj::new_dict(const PdfDocument& doc, int initialcap)
{
	pdf_obj* temp = mupdf::ppdf_new_dict(doc.m_internal, initialcap);
	return PdfObj(temp);
}

/* Wrapper for pdf_array_contains(). */
FZ_FUNCTION int PdfObj::array_contains(const PdfObj& obj)
{
	return mupdf::ppdf_array_contains(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_array_delete(). */
FZ_FUNCTION void PdfObj::array_delete(int index)
{
	return mupdf::ppdf_array_delete(this->m_internal, index);
}

/* Wrapper for pdf_array_find(). */
FZ_FUNCTION int PdfObj::array_find(const PdfObj& obj)
{
	return mupdf::ppdf_array_find(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_array_get(). */
FZ_FUNCTION PdfObj PdfObj::array_get(int i)
{
	pdf_obj* temp = mupdf::ppdf_array_get(this->m_internal, i);
	return PdfObj(temp);
}

/* Wrapper for pdf_array_get_bool(). */
FZ_FUNCTION int PdfObj::array_get_bool(int index)
{
	return mupdf::ppdf_array_get_bool(this->m_internal, index);
}

/* Wrapper for pdf_array_get_int(). */
FZ_FUNCTION int PdfObj::array_get_int(int index)
{
	return mupdf::ppdf_array_get_int(this->m_internal, index);
}

/* Wrapper for pdf_array_get_matrix(). */
FZ_FUNCTION Matrix PdfObj::array_get_matrix(int index)
{
	fz_matrix temp = mupdf::ppdf_array_get_matrix(this->m_internal, index);
	return Matrix(&temp);
}

/* Wrapper for pdf_array_get_name(). */
FZ_FUNCTION const char *PdfObj::array_get_name(int index)
{
	return mupdf::ppdf_array_get_name(this->m_internal, index);
}

/* Wrapper for pdf_array_get_real(). */
FZ_FUNCTION float PdfObj::array_get_real(int index)
{
	return mupdf::ppdf_array_get_real(this->m_internal, index);
}

/* Wrapper for pdf_array_get_rect(). */
FZ_FUNCTION Rect PdfObj::array_get_rect(int index)
{
	fz_rect temp = mupdf::ppdf_array_get_rect(this->m_internal, index);
	return Rect(&temp);
}

/* Wrapper for pdf_array_get_string(). */
FZ_FUNCTION const char *PdfObj::array_get_string(int index, size_t *sizep)
{
	return mupdf::ppdf_array_get_string(this->m_internal, index, sizep);
}

/* Wrapper for pdf_array_get_text_string(). */
FZ_FUNCTION const char *PdfObj::array_get_text_string(int index)
{
	return mupdf::ppdf_array_get_text_string(this->m_internal, index);
}

/* Wrapper for pdf_array_insert(). */
FZ_FUNCTION void PdfObj::array_insert(const PdfObj& obj, int index)
{
	return mupdf::ppdf_array_insert(this->m_internal, obj.m_internal, index);
}

/* Wrapper for pdf_array_insert_drop(). */
FZ_FUNCTION void PdfObj::array_insert_drop(const PdfObj& obj, int index)
{
	return mupdf::ppdf_array_insert_drop(this->m_internal, obj.m_internal, index);
}

/* Wrapper for pdf_array_len(). */
FZ_FUNCTION int PdfObj::array_len()
{
	return mupdf::ppdf_array_len(this->m_internal);
}

/* Wrapper for pdf_array_push(). */
FZ_FUNCTION void PdfObj::array_push(const PdfObj& obj)
{
	return mupdf::ppdf_array_push(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_array_push_array(). */
FZ_FUNCTION PdfObj PdfObj::array_push_array(int initial)
{
	pdf_obj* temp = mupdf::ppdf_array_push_array(this->m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_array_push_bool(). */
FZ_FUNCTION void PdfObj::array_push_bool(int x)
{
	return mupdf::ppdf_array_push_bool(this->m_internal, x);
}

/* Wrapper for pdf_array_push_dict(). */
FZ_FUNCTION PdfObj PdfObj::array_push_dict(int initial)
{
	pdf_obj* temp = mupdf::ppdf_array_push_dict(this->m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_array_push_drop(). */
FZ_FUNCTION void PdfObj::array_push_drop(const PdfObj& obj)
{
	return mupdf::ppdf_array_push_drop(this->m_internal, obj.m_internal);
}

/* Wrapper for pdf_array_push_int(). */
FZ_FUNCTION void PdfObj::array_push_int(int64_t x)
{
	return mupdf::ppdf_array_push_int(this->m_internal, x);
}

/* Wrapper for pdf_array_push_name(). */
FZ_FUNCTION void PdfObj::array_push_name(const char *x)
{
	return mupdf::ppdf_array_push_name(this->m_internal, x);
}

/* Wrapper for pdf_array_push_real(). */
FZ_FUNCTION void PdfObj::array_push_real(double x)
{
	return mupdf::ppdf_array_push_real(this->m_internal, x);
}

/* Wrapper for pdf_array_push_string(). */
FZ_FUNCTION void PdfObj::array_push_string(const char *x, size_t n)
{
	return mupdf::ppdf_array_push_string(this->m_internal, x, n);
}

/* Wrapper for pdf_array_push_text_string(). */
FZ_FUNCTION void PdfObj::array_push_text_string(const char *x)
{
	return mupdf::ppdf_array_push_text_string(this->m_internal, x);
}

/* Wrapper for pdf_array_put(). */
FZ_FUNCTION void PdfObj::array_put(int i, const PdfObj& obj)
{
	return mupdf::ppdf_array_put(this->m_internal, i, obj.m_internal);
}

/* Wrapper for pdf_array_put_drop(). */
FZ_FUNCTION void PdfObj::array_put_drop(int i, const PdfObj& obj)
{
	return mupdf::ppdf_array_put_drop(this->m_internal, i, obj.m_internal);
}

/* Wrapper for pdf_button_field_on_state(). */
FZ_FUNCTION PdfObj PdfObj::button_field_on_state()
{
	pdf_obj* temp = mupdf::ppdf_button_field_on_state(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_choice_field_option(). */
FZ_FUNCTION const char *PdfObj::choice_field_option(int exportval, int i)
{
	return mupdf::ppdf_choice_field_option(this->m_internal, exportval, i);
}

/* Wrapper for pdf_choice_field_option_count(). */
FZ_FUNCTION int PdfObj::choice_field_option_count()
{
	return mupdf::ppdf_choice_field_option_count(this->m_internal);
}

/* Wrapper for pdf_clean_obj(). */
FZ_FUNCTION void PdfObj::clean_obj()
{
	return mupdf::ppdf_clean_obj(this->m_internal);
}

/* Wrapper for pdf_copy_array(). */
FZ_FUNCTION PdfObj PdfObj::copy_array()
{
	pdf_obj* temp = mupdf::ppdf_copy_array(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_copy_dict(). */
FZ_FUNCTION PdfObj PdfObj::copy_dict()
{
	pdf_obj* temp = mupdf::ppdf_copy_dict(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_debug_obj(). */
FZ_FUNCTION void PdfObj::debug_obj()
{
	return mupdf::ppdf_debug_obj(this->m_internal);
}

/* Wrapper for pdf_debug_ref(). */
FZ_FUNCTION void PdfObj::debug_ref()
{
	return mupdf::ppdf_debug_ref(this->m_internal);
}

/* Wrapper for pdf_deep_copy_obj(). */
FZ_FUNCTION PdfObj PdfObj::deep_copy_obj()
{
	pdf_obj* temp = mupdf::ppdf_deep_copy_obj(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_del(). */
FZ_FUNCTION void PdfObj::dict_del(const PdfObj& key)
{
	return mupdf::ppdf_dict_del(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_dels(). */
FZ_FUNCTION void PdfObj::dict_dels(const char *key)
{
	return mupdf::ppdf_dict_dels(this->m_internal, key);
}

/* Wrapper for pdf_dict_get(). */
FZ_FUNCTION PdfObj PdfObj::dict_get(const PdfObj& key)
{
	pdf_obj* temp = mupdf::ppdf_dict_get(this->m_internal, key.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_get_bool(). */
FZ_FUNCTION int PdfObj::dict_get_bool(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_bool(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_date(). */
FZ_FUNCTION int64_t PdfObj::dict_get_date(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_date(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_inheritable(). */
FZ_FUNCTION PdfObj PdfObj::dict_get_inheritable(const PdfObj& key)
{
	pdf_obj* temp = mupdf::ppdf_dict_get_inheritable(this->m_internal, key.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_get_int(). */
FZ_FUNCTION int PdfObj::dict_get_int(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_int(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_key(). */
FZ_FUNCTION PdfObj PdfObj::dict_get_key(int idx)
{
	pdf_obj* temp = mupdf::ppdf_dict_get_key(this->m_internal, idx);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_get_matrix(). */
FZ_FUNCTION Matrix PdfObj::dict_get_matrix(const PdfObj& key)
{
	fz_matrix temp = mupdf::ppdf_dict_get_matrix(this->m_internal, key.m_internal);
	return Matrix(&temp);
}

/* Wrapper for pdf_dict_get_name(). */
FZ_FUNCTION const char *PdfObj::dict_get_name(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_name(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_put_drop(). */
FZ_FUNCTION void PdfObj::dict_get_put_drop(const PdfObj& key, const PdfObj& val, PdfObj& old_val)
{
	return mupdf::ppdf_dict_get_put_drop(this->m_internal, key.m_internal, val.m_internal, &old_val.m_internal);
}

/* Wrapper for pdf_dict_get_real(). */
FZ_FUNCTION float PdfObj::dict_get_real(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_real(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_rect(). */
FZ_FUNCTION Rect PdfObj::dict_get_rect(const PdfObj& key)
{
	fz_rect temp = mupdf::ppdf_dict_get_rect(this->m_internal, key.m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_dict_get_string(). */
FZ_FUNCTION const char *PdfObj::dict_get_string(const PdfObj& key, size_t *sizep)
{
	return mupdf::ppdf_dict_get_string(this->m_internal, key.m_internal, sizep);
}

/* Wrapper for pdf_dict_get_text_string(). */
FZ_FUNCTION const char *PdfObj::dict_get_text_string(const PdfObj& key)
{
	return mupdf::ppdf_dict_get_text_string(this->m_internal, key.m_internal);
}

/* Wrapper for pdf_dict_get_val(). */
FZ_FUNCTION PdfObj PdfObj::dict_get_val(int idx)
{
	pdf_obj* temp = mupdf::ppdf_dict_get_val(this->m_internal, idx);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_geta(). */
FZ_FUNCTION PdfObj PdfObj::dict_geta(const PdfObj& key, const PdfObj& abbrev)
{
	pdf_obj* temp = mupdf::ppdf_dict_geta(this->m_internal, key.m_internal, abbrev.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_getp(). */
FZ_FUNCTION PdfObj PdfObj::dict_getp(const char *path)
{
	pdf_obj* temp = mupdf::ppdf_dict_getp(this->m_internal, path);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_getp_inheritable(). */
FZ_FUNCTION PdfObj PdfObj::dict_getp_inheritable(const char *path)
{
	pdf_obj* temp = mupdf::ppdf_dict_getp_inheritable(this->m_internal, path);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_gets(). */
FZ_FUNCTION PdfObj PdfObj::dict_gets(const char *key)
{
	pdf_obj* temp = mupdf::ppdf_dict_gets(this->m_internal, key);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_getsa(). */
FZ_FUNCTION PdfObj PdfObj::dict_getsa(const char *key, const char *abbrev)
{
	pdf_obj* temp = mupdf::ppdf_dict_getsa(this->m_internal, key, abbrev);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_len(). */
FZ_FUNCTION int PdfObj::dict_len()
{
	return mupdf::ppdf_dict_len(this->m_internal);
}

/* Wrapper for pdf_dict_put(). */
FZ_FUNCTION void PdfObj::dict_put(const PdfObj& key, const PdfObj& val)
{
	return mupdf::ppdf_dict_put(this->m_internal, key.m_internal, val.m_internal);
}

/* Wrapper for pdf_dict_put_array(). */
FZ_FUNCTION PdfObj PdfObj::dict_put_array(const PdfObj& key, int initial)
{
	pdf_obj* temp = mupdf::ppdf_dict_put_array(this->m_internal, key.m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_put_bool(). */
FZ_FUNCTION void PdfObj::dict_put_bool(const PdfObj& key, int x)
{
	return mupdf::ppdf_dict_put_bool(this->m_internal, key.m_internal, x);
}

/* Wrapper for pdf_dict_put_date(). */
FZ_FUNCTION void PdfObj::dict_put_date(const PdfObj& key, int64_t time)
{
	return mupdf::ppdf_dict_put_date(this->m_internal, key.m_internal, time);
}

/* Wrapper for pdf_dict_put_dict(). */
FZ_FUNCTION PdfObj PdfObj::dict_put_dict(const PdfObj& key, int initial)
{
	pdf_obj* temp = mupdf::ppdf_dict_put_dict(this->m_internal, key.m_internal, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_put_drop(). */
FZ_FUNCTION void PdfObj::dict_put_drop(const PdfObj& key, const PdfObj& val)
{
	return mupdf::ppdf_dict_put_drop(this->m_internal, key.m_internal, val.m_internal);
}

/* Wrapper for pdf_dict_put_int(). */
FZ_FUNCTION void PdfObj::dict_put_int(const PdfObj& key, int64_t x)
{
	return mupdf::ppdf_dict_put_int(this->m_internal, key.m_internal, x);
}

/* Wrapper for pdf_dict_put_matrix(). */
FZ_FUNCTION void PdfObj::dict_put_matrix(const PdfObj& key, Matrix& x)
{
	return mupdf::ppdf_dict_put_matrix(this->m_internal, key.m_internal, *(fz_matrix*) &x.a);
}

/* Wrapper for pdf_dict_put_name(). */
FZ_FUNCTION void PdfObj::dict_put_name(const PdfObj& key, const char *x)
{
	return mupdf::ppdf_dict_put_name(this->m_internal, key.m_internal, x);
}

/* Wrapper for pdf_dict_put_real(). */
FZ_FUNCTION void PdfObj::dict_put_real(const PdfObj& key, double x)
{
	return mupdf::ppdf_dict_put_real(this->m_internal, key.m_internal, x);
}

/* Wrapper for pdf_dict_put_rect(). */
FZ_FUNCTION void PdfObj::dict_put_rect(const PdfObj& key, Rect& x)
{
	return mupdf::ppdf_dict_put_rect(this->m_internal, key.m_internal, *(fz_rect*) &x.x0);
}

/* Wrapper for pdf_dict_put_string(). */
FZ_FUNCTION void PdfObj::dict_put_string(const PdfObj& key, const char *x, size_t n)
{
	return mupdf::ppdf_dict_put_string(this->m_internal, key.m_internal, x, n);
}

/* Wrapper for pdf_dict_put_text_string(). */
FZ_FUNCTION void PdfObj::dict_put_text_string(const PdfObj& key, const char *x)
{
	return mupdf::ppdf_dict_put_text_string(this->m_internal, key.m_internal, x);
}

/* Wrapper for pdf_dict_put_val_null(). */
FZ_FUNCTION void PdfObj::dict_put_val_null(int idx)
{
	return mupdf::ppdf_dict_put_val_null(this->m_internal, idx);
}

/* Wrapper for pdf_dict_putp(). */
FZ_FUNCTION void PdfObj::dict_putp(const char *path, const PdfObj& val)
{
	return mupdf::ppdf_dict_putp(this->m_internal, path, val.m_internal);
}

/* Wrapper for pdf_dict_putp_drop(). */
FZ_FUNCTION void PdfObj::dict_putp_drop(const char *path, const PdfObj& val)
{
	return mupdf::ppdf_dict_putp_drop(this->m_internal, path, val.m_internal);
}

/* Wrapper for pdf_dict_puts(). */
FZ_FUNCTION void PdfObj::dict_puts(const char *key, const PdfObj& val)
{
	return mupdf::ppdf_dict_puts(this->m_internal, key, val.m_internal);
}

/* Wrapper for pdf_dict_puts_dict(). */
FZ_FUNCTION PdfObj PdfObj::dict_puts_dict(const char *key, int initial)
{
	pdf_obj* temp = mupdf::ppdf_dict_puts_dict(this->m_internal, key, initial);
	return PdfObj(temp);
}

/* Wrapper for pdf_dict_puts_drop(). */
FZ_FUNCTION void PdfObj::dict_puts_drop(const char *key, const PdfObj& val)
{
	return mupdf::ppdf_dict_puts_drop(this->m_internal, key, val.m_internal);
}

/* Wrapper for pdf_dirty_obj(). */
FZ_FUNCTION void PdfObj::dirty_obj()
{
	return mupdf::ppdf_dirty_obj(this->m_internal);
}

/* Wrapper for pdf_embedded_file_name(). */
FZ_FUNCTION const char *PdfObj::embedded_file_name()
{
	return mupdf::ppdf_embedded_file_name(this->m_internal);
}

/* Wrapper for pdf_embedded_file_stream(). */
FZ_FUNCTION PdfObj PdfObj::embedded_file_stream()
{
	pdf_obj* temp = mupdf::ppdf_embedded_file_stream(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_embedded_file_type(). */
FZ_FUNCTION const char *PdfObj::embedded_file_type()
{
	return mupdf::ppdf_embedded_file_type(this->m_internal);
}

/* Wrapper for pdf_field_border_style(). */
FZ_FUNCTION char *PdfObj::field_border_style()
{
	return mupdf::ppdf_field_border_style(this->m_internal);
}

/* Wrapper for pdf_field_display(). */
FZ_FUNCTION int PdfObj::field_display()
{
	return mupdf::ppdf_field_display(this->m_internal);
}

/* Wrapper for pdf_field_flags(). */
FZ_FUNCTION int PdfObj::field_flags()
{
	return mupdf::ppdf_field_flags(this->m_internal);
}

/* Wrapper for pdf_field_label(). */
FZ_FUNCTION const char *PdfObj::field_label()
{
	return mupdf::ppdf_field_label(this->m_internal);
}

/* Wrapper for pdf_field_name(). */
FZ_FUNCTION char *PdfObj::field_name()
{
	return mupdf::ppdf_field_name(this->m_internal);
}

/* Wrapper for pdf_field_set_border_style(). */
FZ_FUNCTION void PdfObj::field_set_border_style(const char *text)
{
	return mupdf::ppdf_field_set_border_style(this->m_internal, text);
}

/* Wrapper for pdf_field_set_button_caption(). */
FZ_FUNCTION void PdfObj::field_set_button_caption(const char *text)
{
	return mupdf::ppdf_field_set_button_caption(this->m_internal, text);
}

/* Wrapper for pdf_field_set_display(). */
FZ_FUNCTION void PdfObj::field_set_display(int d)
{
	return mupdf::ppdf_field_set_display(this->m_internal, d);
}

/* Wrapper for pdf_field_set_fill_color(). */
FZ_FUNCTION void PdfObj::field_set_fill_color(const PdfObj& col)
{
	return mupdf::ppdf_field_set_fill_color(this->m_internal, col.m_internal);
}

/* Wrapper for pdf_field_set_text_color(). */
FZ_FUNCTION void PdfObj::field_set_text_color(const PdfObj& col)
{
	return mupdf::ppdf_field_set_text_color(this->m_internal, col.m_internal);
}

/* Wrapper for pdf_field_type(). */
FZ_FUNCTION int PdfObj::field_type()
{
	return mupdf::ppdf_field_type(this->m_internal);
}

/* Wrapper for pdf_field_value(). */
FZ_FUNCTION const char *PdfObj::field_value()
{
	return mupdf::ppdf_field_value(this->m_internal);
}

/* Wrapper for pdf_filter_xobject_instance(). */
FZ_FUNCTION PdfObj PdfObj::filter_xobject_instance(const PdfObj& page_res, Matrix& ctm, const PdfFilterOptions& filter)
{
	pdf_obj* temp = mupdf::ppdf_filter_xobject_instance(this->m_internal, page_res.m_internal, *(fz_matrix*) &ctm.a, filter.m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_flatten_inheritable_page_items(). */
FZ_FUNCTION void PdfObj::flatten_inheritable_page_items()
{
	return mupdf::ppdf_flatten_inheritable_page_items(this->m_internal);
}

/* Wrapper for pdf_get_bound_document(). */
FZ_FUNCTION PdfDocument PdfObj::get_bound_document()
{
	pdf_document* temp = mupdf::ppdf_get_bound_document(this->m_internal);
	return PdfDocument(temp);
}

/* Wrapper for pdf_get_indirect_document(). */
FZ_FUNCTION PdfDocument PdfObj::get_indirect_document()
{
	pdf_document* temp = mupdf::ppdf_get_indirect_document(this->m_internal);
	return PdfDocument(temp);
}

/* Wrapper for pdf_is_array(). */
FZ_FUNCTION int PdfObj::is_array()
{
	return mupdf::ppdf_is_array(this->m_internal);
}

/* Wrapper for pdf_is_bool(). */
FZ_FUNCTION int PdfObj::is_bool()
{
	return mupdf::ppdf_is_bool(this->m_internal);
}

/* Wrapper for pdf_is_dict(). */
FZ_FUNCTION int PdfObj::is_dict()
{
	return mupdf::ppdf_is_dict(this->m_internal);
}

/* Wrapper for pdf_is_embedded_file(). */
FZ_FUNCTION int PdfObj::is_embedded_file()
{
	return mupdf::ppdf_is_embedded_file(this->m_internal);
}

/* Wrapper for pdf_is_indirect(). */
FZ_FUNCTION int PdfObj::is_indirect()
{
	return mupdf::ppdf_is_indirect(this->m_internal);
}

/* Wrapper for pdf_is_int(). */
FZ_FUNCTION int PdfObj::is_int()
{
	return mupdf::ppdf_is_int(this->m_internal);
}

/* Wrapper for pdf_is_jpx_image(). */
FZ_FUNCTION int PdfObj::is_jpx_image()
{
	return mupdf::ppdf_is_jpx_image(this->m_internal);
}

/* Wrapper for pdf_is_name(). */
FZ_FUNCTION int PdfObj::is_name()
{
	return mupdf::ppdf_is_name(this->m_internal);
}

/* Wrapper for pdf_is_null(). */
FZ_FUNCTION int PdfObj::is_null()
{
	return mupdf::ppdf_is_null(this->m_internal);
}

/* Wrapper for pdf_is_number(). */
FZ_FUNCTION int PdfObj::is_number()
{
	return mupdf::ppdf_is_number(this->m_internal);
}

/* Wrapper for pdf_is_real(). */
FZ_FUNCTION int PdfObj::is_real()
{
	return mupdf::ppdf_is_real(this->m_internal);
}

/* Wrapper for pdf_is_stream(). */
FZ_FUNCTION int PdfObj::is_stream()
{
	return mupdf::ppdf_is_stream(this->m_internal);
}

/* Wrapper for pdf_is_string(). */
FZ_FUNCTION int PdfObj::is_string()
{
	return mupdf::ppdf_is_string(this->m_internal);
}

/* Wrapper for pdf_line_ending_from_name(). */
FZ_FUNCTION enum pdf_line_ending PdfObj::line_ending_from_name()
{
	return mupdf::ppdf_line_ending_from_name(this->m_internal);
}

/* Wrapper for pdf_load_colorspace(). */
FZ_FUNCTION Colorspace PdfObj::load_colorspace()
{
	fz_colorspace* temp = mupdf::ppdf_load_colorspace(this->m_internal);
	return Colorspace(temp);
}

/* Wrapper for pdf_load_embedded_file(). */
FZ_FUNCTION Buffer PdfObj::load_embedded_file()
{
	fz_buffer* temp = mupdf::ppdf_load_embedded_file(this->m_internal);
	return Buffer(temp);
}

/* Wrapper for pdf_load_function(). */
FZ_FUNCTION PdfFunction PdfObj::load_function(int in, int out)
{
	pdf_function* temp = mupdf::ppdf_load_function(this->m_internal, in, out);
	return PdfFunction(temp);
}

/* Wrapper for pdf_load_raw_stream(). */
FZ_FUNCTION Buffer PdfObj::load_raw_stream()
{
	fz_buffer* temp = mupdf::ppdf_load_raw_stream(this->m_internal);
	return Buffer(temp);
}

/* Wrapper for pdf_load_stream(). */
FZ_FUNCTION Buffer PdfObj::load_stream()
{
	fz_buffer* temp = mupdf::ppdf_load_stream(this->m_internal);
	return Buffer(temp);
}

/* Wrapper for pdf_load_stream_or_string_as_utf8(). */
FZ_FUNCTION char *PdfObj::load_stream_or_string_as_utf8()
{
	return mupdf::ppdf_load_stream_or_string_as_utf8(this->m_internal);
}

/* Wrapper for pdf_lookup_field(). */
FZ_FUNCTION PdfObj PdfObj::lookup_field(const char *name)
{
	pdf_obj* temp = mupdf::ppdf_lookup_field(this->m_internal, name);
	return PdfObj(temp);
}

/* Wrapper for pdf_lookup_number(). */
FZ_FUNCTION PdfObj PdfObj::lookup_number(int needle)
{
	pdf_obj* temp = mupdf::ppdf_lookup_number(this->m_internal, needle);
	return PdfObj(temp);
}

/* Wrapper for pdf_mark_obj(). */
FZ_FUNCTION int PdfObj::mark_obj()
{
	return mupdf::ppdf_mark_obj(this->m_internal);
}

/* Wrapper for pdf_name_eq(). */
FZ_FUNCTION int PdfObj::name_eq(const PdfObj& b)
{
	return mupdf::ppdf_name_eq(this->m_internal, b.m_internal);
}

/* Wrapper for pdf_new_crypt(). */
FZ_FUNCTION PdfCrypt PdfObj::new_crypt(const PdfObj& id)
{
	pdf_crypt* temp = mupdf::ppdf_new_crypt(this->m_internal, id.m_internal);
	return PdfCrypt(temp);
}

/* Wrapper for pdf_new_utf8_from_pdf_stream_obj(). */
FZ_FUNCTION char *PdfObj::new_utf8_from_pdf_stream_obj()
{
	return mupdf::ppdf_new_utf8_from_pdf_stream_obj(this->m_internal);
}

/* Wrapper for pdf_new_utf8_from_pdf_string_obj(). */
FZ_FUNCTION char *PdfObj::new_utf8_from_pdf_string_obj()
{
	return mupdf::ppdf_new_utf8_from_pdf_string_obj(this->m_internal);
}

/* Wrapper for pdf_obj_is_dirty(). */
FZ_FUNCTION int PdfObj::obj_is_dirty()
{
	return mupdf::ppdf_obj_is_dirty(this->m_internal);
}

/* Wrapper for pdf_obj_marked(). */
FZ_FUNCTION int PdfObj::obj_marked()
{
	return mupdf::ppdf_obj_marked(this->m_internal);
}

/* Wrapper for pdf_obj_memo(). */
FZ_FUNCTION int PdfObj::obj_memo(int bit, int *memo)
{
	return mupdf::ppdf_obj_memo(this->m_internal, bit, memo);
}

/* Wrapper for pdf_obj_parent_num(). */
FZ_FUNCTION int PdfObj::obj_parent_num()
{
	return mupdf::ppdf_obj_parent_num(this->m_internal);
}

/* Wrapper for pdf_obj_refs(). */
FZ_FUNCTION int PdfObj::obj_refs()
{
	return mupdf::ppdf_obj_refs(this->m_internal);
}

/* Wrapper for pdf_objcmp(). */
FZ_FUNCTION int PdfObj::objcmp(const PdfObj& b)
{
	return mupdf::ppdf_objcmp(this->m_internal, b.m_internal);
}

/* Wrapper for pdf_objcmp_resolve(). */
FZ_FUNCTION int PdfObj::objcmp_resolve(const PdfObj& b)
{
	return mupdf::ppdf_objcmp_resolve(this->m_internal, b.m_internal);
}

/* Wrapper for pdf_open_raw_stream(). */
FZ_FUNCTION Stream PdfObj::open_raw_stream()
{
	fz_stream* temp = mupdf::ppdf_open_raw_stream(this->m_internal);
	return Stream(temp);
}

/* Wrapper for pdf_open_stream(). */
FZ_FUNCTION Stream PdfObj::open_stream()
{
	fz_stream* temp = mupdf::ppdf_open_stream(this->m_internal);
	return Stream(temp);
}

/* Wrapper for pdf_page_obj_transform(). */
FZ_FUNCTION void PdfObj::page_obj_transform(Rect& page_mediabox, Matrix& page_ctm)
{
	return mupdf::ppdf_page_obj_transform(this->m_internal, (fz_rect *) &page_mediabox.x0, (fz_matrix *) &page_ctm.a);
}

/* Wrapper for pdf_resolve_indirect(). */
FZ_FUNCTION PdfObj PdfObj::resolve_indirect()
{
	pdf_obj* temp = mupdf::ppdf_resolve_indirect(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_resolve_indirect_chain(). */
FZ_FUNCTION PdfObj PdfObj::resolve_indirect_chain()
{
	pdf_obj* temp = mupdf::ppdf_resolve_indirect_chain(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_set_int(). */
FZ_FUNCTION void PdfObj::set_int(int64_t i)
{
	return mupdf::ppdf_set_int(this->m_internal, i);
}

/* Wrapper for pdf_set_obj_memo(). */
FZ_FUNCTION void PdfObj::set_obj_memo(int bit, int memo)
{
	return mupdf::ppdf_set_obj_memo(this->m_internal, bit, memo);
}

/* Wrapper for pdf_set_obj_parent(). */
FZ_FUNCTION void PdfObj::set_obj_parent(int num)
{
	return mupdf::ppdf_set_obj_parent(this->m_internal, num);
}

/* Wrapper for pdf_set_str_len(). */
FZ_FUNCTION void PdfObj::set_str_len(size_t newlen)
{
	return mupdf::ppdf_set_str_len(this->m_internal, newlen);
}

/* Wrapper for pdf_sort_dict(). */
FZ_FUNCTION void PdfObj::sort_dict()
{
	return mupdf::ppdf_sort_dict(this->m_internal);
}

/* Wrapper for pdf_store_item(). */
FZ_FUNCTION void PdfObj::store_item(void *val, size_t itemsize)
{
	return mupdf::ppdf_store_item(this->m_internal, val, itemsize);
}

/* Wrapper for pdf_to_bool(). */
FZ_FUNCTION int PdfObj::to_bool()
{
	return mupdf::ppdf_to_bool(this->m_internal);
}

/* Wrapper for pdf_to_date(). */
FZ_FUNCTION int64_t PdfObj::to_date()
{
	return mupdf::ppdf_to_date(this->m_internal);
}

/* Wrapper for pdf_to_gen(). */
FZ_FUNCTION int PdfObj::to_gen()
{
	return mupdf::ppdf_to_gen(this->m_internal);
}

/* Wrapper for pdf_to_int(). */
FZ_FUNCTION int PdfObj::to_int()
{
	return mupdf::ppdf_to_int(this->m_internal);
}

/* Wrapper for pdf_to_int64(). */
FZ_FUNCTION int64_t PdfObj::to_int64()
{
	return mupdf::ppdf_to_int64(this->m_internal);
}

/* Wrapper for pdf_to_matrix(). */
FZ_FUNCTION Matrix PdfObj::to_matrix()
{
	fz_matrix temp = mupdf::ppdf_to_matrix(this->m_internal);
	return Matrix(&temp);
}

/* Wrapper for pdf_to_name(). */
FZ_FUNCTION const char *PdfObj::to_name()
{
	return mupdf::ppdf_to_name(this->m_internal);
}

/* Wrapper for pdf_to_num(). */
FZ_FUNCTION int PdfObj::to_num()
{
	return mupdf::ppdf_to_num(this->m_internal);
}

/* Wrapper for pdf_to_quad(). */
FZ_FUNCTION Quad PdfObj::to_quad(int offset)
{
	fz_quad temp = mupdf::ppdf_to_quad(this->m_internal, offset);
	return Quad(&temp);
}

/* Wrapper for pdf_to_real(). */
FZ_FUNCTION float PdfObj::to_real()
{
	return mupdf::ppdf_to_real(this->m_internal);
}

/* Wrapper for pdf_to_rect(). */
FZ_FUNCTION Rect PdfObj::to_rect()
{
	fz_rect temp = mupdf::ppdf_to_rect(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_to_str_buf(). */
FZ_FUNCTION char *PdfObj::to_str_buf()
{
	return mupdf::ppdf_to_str_buf(this->m_internal);
}

/* Wrapper for pdf_to_str_len(). */
FZ_FUNCTION size_t PdfObj::to_str_len()
{
	return mupdf::ppdf_to_str_len(this->m_internal);
}

/* Wrapper for pdf_to_string(). */
FZ_FUNCTION const char *PdfObj::to_string(size_t *sizep)
{
	return mupdf::ppdf_to_string(this->m_internal, sizep);
}

/* Wrapper for pdf_to_text_string(). */
FZ_FUNCTION const char *PdfObj::to_text_string()
{
	return mupdf::ppdf_to_text_string(this->m_internal);
}

/* Wrapper for pdf_unmark_obj(). */
FZ_FUNCTION void PdfObj::unmark_obj()
{
	return mupdf::ppdf_unmark_obj(this->m_internal);
}

/* Wrapper for pdf_walk_tree(). */
FZ_FUNCTION void PdfObj::walk_tree(const PdfObj& kid_name, void (*arrive)(fz_context *, pdf_obj *, void *, pdf_obj **), void (*leave)(fz_context *, pdf_obj *, void *), void *arg, PdfObj& names, PdfObj& values)
{
	return mupdf::ppdf_walk_tree(this->m_internal, kid_name.m_internal, arrive, leave, arg, &names.m_internal, &values.m_internal);
}

/* Wrapper for pdf_xobject_bbox(). */
FZ_FUNCTION Rect PdfObj::xobject_bbox()
{
	fz_rect temp = mupdf::ppdf_xobject_bbox(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_xobject_colorspace(). */
FZ_FUNCTION Colorspace PdfObj::xobject_colorspace()
{
	fz_colorspace* temp = mupdf::ppdf_xobject_colorspace(this->m_internal);
	return Colorspace(temp);
}

/* Wrapper for pdf_xobject_isolated(). */
FZ_FUNCTION int PdfObj::xobject_isolated()
{
	return mupdf::ppdf_xobject_isolated(this->m_internal);
}

/* Wrapper for pdf_xobject_knockout(). */
FZ_FUNCTION int PdfObj::xobject_knockout()
{
	return mupdf::ppdf_xobject_knockout(this->m_internal);
}

/* Wrapper for pdf_xobject_matrix(). */
FZ_FUNCTION Matrix PdfObj::xobject_matrix()
{
	fz_matrix temp = mupdf::ppdf_xobject_matrix(this->m_internal);
	return Matrix(&temp);
}

/* Wrapper for pdf_xobject_resources(). */
FZ_FUNCTION PdfObj PdfObj::xobject_resources()
{
	pdf_obj* temp = mupdf::ppdf_xobject_resources(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_xobject_transparency(). */
FZ_FUNCTION int PdfObj::xobject_transparency()
{
	return mupdf::ppdf_xobject_transparency(this->m_internal);
}

FZ_FUNCTION PdfObj::PdfObj(pdf_obj* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfObj::~PdfObj()
{
	mupdf::ppdf_drop_obj(m_internal);
}


/* Implementation of methods for PdfOcgDescriptor (wrapper for pdf_ocg_descriptor). */

FZ_FUNCTION PdfOcgDescriptor::PdfOcgDescriptor(pdf_ocg_descriptor* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfPage (wrapper for pdf_page). */

/* Wrapper for pdf_bound_page(). */
FZ_FUNCTION Rect PdfPage::bound_page()
{
	fz_rect temp = mupdf::ppdf_bound_page(this->m_internal);
	return Rect(&temp);
}

/* Wrapper for pdf_create_annot(). */
FZ_FUNCTION PdfAnnot PdfPage::create_annot(enum pdf_annot_type type)
{
	pdf_annot* temp = mupdf::ppdf_create_annot(this->m_internal, type);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_create_annot_raw(). */
FZ_FUNCTION PdfAnnot PdfPage::create_annot_raw(enum pdf_annot_type type)
{
	pdf_annot* temp = mupdf::ppdf_create_annot_raw(this->m_internal, type);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_create_link(). */
FZ_FUNCTION Link PdfPage::create_link(Rect& bbox, const char *uri)
{
	fz_link* temp = mupdf::ppdf_create_link(this->m_internal, *(fz_rect*) &bbox.x0, uri);
	return Link(temp);
}

/* Wrapper for pdf_create_signature_widget(). */
FZ_FUNCTION PdfAnnot PdfPage::create_signature_widget(char *name)
{
	pdf_annot* temp = mupdf::ppdf_create_signature_widget(this->m_internal, name);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_delete_annot(). */
FZ_FUNCTION void PdfPage::delete_annot(const PdfAnnot& annot)
{
	return mupdf::ppdf_delete_annot(this->m_internal, annot.m_internal);
}

/* Wrapper for pdf_first_annot(). */
FZ_FUNCTION PdfAnnot PdfPage::first_annot()
{
	pdf_annot* temp = mupdf::ppdf_first_annot(this->m_internal);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_first_widget(). */
FZ_FUNCTION PdfAnnot PdfPage::first_widget()
{
	pdf_annot* temp = mupdf::ppdf_first_widget(this->m_internal);
	return PdfAnnot(temp);
}

/* Wrapper for pdf_load_links(). */
FZ_FUNCTION Link PdfPage::load_links()
{
	fz_link* temp = mupdf::ppdf_load_links(this->m_internal);
	return Link(temp);
}

/* Wrapper for pdf_new_pixmap_from_page_contents_with_separations_and_usage(). */
FZ_FUNCTION Pixmap PdfPage::new_pixmap_from_page_contents_with_separations_and_usage(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha, const char *usage)
{
	fz_pixmap* temp = mupdf::ppdf_new_pixmap_from_page_contents_with_separations_and_usage(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha, usage);
	return Pixmap(temp);
}

/* Wrapper for pdf_new_pixmap_from_page_contents_with_usage(). */
FZ_FUNCTION Pixmap PdfPage::new_pixmap_from_page_contents_with_usage(Matrix& ctm, const Colorspace& cs, int alpha, const char *usage)
{
	fz_pixmap* temp = mupdf::ppdf_new_pixmap_from_page_contents_with_usage(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha, usage);
	return Pixmap(temp);
}

/* Wrapper for pdf_new_pixmap_from_page_with_separations_and_usage(). */
FZ_FUNCTION Pixmap PdfPage::new_pixmap_from_page_with_separations_and_usage(Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha, const char *usage)
{
	fz_pixmap* temp = mupdf::ppdf_new_pixmap_from_page_with_separations_and_usage(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha, usage);
	return Pixmap(temp);
}

/* Wrapper for pdf_new_pixmap_from_page_with_usage(). */
FZ_FUNCTION Pixmap PdfPage::new_pixmap_from_page_with_usage(Matrix& ctm, const Colorspace& cs, int alpha, const char *usage)
{
	fz_pixmap* temp = mupdf::ppdf_new_pixmap_from_page_with_usage(this->m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha, usage);
	return Pixmap(temp);
}

/* Wrapper for pdf_page_contents(). */
FZ_FUNCTION PdfObj PdfPage::page_contents()
{
	pdf_obj* temp = mupdf::ppdf_page_contents(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_page_event_close(). */
FZ_FUNCTION void PdfPage::page_event_close()
{
	return mupdf::ppdf_page_event_close(this->m_internal);
}

/* Wrapper for pdf_page_event_open(). */
FZ_FUNCTION void PdfPage::page_event_open()
{
	return mupdf::ppdf_page_event_open(this->m_internal);
}

/* Wrapper for pdf_page_group(). */
FZ_FUNCTION PdfObj PdfPage::page_group()
{
	pdf_obj* temp = mupdf::ppdf_page_group(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_page_presentation(). */
FZ_FUNCTION Transition PdfPage::page_presentation(Transition& transition, float *duration)
{
	fz_transition* temp = mupdf::ppdf_page_presentation(this->m_internal, (fz_transition *) &transition.type, duration);
	return Transition(temp);
}

/* Wrapper for pdf_page_resources(). */
FZ_FUNCTION PdfObj PdfPage::page_resources()
{
	pdf_obj* temp = mupdf::ppdf_page_resources(this->m_internal);
	return PdfObj(temp);
}

/* Wrapper for pdf_page_separations(). */
FZ_FUNCTION Separations PdfPage::page_separations()
{
	fz_separations* temp = mupdf::ppdf_page_separations(this->m_internal);
	return Separations(temp);
}

/* Wrapper for pdf_page_transform(). */
FZ_FUNCTION void PdfPage::page_transform(Rect& mediabox, Matrix& ctm)
{
	return mupdf::ppdf_page_transform(this->m_internal, (fz_rect *) &mediabox.x0, (fz_matrix *) &ctm.a);
}

/* Wrapper for pdf_run_page(). */
FZ_FUNCTION void PdfPage::run_page(const Device& dev, Matrix& ctm, Cookie& cookie)
{
	return mupdf::ppdf_run_page(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_annots(). */
FZ_FUNCTION void PdfPage::run_page_annots(const Device& dev, Matrix& ctm, Cookie& cookie)
{
	return mupdf::ppdf_run_page_annots(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_annots_with_usage(). */
FZ_FUNCTION void PdfPage::run_page_annots_with_usage(const Device& dev, Matrix& ctm, const char *usage, Cookie& cookie)
{
	return mupdf::ppdf_run_page_annots_with_usage(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, usage, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_contents(). */
FZ_FUNCTION void PdfPage::run_page_contents(const Device& dev, Matrix& ctm, Cookie& cookie)
{
	return mupdf::ppdf_run_page_contents(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_contents_with_usage(). */
FZ_FUNCTION void PdfPage::run_page_contents_with_usage(const Device& dev, Matrix& ctm, const char *usage, Cookie& cookie)
{
	return mupdf::ppdf_run_page_contents_with_usage(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, usage, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_widgets(). */
FZ_FUNCTION void PdfPage::run_page_widgets(const Device& dev, Matrix& ctm, Cookie& cookie)
{
	return mupdf::ppdf_run_page_widgets(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_widgets_with_usage(). */
FZ_FUNCTION void PdfPage::run_page_widgets_with_usage(const Device& dev, Matrix& ctm, const char *usage, Cookie& cookie)
{
	return mupdf::ppdf_run_page_widgets_with_usage(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, usage, &cookie.m_internal);
}

/* Wrapper for pdf_run_page_with_usage(). */
FZ_FUNCTION void PdfPage::run_page_with_usage(const Device& dev, Matrix& ctm, const char *usage, Cookie& cookie)
{
	return mupdf::ppdf_run_page_with_usage(this->m_internal, dev.m_internal, *(fz_matrix*) &ctm.a, usage, &cookie.m_internal);
}

/* Wrapper for pdf_update_page(). */
FZ_FUNCTION int PdfPage::update_page()
{
	return mupdf::ppdf_update_page(this->m_internal);
}

FZ_FUNCTION PdfPage::PdfPage(pdf_page* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfPattern (wrapper for pdf_pattern). */

/* Copy constructor using pdf_keep_pattern(). */
FZ_FUNCTION PdfPattern::PdfPattern(const PdfPattern& rhs)
: m_internal(mupdf::ppdf_keep_pattern(rhs.m_internal))
{
}

/* operator= using pdf_keep_pattern() and pdf_drop_pattern(). */
FZ_FUNCTION PdfPattern& PdfPattern::operator=(const PdfPattern& rhs)
{
	mupdf::ppdf_drop_pattern(this->m_internal);
	mupdf::ppdf_keep_pattern(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

FZ_FUNCTION PdfPattern::PdfPattern(pdf_pattern* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfPattern::~PdfPattern()
{
	mupdf::ppdf_drop_pattern(m_internal);
}


/* Implementation of methods for PdfPkcs7DistinguishedName (wrapper for pdf_pkcs7_distinguished_name). */

/* Wrapper for pdf_signature_drop_distinguished_name(). */
FZ_FUNCTION void PdfPkcs7DistinguishedName::signature_drop_distinguished_name()
{
	return mupdf::ppdf_signature_drop_distinguished_name(this->m_internal);
}

/* Wrapper for pdf_signature_format_distinguished_name(). */
FZ_FUNCTION char *PdfPkcs7DistinguishedName::signature_format_distinguished_name()
{
	return mupdf::ppdf_signature_format_distinguished_name(this->m_internal);
}

FZ_FUNCTION PdfPkcs7DistinguishedName::PdfPkcs7DistinguishedName(pdf_pkcs7_distinguished_name* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfPkcs7Signer (wrapper for pdf_pkcs7_signer). */

FZ_FUNCTION PdfPkcs7Signer::PdfPkcs7Signer(pdf_pkcs7_signer* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfPkcs7Verifier (wrapper for pdf_pkcs7_verifier). */

/* Wrapper for pdf_check_certificate(). */
FZ_FUNCTION pdf_signature_error PdfPkcs7Verifier::check_certificate(const PdfDocument& doc, const PdfObj& signature)
{
	return mupdf::ppdf_check_certificate(this->m_internal, doc.m_internal, signature.m_internal);
}

/* Wrapper for pdf_check_digest(). */
FZ_FUNCTION pdf_signature_error PdfPkcs7Verifier::check_digest(const PdfDocument& doc, const PdfObj& signature)
{
	return mupdf::ppdf_check_digest(this->m_internal, doc.m_internal, signature.m_internal);
}

/* Wrapper for pdf_check_signature(). */
FZ_FUNCTION int PdfPkcs7Verifier::check_signature(const PdfDocument& doc, const PdfObj& signature, char *ebuf, size_t ebufsize)
{
	return mupdf::ppdf_check_signature(this->m_internal, doc.m_internal, signature.m_internal, ebuf, ebufsize);
}

/* Wrapper for pdf_check_widget_certificate(). */
FZ_FUNCTION pdf_signature_error PdfPkcs7Verifier::check_widget_certificate(const PdfAnnot& widget)
{
	return mupdf::ppdf_check_widget_certificate(this->m_internal, widget.m_internal);
}

/* Wrapper for pdf_check_widget_digest(). */
FZ_FUNCTION pdf_signature_error PdfPkcs7Verifier::check_widget_digest(const PdfAnnot& widget)
{
	return mupdf::ppdf_check_widget_digest(this->m_internal, widget.m_internal);
}

/* Wrapper for pdf_signature_get_signatory(). */
FZ_FUNCTION PdfPkcs7DistinguishedName PdfPkcs7Verifier::signature_get_signatory(const PdfDocument& doc, const PdfObj& signature)
{
	pdf_pkcs7_distinguished_name* temp = mupdf::ppdf_signature_get_signatory(this->m_internal, doc.m_internal, signature.m_internal);
	return PdfPkcs7DistinguishedName(temp);
}

/* Wrapper for pdf_signature_get_widget_signatory(). */
FZ_FUNCTION PdfPkcs7DistinguishedName PdfPkcs7Verifier::signature_get_widget_signatory(const PdfAnnot& widget)
{
	pdf_pkcs7_distinguished_name* temp = mupdf::ppdf_signature_get_widget_signatory(this->m_internal, widget.m_internal);
	return PdfPkcs7DistinguishedName(temp);
}

FZ_FUNCTION PdfPkcs7Verifier::PdfPkcs7Verifier(pdf_pkcs7_verifier* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfProcessor (wrapper for pdf_processor). */

/* Constructor using pdf_new_buffer_processor(). */
FZ_FUNCTION PdfProcessor::PdfProcessor(const Buffer& buffer, int ahxencode)
{
	this->m_internal = mupdf::ppdf_new_buffer_processor(buffer.m_internal, ahxencode);
}

/* Constructor using pdf_new_filter_processor(). */
FZ_FUNCTION PdfProcessor::PdfProcessor(const PdfDocument& doc, const PdfProcessor& chain, const PdfObj& old_res, const PdfObj& new_res, int struct_parents, Matrix& transform, const PdfFilterOptions& filter)
{
	this->m_internal = mupdf::ppdf_new_filter_processor(doc.m_internal, chain.m_internal, old_res.m_internal, new_res.m_internal, struct_parents, *(fz_matrix*) &transform.a, filter.m_internal);
}

/* Constructor using pdf_new_output_processor(). */
FZ_FUNCTION PdfProcessor::PdfProcessor(const Output& out, int ahxencode)
{
	this->m_internal = mupdf::ppdf_new_output_processor(out.m_internal, ahxencode);
}

/* Constructor using pdf_new_run_processor(). */
FZ_FUNCTION PdfProcessor::PdfProcessor(const Device& dev, Matrix& ctm, const char *usage, const PdfGstate& gstate, const DefaultColorspaces& default_cs, Cookie& cookie)
{
	this->m_internal = mupdf::ppdf_new_run_processor(dev.m_internal, *(fz_matrix*) &ctm.a, usage, gstate.m_internal, default_cs.m_internal, &cookie.m_internal);
}

/* Wrapper for pdf_close_processor(). */
FZ_FUNCTION void PdfProcessor::close_processor()
{
	return mupdf::ppdf_close_processor(this->m_internal);
}

/* Wrapper for pdf_process_annot(). */
FZ_FUNCTION void PdfProcessor::process_annot(const PdfAnnot& annot, Cookie& cookie)
{
	return mupdf::ppdf_process_annot(this->m_internal, annot.m_internal, &cookie.m_internal);
}

/* Wrapper for pdf_process_contents(). */
FZ_FUNCTION void PdfProcessor::process_contents(const PdfDocument& doc, const PdfObj& obj, const PdfObj& res, Cookie& cookie)
{
	return mupdf::ppdf_process_contents(this->m_internal, doc.m_internal, obj.m_internal, res.m_internal, &cookie.m_internal);
}

/* Wrapper for pdf_process_glyph(). */
FZ_FUNCTION void PdfProcessor::process_glyph(const PdfDocument& doc, const PdfObj& resources, const Buffer& contents)
{
	return mupdf::ppdf_process_glyph(this->m_internal, doc.m_internal, resources.m_internal, contents.m_internal);
}

FZ_FUNCTION PdfProcessor::PdfProcessor(pdf_processor* internal)
: m_internal(internal)
{
}

FZ_FUNCTION PdfProcessor::~PdfProcessor()
{
	mupdf::ppdf_drop_processor(m_internal);
}


/* Implementation of methods for PdfRange (wrapper for pdf_range). */

FZ_FUNCTION PdfRange::PdfRange(pdf_range* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfRedactOptions (wrapper for pdf_redact_options). */

FZ_FUNCTION PdfRedactOptions::PdfRedactOptions(pdf_redact_options* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfRevPageMap (wrapper for pdf_rev_page_map). */

FZ_FUNCTION PdfRevPageMap::PdfRevPageMap(pdf_rev_page_map* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfTextObjectState (wrapper for pdf_text_object_state). */

/* Wrapper for pdf_tos_get_text(). */
FZ_FUNCTION Text PdfTextObjectState::tos_get_text()
{
	fz_text* temp = mupdf::ppdf_tos_get_text(this->m_internal);
	return Text(temp);
}

/* Wrapper for pdf_tos_make_trm(). */
FZ_FUNCTION int PdfTextObjectState::tos_make_trm(const PdfTextState& text, const PdfFontDesc& fontdesc, int cid, Matrix& trm)
{
	return mupdf::ppdf_tos_make_trm(this->m_internal, text.m_internal, fontdesc.m_internal, cid, (fz_matrix *) &trm.a);
}

/* Wrapper for pdf_tos_move_after_char(). */
FZ_FUNCTION void PdfTextObjectState::tos_move_after_char()
{
	return mupdf::ppdf_tos_move_after_char(this->m_internal);
}

/* Wrapper for pdf_tos_newline(). */
FZ_FUNCTION void PdfTextObjectState::tos_newline(float leading)
{
	return mupdf::ppdf_tos_newline(this->m_internal, leading);
}

/* Wrapper for pdf_tos_reset(). */
FZ_FUNCTION void PdfTextObjectState::tos_reset(int render)
{
	return mupdf::ppdf_tos_reset(this->m_internal, render);
}

/* Wrapper for pdf_tos_set_matrix(). */
FZ_FUNCTION void PdfTextObjectState::tos_set_matrix(float a, float b, float c, float d, float e, float f)
{
	return mupdf::ppdf_tos_set_matrix(this->m_internal, a, b, c, d, e, f);
}

/* Wrapper for pdf_tos_translate(). */
FZ_FUNCTION void PdfTextObjectState::tos_translate(float tx, float ty)
{
	return mupdf::ppdf_tos_translate(this->m_internal, tx, ty);
}

FZ_FUNCTION PdfTextObjectState::PdfTextObjectState(pdf_text_object_state* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfTextState (wrapper for pdf_text_state). */

FZ_FUNCTION PdfTextState::PdfTextState(pdf_text_state* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfUnsavedSig (wrapper for pdf_unsaved_sig). */

FZ_FUNCTION PdfUnsavedSig::PdfUnsavedSig(pdf_unsaved_sig* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfVmtx (wrapper for pdf_vmtx). */

FZ_FUNCTION PdfVmtx::PdfVmtx(pdf_vmtx* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfWriteOptions (wrapper for pdf_write_options). */

/* Custom constructor. */
FZ_FUNCTION PdfWriteOptions::PdfWriteOptions()
{
	/* Use memcpy() otherwise we get 'invalid array assignment' errors. */
	memcpy(this->internal(), &pdf_default_write_options, sizeof(*this->internal()));
}

/* Custom constructor. */
FZ_FUNCTION PdfWriteOptions::PdfWriteOptions(const PdfWriteOptions& rhs)
{
	/* Use memcpy() otherwise we get 'invalid array assignment' errors. */
	*this = rhs;
}

/* Wrapper for pdf_parse_write_options(). */
FZ_FUNCTION PdfWriteOptions PdfWriteOptions::parse_write_options(const char *args)
{
	pdf_write_options* temp = mupdf::ppdf_parse_write_options((pdf_write_options *) &this->do_incremental, args);
	return PdfWriteOptions(temp);
}

/* Custom method. */
FZ_FUNCTION PdfWriteOptions& PdfWriteOptions::operator=(const PdfWriteOptions& rhs)
{
	memcpy(this->internal(), rhs.internal(), sizeof(*this->internal()));
	return *this;
}

FZ_FUNCTION PdfWriteOptions::PdfWriteOptions(const pdf_write_options* internal)
{
	this->do_incremental = internal->do_incremental;
	this->do_pretty = internal->do_pretty;
	this->do_ascii = internal->do_ascii;
	this->do_compress = internal->do_compress;
	this->do_compress_images = internal->do_compress_images;
	this->do_compress_fonts = internal->do_compress_fonts;
	this->do_decompress = internal->do_decompress;
	this->do_garbage = internal->do_garbage;
	this->do_linear = internal->do_linear;
	this->do_clean = internal->do_clean;
	this->do_sanitize = internal->do_sanitize;
	this->do_appearance = internal->do_appearance;
	this->do_encrypt = internal->do_encrypt;
	this->dont_regenerate_id = internal->dont_regenerate_id;
	this->permissions = internal->permissions;
	memcpy(this->opwd_utf8, internal->opwd_utf8, sizeof(this->opwd_utf8));
	memcpy(this->upwd_utf8, internal->upwd_utf8, sizeof(this->upwd_utf8));
	this->do_snapshot = internal->do_snapshot;
}

FZ_FUNCTION PdfWriteOptions::PdfWriteOptions(const pdf_write_options internal)
{
	this->do_incremental = internal.do_incremental;
	this->do_pretty = internal.do_pretty;
	this->do_ascii = internal.do_ascii;
	this->do_compress = internal.do_compress;
	this->do_compress_images = internal.do_compress_images;
	this->do_compress_fonts = internal.do_compress_fonts;
	this->do_decompress = internal.do_decompress;
	this->do_garbage = internal.do_garbage;
	this->do_linear = internal.do_linear;
	this->do_clean = internal.do_clean;
	this->do_sanitize = internal.do_sanitize;
	this->do_appearance = internal.do_appearance;
	this->do_encrypt = internal.do_encrypt;
	this->dont_regenerate_id = internal.dont_regenerate_id;
	this->permissions = internal.permissions;
	memcpy(this->opwd_utf8, &internal.opwd_utf8, sizeof(this->opwd_utf8));
	memcpy(this->upwd_utf8, &internal.upwd_utf8, sizeof(this->upwd_utf8));
	this->do_snapshot = internal.do_snapshot;
}

/* Constructor using raw copy of pre-existing pdf_write_options. */
FZ_FUNCTION pdf_write_options* PdfWriteOptions::internal()
{
	return (pdf_write_options*) &this->do_incremental;
}

/* Constructor using raw copy of pre-existing pdf_write_options. */
FZ_FUNCTION const pdf_write_options* PdfWriteOptions::internal() const
{
	return (const pdf_write_options*) &this->do_incremental;
}

FZ_FUNCTION std::string PdfWriteOptions::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const PdfWriteOptions& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for PdfXrange (wrapper for pdf_xrange). */

FZ_FUNCTION PdfXrange::PdfXrange(pdf_xrange* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfXref (wrapper for pdf_xref). */

/* Constructor using pdf_new_local_xref(). */
FZ_FUNCTION PdfXref::PdfXref(const PdfDocument& doc)
{
	this->m_internal = mupdf::ppdf_new_local_xref(doc.m_internal);
}

FZ_FUNCTION PdfXref::PdfXref(pdf_xref* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfXrefEntry (wrapper for pdf_xref_entry). */

FZ_FUNCTION PdfXrefEntry::PdfXrefEntry(pdf_xref_entry* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfXrefSubsec (wrapper for pdf_xref_subsec). */

FZ_FUNCTION PdfXrefSubsec::PdfXrefSubsec(pdf_xref_subsec* internal)
: m_internal(internal)
{
}


/* Implementation of methods for PdfocrOptions (wrapper for fz_pdfocr_options). */

/* Wrapper for fz_parse_pdfocr_options(). */
FZ_FUNCTION PdfocrOptions PdfocrOptions::parse_pdfocr_options(const char *args)
{
	fz_pdfocr_options* temp = mupdf::parse_pdfocr_options(this->m_internal, args);
	return PdfocrOptions(temp);
}

FZ_FUNCTION PdfocrOptions::PdfocrOptions(fz_pdfocr_options* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Pixmap (wrapper for fz_pixmap). */

/* Constructor using fz_new_pixmap(). */
FZ_FUNCTION Pixmap::Pixmap(const Colorspace& cs, int w, int h, const Separations& seps, int alpha)
{
	this->m_internal = mupdf::new_pixmap(cs.m_internal, w, h, seps.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_color_and_mask(). */
FZ_FUNCTION Pixmap::Pixmap(const Pixmap& color, const Pixmap& mask)
{
	this->m_internal = mupdf::new_pixmap_from_color_and_mask(color.m_internal, mask.m_internal);
}

/* Constructor using fz_new_pixmap_from_display_list(). */
FZ_FUNCTION Pixmap::Pixmap(const DisplayList& list, Matrix& ctm, const Colorspace& cs, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_display_list(list.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_display_list_with_separations(). */
FZ_FUNCTION Pixmap::Pixmap(const DisplayList& list, Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_display_list_with_separations(list.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_page(). */
FZ_FUNCTION Pixmap::Pixmap(const Page& page, Matrix& ctm, const Colorspace& cs, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_page(page.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_page_number(). */
FZ_FUNCTION Pixmap::Pixmap(const Document& doc, int number, Matrix& ctm, const Colorspace& cs, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_page_number(doc.m_internal, number, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_page_number_with_separations(). */
FZ_FUNCTION Pixmap::Pixmap(const Document& doc, int number, Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_page_number_with_separations(doc.m_internal, number, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_page_with_separations(). */
FZ_FUNCTION Pixmap::Pixmap(const Page& page, Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	this->m_internal = mupdf::new_pixmap_from_page_with_separations(page.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_from_pixmap(). */
FZ_FUNCTION Pixmap::Pixmap(const Pixmap& pixmap, Irect& rect)
{
	this->m_internal = mupdf::new_pixmap_from_pixmap(pixmap.m_internal, (const fz_irect *) &rect.x0);
}

/* Constructor using fz_new_pixmap_with_bbox(). */
FZ_FUNCTION Pixmap::Pixmap(const Colorspace& colorspace, Irect& bbox, const Separations& seps, int alpha)
{
	this->m_internal = mupdf::new_pixmap_with_bbox(colorspace.m_internal, *(fz_irect*) &bbox.x0, seps.m_internal, alpha);
}

/* Constructor using fz_new_pixmap_with_bbox_and_data(). */
FZ_FUNCTION Pixmap::Pixmap(const Colorspace& colorspace, Irect& rect, const Separations& seps, int alpha, unsigned char *samples)
{
	this->m_internal = mupdf::new_pixmap_with_bbox_and_data(colorspace.m_internal, *(fz_irect*) &rect.x0, seps.m_internal, alpha, samples);
}

/* Constructor using fz_new_pixmap_with_data(). */
FZ_FUNCTION Pixmap::Pixmap(const Colorspace& colorspace, int w, int h, const Separations& seps, int alpha, int stride, unsigned char *samples)
{
	this->m_internal = mupdf::new_pixmap_with_data(colorspace.m_internal, w, h, seps.m_internal, alpha, stride, samples);
}

/* Copy constructor using fz_keep_pixmap(). */
FZ_FUNCTION Pixmap::Pixmap(const Pixmap& rhs)
: m_internal(mupdf::keep_pixmap(rhs.m_internal))
{
}

/* operator= using fz_keep_pixmap() and fz_drop_pixmap(). */
FZ_FUNCTION Pixmap& Pixmap::operator=(const Pixmap& rhs)
{
	mupdf::drop_pixmap(this->m_internal);
	mupdf::keep_pixmap(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_new_pixmap_from_page_contents(). */
FZ_FUNCTION Pixmap Pixmap::new_pixmap_from_page_contents(const Page& page, Matrix& ctm, const Colorspace& cs, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_contents(page.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_page_contents_with_separations(). */
FZ_FUNCTION Pixmap Pixmap::new_pixmap_from_page_contents_with_separations(const Page& page, Matrix& ctm, const Colorspace& cs, const Separations& seps, int alpha)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_page_contents_with_separations(page.m_internal, *(fz_matrix*) &ctm.a, cs.m_internal, seps.m_internal, alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_alpha_from_gray(). */
FZ_FUNCTION Pixmap Pixmap::alpha_from_gray()
{
	fz_pixmap* temp = mupdf::alpha_from_gray(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_clear_pixmap(). */
FZ_FUNCTION void Pixmap::clear_pixmap()
{
	return mupdf::clear_pixmap(this->m_internal);
}

/* Wrapper for fz_clear_pixmap_rect_with_value(). */
FZ_FUNCTION void Pixmap::clear_pixmap_rect_with_value(int value, Irect& r)
{
	return mupdf::clear_pixmap_rect_with_value(this->m_internal, value, *(fz_irect*) &r.x0);
}

/* Wrapper for fz_clear_pixmap_with_value(). */
FZ_FUNCTION void Pixmap::clear_pixmap_with_value(int value)
{
	return mupdf::clear_pixmap_with_value(this->m_internal, value);
}

/* Wrapper for fz_clone_pixmap(). */
FZ_FUNCTION Pixmap Pixmap::clone_pixmap()
{
	fz_pixmap* temp = mupdf::clone_pixmap(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_clone_pixmap_area_with_different_seps(). */
FZ_FUNCTION Pixmap Pixmap::clone_pixmap_area_with_different_seps(Irect& bbox, const Colorspace& dcs, const Separations& seps, ColorParams& color_params, const DefaultColorspaces& default_cs)
{
	fz_pixmap* temp = mupdf::clone_pixmap_area_with_different_seps(this->m_internal, (const fz_irect *) &bbox.x0, dcs.m_internal, seps.m_internal, *(fz_color_params*) &color_params.ri, default_cs.m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_convert_indexed_pixmap_to_base(). */
FZ_FUNCTION Pixmap Pixmap::convert_indexed_pixmap_to_base()
{
	fz_pixmap* temp = mupdf::convert_indexed_pixmap_to_base(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_convert_pixmap(). */
FZ_FUNCTION Pixmap Pixmap::convert_pixmap(const Colorspace& cs_des, const Colorspace& prf, const DefaultColorspaces& default_cs, ColorParams& color_params, int keep_alpha)
{
	fz_pixmap* temp = mupdf::convert_pixmap(this->m_internal, cs_des.m_internal, prf.m_internal, default_cs.m_internal, *(fz_color_params*) &color_params.ri, keep_alpha);
	return Pixmap(temp);
}

/* Wrapper for fz_convert_separation_pixmap_to_base(). */
FZ_FUNCTION Pixmap Pixmap::convert_separation_pixmap_to_base()
{
	fz_pixmap* temp = mupdf::convert_separation_pixmap_to_base(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_decode_tile(). */
FZ_FUNCTION void Pixmap::decode_tile(const float *decode)
{
	return mupdf::decode_tile(this->m_internal, decode);
}

/* Wrapper for fz_fill_pixmap_with_color(). */
FZ_FUNCTION void Pixmap::fill_pixmap_with_color(const Colorspace& colorspace, float *color, ColorParams& color_params)
{
	return mupdf::fill_pixmap_with_color(this->m_internal, colorspace.m_internal, color, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_gamma_pixmap(). */
FZ_FUNCTION void Pixmap::gamma_pixmap(float gamma)
{
	return mupdf::gamma_pixmap(this->m_internal, gamma);
}

/* Wrapper for fz_generate_transition(). */
FZ_FUNCTION int Pixmap::generate_transition(const Pixmap& opix, const Pixmap& npix, int time, Transition& trans)
{
	return mupdf::generate_transition(this->m_internal, opix.m_internal, npix.m_internal, time, (fz_transition *) &trans.type);
}

/* Wrapper for fz_invert_pixmap(). */
FZ_FUNCTION void Pixmap::invert_pixmap()
{
	return mupdf::invert_pixmap(this->m_internal);
}

/* Wrapper for fz_invert_pixmap_luminance(). */
FZ_FUNCTION void Pixmap::invert_pixmap_luminance()
{
	return mupdf::invert_pixmap_luminance(this->m_internal);
}

/* Wrapper for fz_invert_pixmap_rect(). */
FZ_FUNCTION void Pixmap::invert_pixmap_rect(Irect& rect)
{
	return mupdf::invert_pixmap_rect(this->m_internal, *(fz_irect*) &rect.x0);
}

/* Wrapper for fz_is_pixmap_monochrome(). */
FZ_FUNCTION int Pixmap::is_pixmap_monochrome()
{
	return mupdf::is_pixmap_monochrome(this->m_internal);
}

/* Wrapper for fz_new_bitmap_from_pixmap(). */
FZ_FUNCTION Bitmap Pixmap::new_bitmap_from_pixmap(const Halftone& ht)
{
	fz_bitmap* temp = mupdf::new_bitmap_from_pixmap(this->m_internal, ht.m_internal);
	return Bitmap(temp);
}

/* Wrapper for fz_new_bitmap_from_pixmap_band(). */
FZ_FUNCTION Bitmap Pixmap::new_bitmap_from_pixmap_band(const Halftone& ht, int band_start)
{
	fz_bitmap* temp = mupdf::new_bitmap_from_pixmap_band(this->m_internal, ht.m_internal, band_start);
	return Bitmap(temp);
}

/* Wrapper for fz_new_buffer_from_pixmap_as_png(). */
FZ_FUNCTION Buffer Pixmap::new_buffer_from_pixmap_as_png(ColorParams& color_params)
{
	fz_buffer* temp = mupdf::new_buffer_from_pixmap_as_png(this->m_internal, *(fz_color_params*) &color_params.ri);
	return Buffer(temp);
}

/* Wrapper for fz_new_image_from_pixmap(). */
FZ_FUNCTION Image Pixmap::new_image_from_pixmap(const Image& mask)
{
	fz_image* temp = mupdf::new_image_from_pixmap(this->m_internal, mask.m_internal);
	return Image(temp);
}

/* Wrapper for fz_new_pixmap_from_alpha_channel(). */
FZ_FUNCTION Pixmap Pixmap::new_pixmap_from_alpha_channel()
{
	fz_pixmap* temp = mupdf::new_pixmap_from_alpha_channel(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_color_and_mask(). */
FZ_FUNCTION Pixmap Pixmap::new_pixmap_from_color_and_mask(const Pixmap& mask)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_color_and_mask(this->m_internal, mask.m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_new_pixmap_from_pixmap(). */
FZ_FUNCTION Pixmap Pixmap::new_pixmap_from_pixmap(Irect& rect)
{
	fz_pixmap* temp = mupdf::new_pixmap_from_pixmap(this->m_internal, (const fz_irect *) &rect.x0);
	return Pixmap(temp);
}

/* Wrapper for fz_pixmap_alpha(). */
FZ_FUNCTION int Pixmap::pixmap_alpha()
{
	return mupdf::pixmap_alpha(this->m_internal);
}

/* Wrapper for fz_pixmap_bbox(). */
FZ_FUNCTION Irect Pixmap::pixmap_bbox()
{
	fz_irect temp = mupdf::pixmap_bbox(this->m_internal);
	return Irect(&temp);
}

/* Wrapper for fz_pixmap_colorants(). */
FZ_FUNCTION int Pixmap::pixmap_colorants()
{
	return mupdf::pixmap_colorants(this->m_internal);
}

/* Wrapper for fz_pixmap_colorspace(). */
FZ_FUNCTION Colorspace Pixmap::pixmap_colorspace()
{
	fz_colorspace* temp = mupdf::pixmap_colorspace(this->m_internal);
	return Colorspace(temp);
}

/* Wrapper for fz_pixmap_components(). */
FZ_FUNCTION int Pixmap::pixmap_components()
{
	return mupdf::pixmap_components(this->m_internal);
}

/* Wrapper for fz_pixmap_height(). */
FZ_FUNCTION int Pixmap::pixmap_height()
{
	return mupdf::pixmap_height(this->m_internal);
}

/* Wrapper for fz_pixmap_samples(). */
FZ_FUNCTION unsigned char *Pixmap::pixmap_samples()
{
	return mupdf::pixmap_samples(this->m_internal);
}

/* Wrapper for fz_pixmap_spots(). */
FZ_FUNCTION int Pixmap::pixmap_spots()
{
	return mupdf::pixmap_spots(this->m_internal);
}

/* Wrapper for fz_pixmap_stride(). */
FZ_FUNCTION int Pixmap::pixmap_stride()
{
	return mupdf::pixmap_stride(this->m_internal);
}

/* Wrapper for fz_pixmap_width(). */
FZ_FUNCTION int Pixmap::pixmap_width()
{
	return mupdf::pixmap_width(this->m_internal);
}

/* Wrapper for fz_pixmap_x(). */
FZ_FUNCTION int Pixmap::pixmap_x()
{
	return mupdf::pixmap_x(this->m_internal);
}

/* Wrapper for fz_pixmap_y(). */
FZ_FUNCTION int Pixmap::pixmap_y()
{
	return mupdf::pixmap_y(this->m_internal);
}

/* Wrapper for fz_save_pixmap_as_pam(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pam(const char *filename)
{
	return mupdf::save_pixmap_as_pam(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_pbm(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pbm(const char *filename)
{
	return mupdf::save_pixmap_as_pbm(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_pcl(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pcl(char *filename, int append, const PclOptions& pcl)
{
	return mupdf::save_pixmap_as_pcl(this->m_internal, filename, append, pcl.m_internal);
}

/* Wrapper for fz_save_pixmap_as_pclm(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pclm(char *filename, int append, const PclmOptions& options)
{
	return mupdf::save_pixmap_as_pclm(this->m_internal, filename, append, options.m_internal);
}

/* Wrapper for fz_save_pixmap_as_pdfocr(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pdfocr(char *filename, int append, const PdfocrOptions& options)
{
	return mupdf::save_pixmap_as_pdfocr(this->m_internal, filename, append, options.m_internal);
}

/* Wrapper for fz_save_pixmap_as_pkm(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pkm(const char *filename)
{
	return mupdf::save_pixmap_as_pkm(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_png(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_png(const char *filename)
{
	return mupdf::save_pixmap_as_png(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_pnm(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pnm(const char *filename)
{
	return mupdf::save_pixmap_as_pnm(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_ps(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_ps(char *filename, int append)
{
	return mupdf::save_pixmap_as_ps(this->m_internal, filename, append);
}

/* Wrapper for fz_save_pixmap_as_psd(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_psd(const char *filename)
{
	return mupdf::save_pixmap_as_psd(this->m_internal, filename);
}

/* Wrapper for fz_save_pixmap_as_pwg(). */
FZ_FUNCTION void Pixmap::save_pixmap_as_pwg(char *filename, int append, PwgOptions& pwg)
{
	return mupdf::save_pixmap_as_pwg(this->m_internal, filename, append, &pwg.m_internal);
}

/* Wrapper for fz_set_pixmap_resolution(). */
FZ_FUNCTION void Pixmap::set_pixmap_resolution(int xres, int yres)
{
	return mupdf::set_pixmap_resolution(this->m_internal, xres, yres);
}

/* Wrapper for fz_tint_pixmap(). */
FZ_FUNCTION void Pixmap::tint_pixmap(int black, int white)
{
	return mupdf::tint_pixmap(this->m_internal, black, white);
}

/* Custom method. */
FZ_FUNCTION std::string Pixmap::md5_pixmap()
{
	unsigned char   digest[16];
	mupdf::md5_pixmap( m_internal, digest);
	return std::string( (char*) digest);
}

FZ_FUNCTION Pixmap::Pixmap(fz_pixmap* internal)
: m_internal(internal)
{
}

FZ_FUNCTION fz_storable Pixmap::storable()
{
	return m_internal->storable;
}

FZ_FUNCTION int Pixmap::x()
{
	return m_internal->x;
}

FZ_FUNCTION int Pixmap::y()
{
	return m_internal->y;
}

FZ_FUNCTION int Pixmap::w()
{
	return m_internal->w;
}

FZ_FUNCTION int Pixmap::h()
{
	return m_internal->h;
}

FZ_FUNCTION unsigned char Pixmap::n()
{
	return m_internal->n;
}

FZ_FUNCTION unsigned char Pixmap::s()
{
	return m_internal->s;
}

FZ_FUNCTION unsigned char Pixmap::alpha()
{
	return m_internal->alpha;
}

FZ_FUNCTION unsigned char Pixmap::flags()
{
	return m_internal->flags;
}

FZ_FUNCTION ptrdiff_t Pixmap::stride()
{
	return m_internal->stride;
}

FZ_FUNCTION Separations Pixmap::seps()
{
	mupdf::keep_separations(m_internal->seps);
	return m_internal->seps;
}

FZ_FUNCTION int Pixmap::xres()
{
	return m_internal->xres;
}

FZ_FUNCTION int Pixmap::yres()
{
	return m_internal->yres;
}

FZ_FUNCTION Colorspace Pixmap::colorspace()
{
	mupdf::keep_colorspace(m_internal->colorspace);
	return m_internal->colorspace;
}

FZ_FUNCTION const unsigned char *Pixmap::samples()
{
	return m_internal->samples;
}

FZ_FUNCTION Pixmap Pixmap::underlying()
{
	mupdf::keep_pixmap(m_internal->underlying);
	return m_internal->underlying;
}

FZ_FUNCTION Pixmap::~Pixmap()
{
	mupdf::drop_pixmap(m_internal);
}


/* Implementation of methods for PixmapImage (wrapper for fz_pixmap_image). */

/* Wrapper for fz_pixmap_image_tile(). */
FZ_FUNCTION Pixmap PixmapImage::pixmap_image_tile()
{
	fz_pixmap* temp = mupdf::pixmap_image_tile(this->m_internal);
	return Pixmap(temp);
}

/* Wrapper for fz_set_pixmap_image_tile(). */
FZ_FUNCTION void PixmapImage::set_pixmap_image_tile(const Pixmap& pix)
{
	return mupdf::set_pixmap_image_tile(this->m_internal, pix.m_internal);
}

FZ_FUNCTION PixmapImage::PixmapImage(fz_pixmap_image* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Point (wrapper for fz_point). */

/* Custom constructor. */
FZ_FUNCTION Point::Point(float x, float y)
: x(x), y(y)
{
}

/* Wrapper for fz_transform_point(). */
FZ_FUNCTION Point Point::transform_point(Point& point, Matrix& m)
{
	fz_point temp = mupdf::transform_point(*(fz_point*) &point.x, *(fz_matrix*) &m.a);
	return Point(&temp);
}

/* Wrapper for fz_transform_point_xy(). */
FZ_FUNCTION Point Point::transform_point_xy(float x, float y, Matrix& m)
{
	fz_point temp = mupdf::transform_point_xy(x, y, *(fz_matrix*) &m.a);
	return Point(&temp);
}

/* Wrapper for fz_transform_vector(). */
FZ_FUNCTION Point Point::transform_vector(Point& vector, Matrix& m)
{
	fz_point temp = mupdf::transform_vector(*(fz_point*) &vector.x, *(fz_matrix*) &m.a);
	return Point(&temp);
}

/* Wrapper for fz_is_point_inside_quad(). */
FZ_FUNCTION int Point::is_point_inside_quad(Quad& q)
{
	return mupdf::is_point_inside_quad(*(fz_point*) &this->x, *(fz_quad*) &q.ul);
}

/* Wrapper for fz_is_point_inside_rect(). */
FZ_FUNCTION int Point::is_point_inside_rect(Rect& r)
{
	return mupdf::is_point_inside_rect(*(fz_point*) &this->x, *(fz_rect*) &r.x0);
}

/* Wrapper for fz_normalize_vector(). */
FZ_FUNCTION Point Point::normalize_vector()
{
	fz_point temp = mupdf::normalize_vector(*(fz_point*) &this->x);
	return Point(&temp);
}

/* Wrapper for fz_transform_point(). */
FZ_FUNCTION Point Point::transform_point(Matrix& m)
{
	fz_point temp = mupdf::transform_point(*(fz_point*) &this->x, *(fz_matrix*) &m.a);
	return Point(&temp);
}

/* Wrapper for fz_transform_vector(). */
FZ_FUNCTION Point Point::transform_vector(Matrix& m)
{
	fz_point temp = mupdf::transform_vector(*(fz_point*) &this->x, *(fz_matrix*) &m.a);
	return Point(&temp);
}

/* Custom method. */
FZ_FUNCTION Point& Point::transform(const Matrix& m)
{
	double  old_x = x;
	x = old_x * m.a + y * m.c + m.e;
	y = old_x * m.b + y * m.d + m.f;
	return *this;
}

FZ_FUNCTION Point::Point(const fz_point* internal)
{
	this->x = internal->x;
	this->y = internal->y;
}

FZ_FUNCTION Point::Point(const fz_point internal)
{
	this->x = internal.x;
	this->y = internal.y;
}

/* Constructor using raw copy of pre-existing fz_point. */
FZ_FUNCTION fz_point* Point::internal()
{
	return (fz_point*) &this->x;
}

/* Constructor using raw copy of pre-existing fz_point. */
FZ_FUNCTION const fz_point* Point::internal() const
{
	return (const fz_point*) &this->x;
}

FZ_FUNCTION std::string Point::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Point& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Pool (wrapper for fz_pool). */

/* Constructor using fz_new_pool(). */
FZ_FUNCTION Pool::Pool()
{
	this->m_internal = mupdf::new_pool();
}

/* Wrapper for fz_pool_alloc(). */
FZ_FUNCTION void *Pool::pool_alloc(size_t size)
{
	return mupdf::pool_alloc(this->m_internal, size);
}

/* Wrapper for fz_pool_size(). */
FZ_FUNCTION size_t Pool::pool_size()
{
	return mupdf::pool_size(this->m_internal);
}

/* Wrapper for fz_pool_strdup(). */
FZ_FUNCTION char *Pool::pool_strdup(const char *s)
{
	return mupdf::pool_strdup(this->m_internal, s);
}

FZ_FUNCTION Pool::Pool(fz_pool* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Pool::~Pool()
{
	mupdf::drop_pool(m_internal);
}


/* Implementation of methods for PwgOptions (wrapper for fz_pwg_options). */

FZ_FUNCTION PwgOptions::PwgOptions(const fz_pwg_options* internal)
: m_internal(*internal)
{
}

FZ_FUNCTION char * PwgOptions::media_class()
{
	return m_internal.media_class;
}

FZ_FUNCTION char * PwgOptions::media_color()
{
	return m_internal.media_color;
}

FZ_FUNCTION char * PwgOptions::media_type()
{
	return m_internal.media_type;
}

FZ_FUNCTION char * PwgOptions::output_type()
{
	return m_internal.output_type;
}

FZ_FUNCTION unsigned int PwgOptions::advance_distance()
{
	return m_internal.advance_distance;
}

FZ_FUNCTION int PwgOptions::advance_media()
{
	return m_internal.advance_media;
}

FZ_FUNCTION int PwgOptions::collate()
{
	return m_internal.collate;
}

FZ_FUNCTION int PwgOptions::cut_media()
{
	return m_internal.cut_media;
}

FZ_FUNCTION int PwgOptions::duplex()
{
	return m_internal.duplex;
}

FZ_FUNCTION int PwgOptions::insert_sheet()
{
	return m_internal.insert_sheet;
}

FZ_FUNCTION int PwgOptions::jog()
{
	return m_internal.jog;
}

FZ_FUNCTION int PwgOptions::leading_edge()
{
	return m_internal.leading_edge;
}

FZ_FUNCTION int PwgOptions::manual_feed()
{
	return m_internal.manual_feed;
}

FZ_FUNCTION unsigned int PwgOptions::media_position()
{
	return m_internal.media_position;
}

FZ_FUNCTION unsigned int PwgOptions::media_weight()
{
	return m_internal.media_weight;
}

FZ_FUNCTION int PwgOptions::mirror_print()
{
	return m_internal.mirror_print;
}

FZ_FUNCTION int PwgOptions::negative_print()
{
	return m_internal.negative_print;
}

FZ_FUNCTION unsigned int PwgOptions::num_copies()
{
	return m_internal.num_copies;
}

FZ_FUNCTION int PwgOptions::orientation()
{
	return m_internal.orientation;
}

FZ_FUNCTION int PwgOptions::output_face_up()
{
	return m_internal.output_face_up;
}

FZ_FUNCTION unsigned int * PwgOptions::PageSize()
{
	return m_internal.PageSize;
}

FZ_FUNCTION int PwgOptions::separations()
{
	return m_internal.separations;
}

FZ_FUNCTION int PwgOptions::tray_switch()
{
	return m_internal.tray_switch;
}

FZ_FUNCTION int PwgOptions::tumble()
{
	return m_internal.tumble;
}

FZ_FUNCTION int PwgOptions::media_type_num()
{
	return m_internal.media_type_num;
}

FZ_FUNCTION int PwgOptions::compression()
{
	return m_internal.compression;
}

FZ_FUNCTION unsigned int PwgOptions::row_count()
{
	return m_internal.row_count;
}

FZ_FUNCTION unsigned int PwgOptions::row_feed()
{
	return m_internal.row_feed;
}

FZ_FUNCTION unsigned int PwgOptions::row_step()
{
	return m_internal.row_step;
}

FZ_FUNCTION char * PwgOptions::rendering_intent()
{
	return m_internal.rendering_intent;
}

FZ_FUNCTION char * PwgOptions::page_size_name()
{
	return m_internal.page_size_name;
}

FZ_FUNCTION std::string PwgOptions::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const PwgOptions& rhs)
{
	return out << rhs.m_internal;
}

/* Implementation of methods for Quad (wrapper for fz_quad). */

/* Constructor using fz_quad_from_rect(). */
FZ_FUNCTION Quad::Quad(Rect& r)
{
	*(fz_quad*) &this->ul = mupdf::quad_from_rect(*(fz_rect*) &r.x0);
}

/* Constructor using fz_transform_quad(). */
FZ_FUNCTION Quad::Quad(Quad& q, Matrix& m)
{
	*(fz_quad*) &this->ul = mupdf::transform_quad(*(fz_quad*) &q.ul, *(fz_matrix*) &m.a);
}

/* Custom constructor. */
FZ_FUNCTION Quad::Quad()
: ul{0,0}, ur{0,0}, ll{0,0}, lr{0,0}
{
}
/* Wrapper for fz_is_quad_inside_quad(). */
FZ_FUNCTION int Quad::is_quad_inside_quad(Quad& haystack)
{
	return mupdf::is_quad_inside_quad(*(fz_quad*) &this->ul, *(fz_quad*) &haystack.ul);
}

/* Wrapper for fz_is_quad_intersecting_quad(). */
FZ_FUNCTION int Quad::is_quad_intersecting_quad(Quad& b)
{
	return mupdf::is_quad_intersecting_quad(*(fz_quad*) &this->ul, *(fz_quad*) &b.ul);
}

/* Wrapper for fz_rect_from_quad(). */
FZ_FUNCTION Rect Quad::rect_from_quad()
{
	fz_rect temp = mupdf::rect_from_quad(*(fz_quad*) &this->ul);
	return Rect(&temp);
}

/* Wrapper for fz_transform_quad(). */
FZ_FUNCTION Quad Quad::transform_quad(Matrix& m)
{
	fz_quad temp = mupdf::transform_quad(*(fz_quad*) &this->ul, *(fz_matrix*) &m.a);
	return Quad(&temp);
}

FZ_FUNCTION Quad::Quad(const fz_quad* internal)
{
	this->ul = internal->ul;
	this->ur = internal->ur;
	this->ll = internal->ll;
	this->lr = internal->lr;
}

FZ_FUNCTION Quad::Quad(const fz_quad internal)
{
	this->ul = internal.ul;
	this->ur = internal.ur;
	this->ll = internal.ll;
	this->lr = internal.lr;
}

/* Constructor using raw copy of pre-existing fz_quad. */
FZ_FUNCTION fz_quad* Quad::internal()
{
	return (fz_quad*) &this->ul;
}

/* Constructor using raw copy of pre-existing fz_quad. */
FZ_FUNCTION const fz_quad* Quad::internal() const
{
	return (const fz_quad*) &this->ul;
}

FZ_FUNCTION std::string Quad::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Quad& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Range (wrapper for fz_range). */

FZ_FUNCTION Range::Range(fz_range* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Rect (wrapper for fz_rect). */

/* Constructor using fz_bound_display_list(). */
FZ_FUNCTION Rect::Rect(const DisplayList& list)
{
	*(fz_rect*) &this->x0 = mupdf::bound_display_list(list.m_internal);
}

/* Constructor using fz_rect_from_irect(). */
FZ_FUNCTION Rect::Rect(Irect& bbox)
{
	*(fz_rect*) &this->x0 = mupdf::rect_from_irect(*(fz_irect*) &bbox.x0);
}

/* Constructor using fz_rect_from_quad(). */
FZ_FUNCTION Rect::Rect(Quad& q)
{
	*(fz_rect*) &this->x0 = mupdf::rect_from_quad(*(fz_quad*) &q.ul);
}

/* Constructor using fz_transform_rect(). */
FZ_FUNCTION Rect::Rect(Rect& rect, Matrix& m)
{
	*(fz_rect*) &this->x0 = mupdf::transform_rect(*(fz_rect*) &rect.x0, *(fz_matrix*) &m.a);
}

/* Custom constructor. */
FZ_FUNCTION Rect::Rect(double x0, double y0, double x1, double y1)
:
x0(x0),
x1(x1),
y0(y0),
y1(y1)
{
}

/* Custom constructor. */
FZ_FUNCTION Rect::Rect(const Rect& rhs)
:
x0(rhs.x0),
x1(rhs.x1),
y0(rhs.y0),
y1(rhs.y1)
{
}

/* Custom constructor. */
FZ_FUNCTION Rect::Rect(Fixed fixed)
{
	if (0)  {}
	else if (fixed == Fixed_UNIT)       *this->internal() = ::fz_unit_rect;
	else if (fixed == Fixed_EMPTY)      *this->internal() = ::fz_empty_rect;
	else if (fixed == Fixed_INFINITE)   *this->internal() = ::fz_infinite_rect;
	else throw ErrorAbort( "Unrecognised From value");
}

/* Wrapper for fz_intersect_rect(). */
FZ_FUNCTION Rect Rect::intersect_rect(Rect& a, Rect& b)
{
	fz_rect temp = mupdf::intersect_rect(*(fz_rect*) &a.x0, *(fz_rect*) &b.x0);
	return Rect(&temp);
}

/* Wrapper for fz_union_rect(). */
FZ_FUNCTION Rect Rect::union_rect(Rect& a, Rect& b)
{
	fz_rect temp = mupdf::union_rect(*(fz_rect*) &a.x0, *(fz_rect*) &b.x0);
	return Rect(&temp);
}

/* Wrapper for fz_adjust_rect_for_stroke(). */
FZ_FUNCTION Rect Rect::adjust_rect_for_stroke(const StrokeState& stroke, Matrix& ctm)
{
	fz_rect temp = mupdf::adjust_rect_for_stroke(*(fz_rect*) &this->x0, stroke.m_internal, *(fz_matrix*) &ctm.a);
	return Rect(&temp);
}

/* Wrapper for fz_contains_rect(). */
FZ_FUNCTION int Rect::contains_rect(Rect& b)
{
	return mupdf::contains_rect(*(fz_rect*) &this->x0, *(fz_rect*) &b.x0);
}

/* Wrapper for fz_expand_rect(). */
FZ_FUNCTION Rect Rect::expand_rect(float expand)
{
	fz_rect temp = mupdf::expand_rect(*(fz_rect*) &this->x0, expand);
	return Rect(&temp);
}

/* Wrapper for fz_include_point_in_rect(). */
FZ_FUNCTION Rect Rect::include_point_in_rect(Point& p)
{
	fz_rect temp = mupdf::include_point_in_rect(*(fz_rect*) &this->x0, *(fz_point*) &p.x);
	return Rect(&temp);
}

/* Wrapper for fz_intersect_rect(). */
FZ_FUNCTION Rect Rect::intersect_rect(Rect& b)
{
	fz_rect temp = mupdf::intersect_rect(*(fz_rect*) &this->x0, *(fz_rect*) &b.x0);
	return Rect(&temp);
}

/* Wrapper for fz_irect_from_rect(). */
FZ_FUNCTION Irect Rect::irect_from_rect()
{
	fz_irect temp = mupdf::irect_from_rect(*(fz_rect*) &this->x0);
	return Irect(&temp);
}

/* Wrapper for fz_is_empty_rect(). */
FZ_FUNCTION int Rect::is_empty_rect()
{
	return mupdf::is_empty_rect(*(fz_rect*) &this->x0);
}

/* Wrapper for fz_is_infinite_rect(). */
FZ_FUNCTION int Rect::is_infinite_rect()
{
	return mupdf::is_infinite_rect(*(fz_rect*) &this->x0);
}

/* Wrapper for fz_is_valid_rect(). */
FZ_FUNCTION int Rect::is_valid_rect()
{
	return mupdf::is_valid_rect(*(fz_rect*) &this->x0);
}

/* Wrapper for fz_new_bbox_device(). */
FZ_FUNCTION Device Rect::new_bbox_device()
{
	fz_device* temp = mupdf::new_bbox_device((fz_rect *) &this->x0);
	return Device(temp);
}

/* Wrapper for fz_new_display_list(). */
FZ_FUNCTION DisplayList Rect::new_display_list()
{
	fz_display_list* temp = mupdf::new_display_list(*(fz_rect*) &this->x0);
	return DisplayList(temp);
}

/* Wrapper for fz_new_link(). */
FZ_FUNCTION Link Rect::new_link(const char *uri)
{
	fz_link* temp = mupdf::new_link(*(fz_rect*) &this->x0, uri);
	return Link(temp);
}

/* Wrapper for fz_quad_from_rect(). */
FZ_FUNCTION Quad Rect::quad_from_rect()
{
	fz_quad temp = mupdf::quad_from_rect(*(fz_rect*) &this->x0);
	return Quad(&temp);
}

/* Wrapper for fz_round_rect(). */
FZ_FUNCTION Irect Rect::round_rect()
{
	fz_irect temp = mupdf::round_rect(*(fz_rect*) &this->x0);
	return Irect(&temp);
}

/* Wrapper for fz_transform_page(). */
FZ_FUNCTION Matrix Rect::transform_page(float resolution, float rotate)
{
	fz_matrix temp = mupdf::transform_page(*(fz_rect*) &this->x0, resolution, rotate);
	return Matrix(&temp);
}

/* Wrapper for fz_transform_rect(). */
FZ_FUNCTION Rect Rect::transform_rect(Matrix& m)
{
	fz_rect temp = mupdf::transform_rect(*(fz_rect*) &this->x0, *(fz_matrix*) &m.a);
	return Rect(&temp);
}

/* Wrapper for fz_translate_rect(). */
FZ_FUNCTION Rect Rect::translate_rect(float xoff, float yoff)
{
	fz_rect temp = mupdf::translate_rect(*(fz_rect*) &this->x0, xoff, yoff);
	return Rect(&temp);
}

/* Wrapper for fz_union_rect(). */
FZ_FUNCTION Rect Rect::union_rect(Rect& b)
{
	fz_rect temp = mupdf::union_rect(*(fz_rect*) &this->x0, *(fz_rect*) &b.x0);
	return Rect(&temp);
}

/* Wrapper for pdf_signature_appearance_signed(). */
FZ_FUNCTION DisplayList Rect::pdf_signature_appearance_signed(fz_text_language lang, const Image& img, const char *left_text, const char *right_text, int include_logo)
{
	fz_display_list* temp = mupdf::ppdf_signature_appearance_signed(*(fz_rect*) &this->x0, lang, img.m_internal, left_text, right_text, include_logo);
	return DisplayList(temp);
}

/* Wrapper for pdf_signature_appearance_unsigned(). */
FZ_FUNCTION DisplayList Rect::pdf_signature_appearance_unsigned(fz_text_language lang)
{
	fz_display_list* temp = mupdf::ppdf_signature_appearance_unsigned(*(fz_rect*) &this->x0, lang);
	return DisplayList(temp);
}

/* Custom method. */
FZ_FUNCTION void Rect::transform(const Matrix& m)
{
	*(fz_rect*) &this->x0 = ::fz_transform_rect(*(fz_rect*) &this->x0, *(fz_matrix*) &m.a);
}

/* Custom method. */
FZ_FUNCTION bool Rect::contains(double x, double y)
{
	if (is_empty()) {
		return false;
	}
	return true
			&& x >= x0
			&& x < x1
			&& y >= y0
			&& y < y1
			;
}

/* Custom method. */
FZ_FUNCTION bool Rect::contains(Rect& rhs)
{
	return ::fz_contains_rect(*(fz_rect*) &x0, *(fz_rect*) &rhs.x0);
}

/* Custom method. */
FZ_FUNCTION bool Rect::is_empty()
{
	return ::fz_is_empty_rect(*(fz_rect*) &x0);
}

/* Custom method. */
FZ_FUNCTION void Rect::union_(Rect& rhs)
{
	*(fz_rect*) &x0 = ::fz_union_rect(*(fz_rect*) &x0, *(fz_rect*) &rhs.x0);
}

FZ_FUNCTION Rect::Rect(const fz_rect* internal)
{
	this->x0 = internal->x0;
	this->y0 = internal->y0;
	this->x1 = internal->x1;
	this->y1 = internal->y1;
}

FZ_FUNCTION Rect::Rect(const fz_rect internal)
{
	this->x0 = internal.x0;
	this->y0 = internal.y0;
	this->x1 = internal.x1;
	this->y1 = internal.y1;
}

/* Constructor using raw copy of pre-existing fz_rect. */
FZ_FUNCTION fz_rect* Rect::internal()
{
	return (fz_rect*) &this->x0;
}

/* Constructor using raw copy of pre-existing fz_rect. */
FZ_FUNCTION const fz_rect* Rect::internal() const
{
	return (const fz_rect*) &this->x0;
}

FZ_FUNCTION std::string Rect::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Rect& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Separations (wrapper for fz_separations). */

/* Constructor using fz_new_separations(). */
FZ_FUNCTION Separations::Separations(int controllable)
{
	this->m_internal = mupdf::new_separations(controllable);
}

/* Copy constructor using fz_keep_separations(). */
FZ_FUNCTION Separations::Separations(const Separations& rhs)
: m_internal(mupdf::keep_separations(rhs.m_internal))
{
}

/* operator= using fz_keep_separations() and fz_drop_separations(). */
FZ_FUNCTION Separations& Separations::operator=(const Separations& rhs)
{
	mupdf::drop_separations(this->m_internal);
	mupdf::keep_separations(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_add_separation(). */
FZ_FUNCTION void Separations::add_separation(const char *name, const Colorspace& cs, int cs_channel)
{
	return mupdf::add_separation(this->m_internal, name, cs.m_internal, cs_channel);
}

/* Wrapper for fz_add_separation_equivalents(). */
FZ_FUNCTION void Separations::add_separation_equivalents(uint32_t rgba, uint32_t cmyk, const char *name)
{
	return mupdf::add_separation_equivalents(this->m_internal, rgba, cmyk, name);
}

/* Wrapper for fz_clone_separations_for_overprint(). */
FZ_FUNCTION Separations Separations::clone_separations_for_overprint()
{
	fz_separations* temp = mupdf::clone_separations_for_overprint(this->m_internal);
	return Separations(temp);
}

/* Wrapper for fz_count_active_separations(). */
FZ_FUNCTION int Separations::count_active_separations()
{
	return mupdf::count_active_separations(this->m_internal);
}

/* Wrapper for fz_count_separations(). */
FZ_FUNCTION int Separations::count_separations()
{
	return mupdf::count_separations(this->m_internal);
}

/* Wrapper for fz_separation_current_behavior(). */
FZ_FUNCTION fz_separation_behavior Separations::separation_current_behavior(int separation)
{
	return mupdf::separation_current_behavior(this->m_internal, separation);
}

/* Wrapper for fz_separation_equivalent(). */
FZ_FUNCTION void Separations::separation_equivalent(int idx, const Colorspace& dst_cs, float *dst_color, const Colorspace& prf, ColorParams& color_params)
{
	return mupdf::separation_equivalent(this->m_internal, idx, dst_cs.m_internal, dst_color, prf.m_internal, *(fz_color_params*) &color_params.ri);
}

/* Wrapper for fz_separation_name(). */
FZ_FUNCTION const char *Separations::separation_name(int separation)
{
	return mupdf::separation_name(this->m_internal, separation);
}

/* Wrapper for fz_set_separation_behavior(). */
FZ_FUNCTION void Separations::set_separation_behavior(int separation, fz_separation_behavior behavior)
{
	return mupdf::set_separation_behavior(this->m_internal, separation, behavior);
}

FZ_FUNCTION Separations::Separations(fz_separations* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Separations::~Separations()
{
	mupdf::drop_separations(m_internal);
}


/* Implementation of methods for Sha256 (wrapper for fz_sha256). */

/* Wrapper for fz_sha256_final(). */
FZ_FUNCTION void Sha256::sha256_final(unsigned char digest[32])
{
	return mupdf::sha256_final(this->m_internal, digest);
}

/* Wrapper for fz_sha256_init(). */
FZ_FUNCTION void Sha256::sha256_init()
{
	return mupdf::sha256_init(this->m_internal);
}

/* Wrapper for fz_sha256_update(). */
FZ_FUNCTION void Sha256::sha256_update(const unsigned char *input, size_t inlen)
{
	return mupdf::sha256_update(this->m_internal, input, inlen);
}

FZ_FUNCTION Sha256::Sha256(fz_sha256* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Sha512 (wrapper for fz_sha512). */

/* Wrapper for fz_sha384_final(). */
FZ_FUNCTION void Sha512::sha384_final(unsigned char digest[64])
{
	return mupdf::sha384_final(this->m_internal, digest);
}

/* Wrapper for fz_sha384_init(). */
FZ_FUNCTION void Sha512::sha384_init()
{
	return mupdf::sha384_init(this->m_internal);
}

/* Wrapper for fz_sha384_update(). */
FZ_FUNCTION void Sha512::sha384_update(const unsigned char *input, size_t inlen)
{
	return mupdf::sha384_update(this->m_internal, input, inlen);
}

/* Wrapper for fz_sha512_final(). */
FZ_FUNCTION void Sha512::sha512_final(unsigned char digest[64])
{
	return mupdf::sha512_final(this->m_internal, digest);
}

/* Wrapper for fz_sha512_init(). */
FZ_FUNCTION void Sha512::sha512_init()
{
	return mupdf::sha512_init(this->m_internal);
}

/* Wrapper for fz_sha512_update(). */
FZ_FUNCTION void Sha512::sha512_update(const unsigned char *input, size_t inlen)
{
	return mupdf::sha512_update(this->m_internal, input, inlen);
}

FZ_FUNCTION Sha512::Sha512(fz_sha512* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Shade (wrapper for fz_shade). */

/* Copy constructor using fz_keep_shade(). */
FZ_FUNCTION Shade::Shade(const Shade& rhs)
: m_internal(mupdf::keep_shade(rhs.m_internal))
{
}

/* operator= using fz_keep_shade() and fz_drop_shade(). */
FZ_FUNCTION Shade& Shade::operator=(const Shade& rhs)
{
	mupdf::drop_shade(this->m_internal);
	mupdf::keep_shade(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_bound_shade(). */
FZ_FUNCTION Rect Shade::bound_shade(Matrix& ctm)
{
	fz_rect temp = mupdf::bound_shade(this->m_internal, *(fz_matrix*) &ctm.a);
	return Rect(&temp);
}

/* Wrapper for fz_paint_shade(). */
FZ_FUNCTION void Shade::paint_shade(const Colorspace& override_cs, Matrix& ctm, const Pixmap& dest, ColorParams& color_params, Irect& bbox, const Overprint& eop, ShadeColorCache& cache)
{
	return mupdf::paint_shade(this->m_internal, override_cs.m_internal, *(fz_matrix*) &ctm.a, dest.m_internal, *(fz_color_params*) &color_params.ri, *(fz_irect*) &bbox.x0, eop.m_internal, &cache.m_internal);
}

/* Wrapper for fz_process_shade(). */
FZ_FUNCTION void Shade::process_shade(Matrix& ctm, Rect& scissor, fz_shade_prepare_fn *prepare, fz_shade_process_fn *process, void *process_arg)
{
	return mupdf::process_shade(this->m_internal, *(fz_matrix*) &ctm.a, *(fz_rect*) &scissor.x0, prepare, process, process_arg);
}

/* Custom method. */
FZ_FUNCTION void Shade::paint_shade_no_cache(const Colorspace& override_cs, Matrix& ctm, const Pixmap& dest, ColorParams& color_params, Irect& bbox, const Overprint& eop)
{
	return mupdf::paint_shade(
			this->m_internal,
			override_cs.m_internal,
			*(fz_matrix*) &ctm.a,
			dest.m_internal,
			*(fz_color_params*) &color_params.ri,
			*(fz_irect*) &bbox.x0,
			eop.m_internal,
			NULL /*cache*/
			);
}

FZ_FUNCTION Shade::Shade(fz_shade* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Shade::~Shade()
{
	mupdf::drop_shade(m_internal);
}


/* Implementation of methods for ShadeColorCache (wrapper for fz_shade_color_cache). */

/* Custom constructor. */
FZ_FUNCTION ShadeColorCache::ShadeColorCache()
: m_internal( NULL)
{
}

FZ_FUNCTION ShadeColorCache::ShadeColorCache(fz_shade_color_cache* internal)
: m_internal(internal)
{
}

FZ_FUNCTION ShadeColorCache::~ShadeColorCache()
{
	mupdf::drop_shade_color_cache(m_internal);
}


/* Implementation of methods for ShaperDataT (wrapper for fz_shaper_data_t). */

FZ_FUNCTION ShaperDataT::ShaperDataT(fz_shaper_data_t* internal)
: m_internal(internal)
{
}


/* Implementation of methods for StextBlock (wrapper for fz_stext_block). */

/* Custom method. */
FZ_FUNCTION Matrix StextBlock::i_transform()
{
	if (m_internal->type != FZ_STEXT_BLOCK_IMAGE) {
		throw std::runtime_error("Not an image");
	}
	return m_internal->u.i.transform;
}

/* Custom method. */
FZ_FUNCTION Image StextBlock::i_image()
{
	if (m_internal->type != FZ_STEXT_BLOCK_IMAGE) {
		throw std::runtime_error("Not an image");
	}
	return keep_image(m_internal->u.i.image);
}

/* Custom method. */
FZ_FUNCTION StextBlockIterator StextBlock::begin()
{
	return StextBlockIterator(m_internal->u.t.first_line);
}

/* Custom method. */
FZ_FUNCTION StextBlockIterator StextBlock::end()
{
	return StextBlockIterator(NULL);
}

FZ_FUNCTION StextBlock::StextBlock(fz_stext_block* internal)
: m_internal(internal)
{
}


FZ_FUNCTION StextBlockIterator::StextBlockIterator(const StextLine& item)
: m_item( item)
{
}
FZ_FUNCTION StextBlockIterator& StextBlockIterator::operator++()
{

	m_item = StextLine(m_item.m_internal->next);
	return *this;
}
FZ_FUNCTION bool StextBlockIterator::operator==( const StextBlockIterator& rhs)
{
	return m_item.m_internal == rhs.m_item.m_internal;
}
FZ_FUNCTION bool StextBlockIterator::operator!=( const StextBlockIterator& rhs)
{
	return m_item.m_internal != rhs.m_item.m_internal;
}
FZ_FUNCTION StextLine StextBlockIterator::operator*()
{
	return m_item;
}
FZ_FUNCTION StextLine* StextBlockIterator::operator->()
{
	return &m_item;
}

void test(StextBlock& item)
{
	for( StextBlockIterator it = item.begin(); it != item.end(); ++it) {
		(void) *it;
	}
	for ( auto i: item) {
		(void) i;
	}
}


/* Implementation of methods for StextChar (wrapper for fz_stext_char). */

FZ_FUNCTION StextChar::StextChar(fz_stext_char* internal)
: m_internal(internal)
{
}


/* Implementation of methods for StextLine (wrapper for fz_stext_line). */

/* Custom method. */
FZ_FUNCTION StextLineIterator StextLine::begin()
{
	return StextLineIterator(m_internal->first_char);
}

/* Custom method. */
FZ_FUNCTION StextLineIterator StextLine::end()
{
	return StextLineIterator(NULL);
}

FZ_FUNCTION StextLine::StextLine(fz_stext_line* internal)
: m_internal(internal)
{
}


FZ_FUNCTION StextLineIterator::StextLineIterator(const StextChar& item)
: m_item( item)
{
}
FZ_FUNCTION StextLineIterator& StextLineIterator::operator++()
{

	m_item = StextChar(m_item.m_internal->next);
	return *this;
}
FZ_FUNCTION bool StextLineIterator::operator==( const StextLineIterator& rhs)
{
	return m_item.m_internal == rhs.m_item.m_internal;
}
FZ_FUNCTION bool StextLineIterator::operator!=( const StextLineIterator& rhs)
{
	return m_item.m_internal != rhs.m_item.m_internal;
}
FZ_FUNCTION StextChar StextLineIterator::operator*()
{
	return m_item;
}
FZ_FUNCTION StextChar* StextLineIterator::operator->()
{
	return &m_item;
}

void test(StextLine& item)
{
	for( StextLineIterator it = item.begin(); it != item.end(); ++it) {
		(void) *it;
	}
	for ( auto i: item) {
		(void) i;
	}
}


/* Implementation of methods for StextOptions (wrapper for fz_stext_options). */

/* Custom constructor. */
FZ_FUNCTION StextOptions::StextOptions()
: flags( 0)
{
}

/* Custom constructor. */
FZ_FUNCTION StextOptions::StextOptions(int flags)
: flags( flags)
{
}

/* Wrapper for fz_parse_stext_options(). */
FZ_FUNCTION StextOptions StextOptions::parse_stext_options(const char *string)
{
	fz_stext_options* temp = mupdf::parse_stext_options((fz_stext_options *) &this->flags, string);
	return StextOptions(temp);
}

FZ_FUNCTION StextOptions::StextOptions(const fz_stext_options* internal)
{
	this->flags = internal->flags;
}

FZ_FUNCTION StextOptions::StextOptions(const fz_stext_options internal)
{
	this->flags = internal.flags;
}

/* Constructor using raw copy of pre-existing fz_stext_options. */
FZ_FUNCTION fz_stext_options* StextOptions::internal()
{
	return (fz_stext_options*) &this->flags;
}

/* Constructor using raw copy of pre-existing fz_stext_options. */
FZ_FUNCTION const fz_stext_options* StextOptions::internal() const
{
	return (const fz_stext_options*) &this->flags;
}

FZ_FUNCTION std::string StextOptions::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const StextOptions& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for StextPage (wrapper for fz_stext_page). */

/* Constructor using fz_new_stext_page(). */
FZ_FUNCTION StextPage::StextPage(Rect& mediabox)
{
	this->m_internal = mupdf::new_stext_page(*(fz_rect*) &mediabox.x0);
}

/* Constructor using fz_new_stext_page_from_chapter_page_number(). */
FZ_FUNCTION StextPage::StextPage(const Document& doc, int chapter, int number, StextOptions& options)
{
	this->m_internal = mupdf::new_stext_page_from_chapter_page_number(doc.m_internal, chapter, number, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_stext_page_from_display_list(). */
FZ_FUNCTION StextPage::StextPage(const DisplayList& list, StextOptions& options)
{
	this->m_internal = mupdf::new_stext_page_from_display_list(list.m_internal, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_stext_page_from_page(). */
FZ_FUNCTION StextPage::StextPage(const Page& page, StextOptions& options)
{
	this->m_internal = mupdf::new_stext_page_from_page(page.m_internal, (const fz_stext_options *) &options.flags);
}

/* Constructor using fz_new_stext_page_from_page_number(). */
FZ_FUNCTION StextPage::StextPage(const Document& doc, int number, StextOptions& options)
{
	this->m_internal = mupdf::new_stext_page_from_page_number(doc.m_internal, number, (const fz_stext_options *) &options.flags);
}

/* Wrapper for fz_highlight_selection(). */
FZ_FUNCTION int StextPage::highlight_selection(Point& a, Point& b, Quad& quads, int max_quads)
{
	return mupdf::highlight_selection(this->m_internal, *(fz_point*) &a.x, *(fz_point*) &b.x, (fz_quad *) &quads.ul, max_quads);
}

/* Wrapper for fz_new_buffer_from_stext_page(). */
FZ_FUNCTION Buffer StextPage::new_buffer_from_stext_page()
{
	fz_buffer* temp = mupdf::new_buffer_from_stext_page(this->m_internal);
	return Buffer(temp);
}

/* Wrapper for fz_new_stext_device(). */
FZ_FUNCTION Device StextPage::new_stext_device(StextOptions& options)
{
	fz_device* temp = mupdf::new_stext_device(this->m_internal, (const fz_stext_options *) &options.flags);
	return Device(temp);
}

/* Wrapper for fz_search_stext_page(). */
FZ_FUNCTION int StextPage::search_stext_page(const char *needle, Quad& quads, int max_quads)
{
	return mupdf::search_stext_page(this->m_internal, needle, (fz_quad *) &quads.ul, max_quads);
}

/* Wrapper for fz_snap_selection(). */
FZ_FUNCTION Quad StextPage::snap_selection(Point& ap, Point& bp, int mode)
{
	fz_quad temp = mupdf::snap_selection(this->m_internal, (fz_point *) &ap.x, (fz_point *) &bp.x, mode);
	return Quad(&temp);
}

/* Custom method. */
FZ_FUNCTION std::string StextPage::copy_selection(Point& a, Point& b, int crlf)
{
	char* text = mupdf::copy_selection(m_internal, *(fz_point *) &a.x, *(fz_point *) &b.x, crlf);
	std::string ret(text);
	mupdf::free(text);
	return ret;
}

/* Custom method. */
FZ_FUNCTION std::string StextPage::copy_rectangle(Rect& area, int crlf)
{
	char* text = mupdf::copy_rectangle(m_internal, *(fz_rect*) &area.x0, crlf);
	std::string ret(text);
	mupdf::free(text);
	return ret;
}

/* Custom method. */
FZ_FUNCTION StextPageIterator StextPage::begin()
{
	return StextPageIterator(m_internal->first_block);
}

/* Custom method. */
FZ_FUNCTION StextPageIterator StextPage::end()
{
	return StextPageIterator(NULL);
}

FZ_FUNCTION StextPage::StextPage(fz_stext_page* internal)
: m_internal(internal)
{
}

FZ_FUNCTION StextPage::~StextPage()
{
	mupdf::drop_stext_page(m_internal);
}


FZ_FUNCTION StextPageIterator::StextPageIterator(const StextBlock& item)
: m_item( item)
{
}
FZ_FUNCTION StextPageIterator& StextPageIterator::operator++()
{

	m_item = StextBlock(m_item.m_internal->next);
	return *this;
}
FZ_FUNCTION bool StextPageIterator::operator==( const StextPageIterator& rhs)
{
	return m_item.m_internal == rhs.m_item.m_internal;
}
FZ_FUNCTION bool StextPageIterator::operator!=( const StextPageIterator& rhs)
{
	return m_item.m_internal != rhs.m_item.m_internal;
}
FZ_FUNCTION StextBlock StextPageIterator::operator*()
{
	return m_item;
}
FZ_FUNCTION StextBlock* StextPageIterator::operator->()
{
	return &m_item;
}

void test(StextPage& item)
{
	for( StextPageIterator it = item.begin(); it != item.end(); ++it) {
		(void) *it;
	}
	for ( auto i: item) {
		(void) i;
	}
}


/* Implementation of methods for Storable (wrapper for fz_storable). */

/* Copy constructor using fz_keep_storable(). */
FZ_FUNCTION Storable::Storable(const Storable& rhs)
: m_internal((fz_storable*) mupdf::keep_storable(rhs.m_internal))
{
}

/* operator= using fz_keep_storable() and fz_drop_storable(). */
FZ_FUNCTION Storable& Storable::operator=(const Storable& rhs)
{
	mupdf::drop_storable(this->m_internal);
	mupdf::keep_storable(rhs.m_internal);
	this->m_internal = (fz_storable*) rhs.m_internal;
	return *this;
}

FZ_FUNCTION Storable::Storable(fz_storable* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Storable::~Storable()
{
	mupdf::drop_storable(m_internal);
}


/* Implementation of methods for Store (wrapper for fz_store). */

FZ_FUNCTION Store::Store(fz_store* internal)
: m_internal(internal)
{
}


/* Implementation of methods for StoreHash (wrapper for fz_store_hash). */

FZ_FUNCTION StoreHash::StoreHash(fz_store_hash* internal)
: m_internal(internal)
{
}


/* Implementation of methods for StoreType (wrapper for fz_store_type). */

FZ_FUNCTION StoreType::StoreType(fz_store_type* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Stream (wrapper for fz_stream). */

/* Constructor using fz_new_stream(). */
FZ_FUNCTION Stream::Stream(void *state, fz_stream_next_fn *next, fz_stream_drop_fn *drop)
{
	this->m_internal = mupdf::new_stream(state, next, drop);
}

/* Constructor using fz_open_file(). */
FZ_FUNCTION Stream::Stream(const char *filename)
{
	this->m_internal = mupdf::open_file(filename);
}

/* Constructor using fz_open_file_ptr_no_close(). */
FZ_FUNCTION Stream::Stream(FILE *file)
{
	this->m_internal = mupdf::open_file_ptr_no_close(file);
}

/* Constructor using fz_open_memory(). */
FZ_FUNCTION Stream::Stream(const unsigned char *data, size_t len)
{
	this->m_internal = mupdf::open_memory(data, len);
}

/* Custom constructor. */
FZ_FUNCTION Stream::Stream(const std::string& filename)
: m_internal(mupdf::open_file(filename.c_str()))
{
}

/* Copy constructor using fz_keep_stream(). */
FZ_FUNCTION Stream::Stream(const Stream& rhs)
: m_internal(mupdf::keep_stream(rhs.m_internal))
{
}

/* operator= using fz_keep_stream() and fz_drop_stream(). */
FZ_FUNCTION Stream& Stream::operator=(const Stream& rhs)
{
	mupdf::drop_stream(this->m_internal);
	mupdf::keep_stream(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_available(). */
FZ_FUNCTION size_t Stream::available(size_t max)
{
	return mupdf::available(this->m_internal, max);
}

/* Wrapper for fz_concat_push_drop(). */
FZ_FUNCTION void Stream::concat_push_drop(const Stream& chain)
{
	return mupdf::concat_push_drop(this->m_internal, chain.m_internal);
}

/* Wrapper for fz_decomp_image_from_stream(). */
FZ_FUNCTION Pixmap Stream::decomp_image_from_stream(const CompressedImage& image, Irect& subarea, int indexed, int l2factor, int *l2extra)
{
	fz_pixmap* temp = mupdf::decomp_image_from_stream(this->m_internal, image.m_internal, (fz_irect *) &subarea.x0, indexed, l2factor, l2extra);
	return Pixmap(temp);
}

/* Wrapper for fz_is_eof(). */
FZ_FUNCTION int Stream::is_eof()
{
	return mupdf::is_eof(this->m_internal);
}

/* Wrapper for fz_is_eof_bits(). */
FZ_FUNCTION int Stream::is_eof_bits()
{
	return mupdf::is_eof_bits(this->m_internal);
}

/* Wrapper for fz_is_tar_archive(). */
FZ_FUNCTION int Stream::is_tar_archive()
{
	return mupdf::is_tar_archive(this->m_internal);
}

/* Wrapper for fz_is_zip_archive(). */
FZ_FUNCTION int Stream::is_zip_archive()
{
	return mupdf::is_zip_archive(this->m_internal);
}

/* Wrapper for fz_new_archive_of_size(). */
FZ_FUNCTION Archive Stream::new_archive_of_size(int size)
{
	fz_archive* temp = mupdf::new_archive_of_size(this->m_internal, size);
	return Archive(temp);
}

/* Wrapper for fz_open_a85d(). */
FZ_FUNCTION Stream Stream::open_a85d()
{
	fz_stream* temp = mupdf::open_a85d(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_aesd(). */
FZ_FUNCTION Stream Stream::open_aesd(unsigned char *key, unsigned int keylen)
{
	fz_stream* temp = mupdf::open_aesd(this->m_internal, key, keylen);
	return Stream(temp);
}

/* Wrapper for fz_open_ahxd(). */
FZ_FUNCTION Stream Stream::open_ahxd()
{
	fz_stream* temp = mupdf::open_ahxd(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_arc4(). */
FZ_FUNCTION Stream Stream::open_arc4(unsigned char *key, unsigned int keylen)
{
	fz_stream* temp = mupdf::open_arc4(this->m_internal, key, keylen);
	return Stream(temp);
}

/* Wrapper for fz_open_archive_with_stream(). */
FZ_FUNCTION Archive Stream::open_archive_with_stream()
{
	fz_archive* temp = mupdf::open_archive_with_stream(this->m_internal);
	return Archive(temp);
}

/* Wrapper for fz_open_dctd(). */
FZ_FUNCTION Stream Stream::open_dctd(int color_transform, int l2factor, const Stream& jpegtables)
{
	fz_stream* temp = mupdf::open_dctd(this->m_internal, color_transform, l2factor, jpegtables.m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_endstream_filter(). */
FZ_FUNCTION Stream Stream::open_endstream_filter(int len, int64_t offset)
{
	fz_stream* temp = mupdf::open_endstream_filter(this->m_internal, len, offset);
	return Stream(temp);
}

/* Wrapper for fz_open_faxd(). */
FZ_FUNCTION Stream Stream::open_faxd(int k, int end_of_line, int encoded_byte_align, int columns, int rows, int end_of_block, int black_is_1)
{
	fz_stream* temp = mupdf::open_faxd(this->m_internal, k, end_of_line, encoded_byte_align, columns, rows, end_of_block, black_is_1);
	return Stream(temp);
}

/* Wrapper for fz_open_flated(). */
FZ_FUNCTION Stream Stream::open_flated(int window_bits)
{
	fz_stream* temp = mupdf::open_flated(this->m_internal, window_bits);
	return Stream(temp);
}

/* Wrapper for fz_open_image_decomp_stream(). */
FZ_FUNCTION Stream Stream::open_image_decomp_stream(const CompressionParams& arg_1, int *l2factor)
{
	fz_stream* temp = mupdf::open_image_decomp_stream(this->m_internal, arg_1.m_internal, l2factor);
	return Stream(temp);
}

/* Wrapper for fz_open_jbig2d(). */
FZ_FUNCTION Stream Stream::open_jbig2d(const Jbig2Globals& globals, int embedded)
{
	fz_stream* temp = mupdf::open_jbig2d(this->m_internal, globals.m_internal, embedded);
	return Stream(temp);
}

/* Wrapper for fz_open_leecher(). */
FZ_FUNCTION Stream Stream::open_leecher(const Buffer& buf)
{
	fz_stream* temp = mupdf::open_leecher(this->m_internal, buf.m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_lzwd(). */
FZ_FUNCTION Stream Stream::open_lzwd(int early_change, int min_bits, int reverse_bits, int old_tiff)
{
	fz_stream* temp = mupdf::open_lzwd(this->m_internal, early_change, min_bits, reverse_bits, old_tiff);
	return Stream(temp);
}

/* Wrapper for fz_open_null_filter(). */
FZ_FUNCTION Stream Stream::open_null_filter(int len, int64_t offset)
{
	fz_stream* temp = mupdf::open_null_filter(this->m_internal, len, offset);
	return Stream(temp);
}

/* Wrapper for fz_open_predict(). */
FZ_FUNCTION Stream Stream::open_predict(int predictor, int columns, int colors, int bpc)
{
	fz_stream* temp = mupdf::open_predict(this->m_internal, predictor, columns, colors, bpc);
	return Stream(temp);
}

/* Wrapper for fz_open_range_filter(). */
FZ_FUNCTION Stream Stream::open_range_filter(const Range& ranges, int nranges)
{
	fz_stream* temp = mupdf::open_range_filter(this->m_internal, ranges.m_internal, nranges);
	return Stream(temp);
}

/* Wrapper for fz_open_rld(). */
FZ_FUNCTION Stream Stream::open_rld()
{
	fz_stream* temp = mupdf::open_rld(this->m_internal);
	return Stream(temp);
}

/* Wrapper for fz_open_sgilog16(). */
FZ_FUNCTION Stream Stream::open_sgilog16(int w)
{
	fz_stream* temp = mupdf::open_sgilog16(this->m_internal, w);
	return Stream(temp);
}

/* Wrapper for fz_open_sgilog24(). */
FZ_FUNCTION Stream Stream::open_sgilog24(int w)
{
	fz_stream* temp = mupdf::open_sgilog24(this->m_internal, w);
	return Stream(temp);
}

/* Wrapper for fz_open_sgilog32(). */
FZ_FUNCTION Stream Stream::open_sgilog32(int w)
{
	fz_stream* temp = mupdf::open_sgilog32(this->m_internal, w);
	return Stream(temp);
}

/* Wrapper for fz_open_tar_archive_with_stream(). */
FZ_FUNCTION Archive Stream::open_tar_archive_with_stream()
{
	fz_archive* temp = mupdf::open_tar_archive_with_stream(this->m_internal);
	return Archive(temp);
}

/* Wrapper for fz_open_thunder(). */
FZ_FUNCTION Stream Stream::open_thunder(int w)
{
	fz_stream* temp = mupdf::open_thunder(this->m_internal, w);
	return Stream(temp);
}

/* Wrapper for fz_open_zip_archive_with_stream(). */
FZ_FUNCTION Archive Stream::open_zip_archive_with_stream()
{
	fz_archive* temp = mupdf::open_zip_archive_with_stream(this->m_internal);
	return Archive(temp);
}

/* Wrapper for fz_peek_byte(). */
FZ_FUNCTION int Stream::peek_byte()
{
	return mupdf::peek_byte(this->m_internal);
}

/* Wrapper for fz_read(). */
FZ_FUNCTION size_t Stream::read(unsigned char *data, size_t len)
{
	return mupdf::read(this->m_internal, data, len);
}

/* Wrapper for fz_read_all(). */
FZ_FUNCTION Buffer Stream::read_all(size_t initial)
{
	fz_buffer* temp = mupdf::read_all(this->m_internal, initial);
	return Buffer(temp);
}

/* Wrapper for fz_read_best(). */
FZ_FUNCTION Buffer Stream::read_best(size_t initial, int *truncated)
{
	fz_buffer* temp = mupdf::read_best(this->m_internal, initial, truncated);
	return Buffer(temp);
}

/* Wrapper for fz_read_bits(). */
FZ_FUNCTION unsigned int Stream::read_bits(int n)
{
	return mupdf::read_bits(this->m_internal, n);
}

/* Wrapper for fz_read_byte(). */
FZ_FUNCTION int Stream::read_byte()
{
	return mupdf::read_byte(this->m_internal);
}

/* Wrapper for fz_read_float(). */
FZ_FUNCTION float Stream::read_float()
{
	return mupdf::read_float(this->m_internal);
}

/* Wrapper for fz_read_float_le(). */
FZ_FUNCTION float Stream::read_float_le()
{
	return mupdf::read_float_le(this->m_internal);
}

/* Wrapper for fz_read_int16(). */
FZ_FUNCTION int16_t Stream::read_int16()
{
	return mupdf::read_int16(this->m_internal);
}

/* Wrapper for fz_read_int16_le(). */
FZ_FUNCTION int16_t Stream::read_int16_le()
{
	return mupdf::read_int16_le(this->m_internal);
}

/* Wrapper for fz_read_int32(). */
FZ_FUNCTION int32_t Stream::read_int32()
{
	return mupdf::read_int32(this->m_internal);
}

/* Wrapper for fz_read_int32_le(). */
FZ_FUNCTION int32_t Stream::read_int32_le()
{
	return mupdf::read_int32_le(this->m_internal);
}

/* Wrapper for fz_read_int64(). */
FZ_FUNCTION int64_t Stream::read_int64()
{
	return mupdf::read_int64(this->m_internal);
}

/* Wrapper for fz_read_int64_le(). */
FZ_FUNCTION int64_t Stream::read_int64_le()
{
	return mupdf::read_int64_le(this->m_internal);
}

/* Wrapper for fz_read_line(). */
FZ_FUNCTION char *Stream::read_line(char *buf, size_t max)
{
	return mupdf::read_line(this->m_internal, buf, max);
}

/* Wrapper for fz_read_rbits(). */
FZ_FUNCTION unsigned int Stream::read_rbits(int n)
{
	return mupdf::read_rbits(this->m_internal, n);
}

/* Wrapper for fz_read_string(). */
FZ_FUNCTION void Stream::read_string(char *buffer, int len)
{
	return mupdf::read_string(this->m_internal, buffer, len);
}

/* Wrapper for fz_read_uint16(). */
FZ_FUNCTION uint16_t Stream::read_uint16()
{
	return mupdf::read_uint16(this->m_internal);
}

/* Wrapper for fz_read_uint16_le(). */
FZ_FUNCTION uint16_t Stream::read_uint16_le()
{
	return mupdf::read_uint16_le(this->m_internal);
}

/* Wrapper for fz_read_uint24(). */
FZ_FUNCTION uint32_t Stream::read_uint24()
{
	return mupdf::read_uint24(this->m_internal);
}

/* Wrapper for fz_read_uint24_le(). */
FZ_FUNCTION uint32_t Stream::read_uint24_le()
{
	return mupdf::read_uint24_le(this->m_internal);
}

/* Wrapper for fz_read_uint32(). */
FZ_FUNCTION uint32_t Stream::read_uint32()
{
	return mupdf::read_uint32(this->m_internal);
}

/* Wrapper for fz_read_uint32_le(). */
FZ_FUNCTION uint32_t Stream::read_uint32_le()
{
	return mupdf::read_uint32_le(this->m_internal);
}

/* Wrapper for fz_read_uint64(). */
FZ_FUNCTION uint64_t Stream::read_uint64()
{
	return mupdf::read_uint64(this->m_internal);
}

/* Wrapper for fz_read_uint64_le(). */
FZ_FUNCTION uint64_t Stream::read_uint64_le()
{
	return mupdf::read_uint64_le(this->m_internal);
}

/* Wrapper for fz_seek(). */
FZ_FUNCTION void Stream::seek(int64_t offset, int whence)
{
	return mupdf::seek(this->m_internal, offset, whence);
}

/* Wrapper for fz_skip(). */
FZ_FUNCTION size_t Stream::skip(size_t len)
{
	return mupdf::skip(this->m_internal, len);
}

/* Wrapper for fz_skip_space(). */
FZ_FUNCTION void Stream::skip_space()
{
	return mupdf::skip_space(this->m_internal);
}

/* Wrapper for fz_skip_string(). */
FZ_FUNCTION int Stream::skip_string(const char *str)
{
	return mupdf::skip_string(this->m_internal, str);
}

/* Wrapper for fz_sync_bits(). */
FZ_FUNCTION void Stream::sync_bits()
{
	return mupdf::sync_bits(this->m_internal);
}

/* Wrapper for fz_tell(). */
FZ_FUNCTION int64_t Stream::tell()
{
	return mupdf::tell(this->m_internal);
}

/* Wrapper for fz_unpack_stream(). */
FZ_FUNCTION Stream Stream::unpack_stream(int depth, int w, int h, int n, int indexed, int pad, int skip)
{
	fz_stream* temp = mupdf::unpack_stream(this->m_internal, depth, w, h, n, indexed, pad, skip);
	return Stream(temp);
}

/* Wrapper for fz_unread_byte(). */
FZ_FUNCTION void Stream::unread_byte()
{
	return mupdf::unread_byte(this->m_internal);
}

/* Wrapper for pdf_lex(). */
FZ_FUNCTION pdf_token Stream::pdf_lex(const PdfLexbuf& lexbuf)
{
	return mupdf::ppdf_lex(this->m_internal, lexbuf.m_internal);
}

/* Wrapper for pdf_lex_no_string(). */
FZ_FUNCTION pdf_token Stream::pdf_lex_no_string(const PdfLexbuf& lexbuf)
{
	return mupdf::ppdf_lex_no_string(this->m_internal, lexbuf.m_internal);
}

/* Wrapper for pdf_load_cmap(). */
FZ_FUNCTION PdfCmap Stream::pdf_load_cmap()
{
	pdf_cmap* temp = mupdf::ppdf_load_cmap(this->m_internal);
	return PdfCmap(temp);
}

/* Wrapper for pdf_open_crypt(). */
FZ_FUNCTION Stream Stream::pdf_open_crypt(const PdfCrypt& crypt, int num, int gen)
{
	fz_stream* temp = mupdf::ppdf_open_crypt(this->m_internal, crypt.m_internal, num, gen);
	return Stream(temp);
}

/* Wrapper for pdf_open_crypt_with_filter(). */
FZ_FUNCTION Stream Stream::pdf_open_crypt_with_filter(const PdfCrypt& crypt, const PdfObj& name, int num, int gen)
{
	fz_stream* temp = mupdf::ppdf_open_crypt_with_filter(this->m_internal, crypt.m_internal, name.m_internal, num, gen);
	return Stream(temp);
}

/* Wrapper for pdf_open_document_with_stream(). */
FZ_FUNCTION PdfDocument Stream::pdf_open_document_with_stream()
{
	pdf_document* temp = mupdf::ppdf_open_document_with_stream(this->m_internal);
	return PdfDocument(temp);
}

FZ_FUNCTION Stream::Stream(fz_stream* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Stream::~Stream()
{
	mupdf::drop_stream(m_internal);
}


/* Implementation of methods for StrokeState (wrapper for fz_stroke_state). */

/* Constructor using fz_new_stroke_state(). */
FZ_FUNCTION StrokeState::StrokeState()
{
	this->m_internal = mupdf::new_stroke_state();
}

/* Constructor using fz_new_stroke_state_with_dash_len(). */
FZ_FUNCTION StrokeState::StrokeState(int len)
{
	this->m_internal = mupdf::new_stroke_state_with_dash_len(len);
}

/* Copy constructor using fz_keep_stroke_state(). */
FZ_FUNCTION StrokeState::StrokeState(const StrokeState& rhs)
: m_internal(mupdf::keep_stroke_state(rhs.m_internal))
{
}

/* operator= using fz_keep_stroke_state() and fz_drop_stroke_state(). */
FZ_FUNCTION StrokeState& StrokeState::operator=(const StrokeState& rhs)
{
	mupdf::drop_stroke_state(this->m_internal);
	mupdf::keep_stroke_state(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_clone_stroke_state(). */
FZ_FUNCTION StrokeState StrokeState::clone_stroke_state()
{
	fz_stroke_state* temp = mupdf::clone_stroke_state(this->m_internal);
	return StrokeState(temp);
}

/* Wrapper for fz_unshare_stroke_state(). */
FZ_FUNCTION StrokeState StrokeState::unshare_stroke_state()
{
	fz_stroke_state* temp = mupdf::unshare_stroke_state(this->m_internal);
	return StrokeState(temp);
}

/* Wrapper for fz_unshare_stroke_state_with_dash_len(). */
FZ_FUNCTION StrokeState StrokeState::unshare_stroke_state_with_dash_len(int len)
{
	fz_stroke_state* temp = mupdf::unshare_stroke_state_with_dash_len(this->m_internal, len);
	return StrokeState(temp);
}

FZ_FUNCTION StrokeState::StrokeState(fz_stroke_state* internal)
: m_internal(internal)
{
}

FZ_FUNCTION StrokeState::~StrokeState()
{
	mupdf::drop_stroke_state(m_internal);
}


/* Implementation of methods for StyleContext (wrapper for fz_style_context). */

FZ_FUNCTION StyleContext::StyleContext(fz_style_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Text (wrapper for fz_text). */

/* Constructor using fz_new_text(). */
FZ_FUNCTION Text::Text()
{
	this->m_internal = mupdf::new_text();
}

/* Copy constructor using fz_keep_text(). */
FZ_FUNCTION Text::Text(const Text& rhs)
: m_internal(mupdf::keep_text(rhs.m_internal))
{
}

/* operator= using fz_keep_text() and fz_drop_text(). */
FZ_FUNCTION Text& Text::operator=(const Text& rhs)
{
	mupdf::drop_text(this->m_internal);
	mupdf::keep_text(rhs.m_internal);
	this->m_internal = rhs.m_internal;
	return *this;
}

/* Wrapper for fz_bound_text(). */
FZ_FUNCTION Rect Text::bound_text(const StrokeState& stroke, Matrix& ctm)
{
	fz_rect temp = mupdf::bound_text(this->m_internal, stroke.m_internal, *(fz_matrix*) &ctm.a);
	return Rect(&temp);
}

/* Wrapper for fz_show_glyph(). */
FZ_FUNCTION void Text::show_glyph(const Font& font, Matrix& trm, int glyph, int unicode, int wmode, int bidi_level, fz_bidi_direction markup_dir, fz_text_language language)
{
	return mupdf::show_glyph(this->m_internal, font.m_internal, *(fz_matrix*) &trm.a, glyph, unicode, wmode, bidi_level, markup_dir, language);
}

/* Wrapper for fz_show_string(). */
FZ_FUNCTION Matrix Text::show_string(const Font& font, Matrix& trm, const char *s, int wmode, int bidi_level, fz_bidi_direction markup_dir, fz_text_language language)
{
	fz_matrix temp = mupdf::show_string(this->m_internal, font.m_internal, *(fz_matrix*) &trm.a, s, wmode, bidi_level, markup_dir, language);
	return Matrix(&temp);
}

FZ_FUNCTION Text::Text(fz_text* internal)
: m_internal(internal)
{
}

FZ_FUNCTION Text::~Text()
{
	mupdf::drop_text(m_internal);
}


/* Implementation of methods for TextItem (wrapper for fz_text_item). */

FZ_FUNCTION TextItem::TextItem(fz_text_item* internal)
: m_internal(internal)
{
}


/* Implementation of methods for TextSpan (wrapper for fz_text_span). */

FZ_FUNCTION TextSpan::TextSpan(fz_text_span* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Transition (wrapper for fz_transition). */

FZ_FUNCTION Transition::Transition(const fz_transition* internal)
{
	this->type = internal->type;
	this->duration = internal->duration;
	this->vertical = internal->vertical;
	this->outwards = internal->outwards;
	this->direction = internal->direction;
	this->state0 = internal->state0;
	this->state1 = internal->state1;
}

FZ_FUNCTION Transition::Transition(const fz_transition internal)
{
	this->type = internal.type;
	this->duration = internal.duration;
	this->vertical = internal.vertical;
	this->outwards = internal.outwards;
	this->direction = internal.direction;
	this->state0 = internal.state0;
	this->state1 = internal.state1;
}

/* Constructor using raw copy of pre-existing fz_transition. */
FZ_FUNCTION fz_transition* Transition::internal()
{
	return (fz_transition*) &this->type;
}

/* Constructor using raw copy of pre-existing fz_transition. */
FZ_FUNCTION const fz_transition* Transition::internal() const
{
	return (const fz_transition*) &this->type;
}

FZ_FUNCTION std::string Transition::to_string()
{
	std::ostringstream buffer;
	buffer << *this;
	return buffer.str();
}


FZ_FUNCTION std::ostream& operator<< (std::ostream& out, const Transition& rhs)
{
	return out << *rhs.internal();
}

/* Implementation of methods for Tree (wrapper for fz_tree). */

/* Wrapper for fz_tree_insert(). */
FZ_FUNCTION Tree Tree::tree_insert(const char *key, void *value)
{
	fz_tree* temp = mupdf::tree_insert(this->m_internal, key, value);
	return Tree(temp);
}

/* Wrapper for fz_tree_lookup(). */
FZ_FUNCTION void *Tree::tree_lookup(const char *key)
{
	return mupdf::tree_lookup(this->m_internal, key);
}

FZ_FUNCTION Tree::Tree(fz_tree* internal)
: m_internal(internal)
{
}


/* Implementation of methods for TuningContext (wrapper for fz_tuning_context). */

FZ_FUNCTION TuningContext::TuningContext(fz_tuning_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Vertex (wrapper for fz_vertex). */

FZ_FUNCTION Vertex::Vertex(fz_vertex* internal)
: m_internal(internal)
{
}


/* Implementation of methods for WarnContext (wrapper for fz_warn_context). */

FZ_FUNCTION WarnContext::WarnContext(fz_warn_context* internal)
: m_internal(internal)
{
}


/* Implementation of methods for Xml (wrapper for fz_xml). */

/* Wrapper for fz_debug_xml(). */
FZ_FUNCTION void Xml::debug_xml(int level)
{
	return mupdf::debug_xml(this->m_internal, level);
}

/* Wrapper for fz_xml_att(). */
FZ_FUNCTION char *Xml::xml_att(const char *att)
{
	return mupdf::xml_att(this->m_internal, att);
}

/* Wrapper for fz_xml_att_alt(). */
FZ_FUNCTION char *Xml::xml_att_alt(const char *one, const char *two)
{
	return mupdf::xml_att_alt(this->m_internal, one, two);
}

/* Wrapper for fz_xml_att_eq(). */
FZ_FUNCTION int Xml::xml_att_eq(const char *name, const char *match)
{
	return mupdf::xml_att_eq(this->m_internal, name, match);
}

/* Wrapper for fz_xml_down(). */
FZ_FUNCTION Xml Xml::xml_down()
{
	fz_xml* temp = mupdf::xml_down(this->m_internal);
	return Xml(temp);
}

/* Wrapper for fz_xml_find(). */
FZ_FUNCTION Xml Xml::xml_find(const char *tag)
{
	fz_xml* temp = mupdf::xml_find(this->m_internal, tag);
	return Xml(temp);
}

/* Wrapper for fz_xml_find_down(). */
FZ_FUNCTION Xml Xml::xml_find_down(const char *tag)
{
	fz_xml* temp = mupdf::xml_find_down(this->m_internal, tag);
	return Xml(temp);
}

/* Wrapper for fz_xml_find_down_match(). */
FZ_FUNCTION Xml Xml::xml_find_down_match(const char *tag, const char *att, const char *match)
{
	fz_xml* temp = mupdf::xml_find_down_match(this->m_internal, tag, att, match);
	return Xml(temp);
}

/* Wrapper for fz_xml_find_match(). */
FZ_FUNCTION Xml Xml::xml_find_match(const char *tag, const char *att, const char *match)
{
	fz_xml* temp = mupdf::xml_find_match(this->m_internal, tag, att, match);
	return Xml(temp);
}

/* Wrapper for fz_xml_find_next(). */
FZ_FUNCTION Xml Xml::xml_find_next(const char *tag)
{
	fz_xml* temp = mupdf::xml_find_next(this->m_internal, tag);
	return Xml(temp);
}

/* Wrapper for fz_xml_find_next_match(). */
FZ_FUNCTION Xml Xml::xml_find_next_match(const char *tag, const char *att, const char *match)
{
	fz_xml* temp = mupdf::xml_find_next_match(this->m_internal, tag, att, match);
	return Xml(temp);
}

/* Wrapper for fz_xml_is_tag(). */
FZ_FUNCTION int Xml::xml_is_tag(const char *name)
{
	return mupdf::xml_is_tag(this->m_internal, name);
}

/* Wrapper for fz_xml_next(). */
FZ_FUNCTION Xml Xml::xml_next()
{
	fz_xml* temp = mupdf::xml_next(this->m_internal);
	return Xml(temp);
}

/* Wrapper for fz_xml_prev(). */
FZ_FUNCTION Xml Xml::xml_prev()
{
	fz_xml* temp = mupdf::xml_prev(this->m_internal);
	return Xml(temp);
}

/* Wrapper for fz_xml_tag(). */
FZ_FUNCTION char *Xml::xml_tag()
{
	return mupdf::xml_tag(this->m_internal);
}

/* Wrapper for fz_xml_text(). */
FZ_FUNCTION char *Xml::xml_text()
{
	return mupdf::xml_text(this->m_internal);
}

/* Wrapper for fz_xml_up(). */
FZ_FUNCTION Xml Xml::xml_up()
{
	fz_xml* temp = mupdf::xml_up(this->m_internal);
	return Xml(temp);
}

FZ_FUNCTION Xml::Xml(fz_xml* internal)
: m_internal(internal)
{
}


/* Implementation of methods for XmlDoc (wrapper for fz_xml_doc). */

/* Wrapper for fz_detach_xml(). */
FZ_FUNCTION void XmlDoc::detach_xml(const Xml& node)
{
	return mupdf::detach_xml(this->m_internal, node.m_internal);
}

/* Wrapper for fz_new_display_list_from_svg_xml(). */
FZ_FUNCTION DisplayList XmlDoc::new_display_list_from_svg_xml(const Xml& xml, const char *base_uri, const Archive& zip, float *w, float *h)
{
	fz_display_list* temp = mupdf::new_display_list_from_svg_xml(this->m_internal, xml.m_internal, base_uri, zip.m_internal, w, h);
	return DisplayList(temp);
}

/* Wrapper for fz_new_image_from_svg_xml(). */
FZ_FUNCTION Image XmlDoc::new_image_from_svg_xml(const Xml& xml, const char *base_uri, const Archive& zip)
{
	fz_image* temp = mupdf::new_image_from_svg_xml(this->m_internal, xml.m_internal, base_uri, zip.m_internal);
	return Image(temp);
}

/* Wrapper for fz_xml_root(). */
FZ_FUNCTION Xml XmlDoc::xml_root()
{
	fz_xml* temp = mupdf::xml_root(this->m_internal);
	return Xml(temp);
}

FZ_FUNCTION XmlDoc::XmlDoc(fz_xml_doc* internal)
: m_internal(internal)
{
}


/* Implementation of methods for ZipWriter (wrapper for fz_zip_writer). */

/* Constructor using fz_new_zip_writer(). */
FZ_FUNCTION ZipWriter::ZipWriter(const char *filename)
{
	this->m_internal = mupdf::new_zip_writer(filename);
}

/* Constructor using fz_new_zip_writer_with_output(). */
FZ_FUNCTION ZipWriter::ZipWriter(const Output& out)
{
	this->m_internal = mupdf::new_zip_writer_with_output(out.m_internal);
}

/* Wrapper for fz_close_zip_writer(). */
FZ_FUNCTION void ZipWriter::close_zip_writer()
{
	return mupdf::close_zip_writer(this->m_internal);
}

/* Wrapper for fz_write_zip_entry(). */
FZ_FUNCTION void ZipWriter::write_zip_entry(const char *name, const Buffer& buf, int compress)
{
	return mupdf::write_zip_entry(this->m_internal, name, buf.m_internal, compress);
}

FZ_FUNCTION ZipWriter::ZipWriter(fz_zip_writer* internal)
: m_internal(internal)
{
}

FZ_FUNCTION ZipWriter::~ZipWriter()
{
	mupdf::drop_zip_writer(m_internal);
}


} /* End of namespace mupdf. */
